#include "stdafx.h"

#include "UI.h"

#include <stdio.h>

#include "Objects.h"
#include "Dispatch.h"
#include "CSB.h"
#include "Data.h"

extern bool RepeatGame;
extern bool GameIsComplete;

//*********************************************************
//
//*********************************************************
//  TAG01dc4e
i16 Darken(i16 color)
{
  if (color & 0x007) color -= 0x001;
  if (color & 0x070) color -= 0x010;
  if (color & 0x700) color -= 0x100;
  return color;
}

//*********************************************************
//
//*********************************************************
//   TAG01f990
void DisplayHeroName(i16 P1,i16 P2,i16 P3,pnt heroName)
{
  aReg A2, A3;
  i8 b_50[50];
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//01f990 4e56 ffce                LINK     A6,#-50
//01f994 48e7 0030                MOVEM.L  A23,-(A7)
  ASSERT(1);
//01f998 266e 000e                MOVE.L   14(A6),A3
  A3 = heroName;
//01f99c 41ee ffce                LEA      -50(A6),A0
//01f9a0 2448                     MOVE.L   A0,A2
  A2 = b_50;
//01f9a2 601a                     BRA      $+28 (=0x01f9be)
  while ( ((*A2)=*(A3++)) != 0)
  {
//01f9a4 1012                     MOVE.B   (A2),D0
//01f9a6 4880                     EXT.W    D0
//01f9a8 b07c 0041                CMP.W    #65,D0
//01f9ac 6d0e                     BLT      $+16 (=0x01f9bc)
//
//01f9ae 1012                     MOVE.B   (A2),D0
//01f9b0 4880                     EXT.W    D0
//01f9b2 b07c 005a                CMP.W    #90,D0
//01f9b6 6e04                     BGT      $+6 (=0x01f9bc)
    if ( (*A2 >= 'A') && (*A2 <= 'Z'))
    {
//01f9b8 0412 0040                SUB.B    #64,(A2)
      *A2 -= 0x40;
    };
//01f9bc 528a                     ADDQ.L   #1,A2
    A2++;
//
//01f9be 149b                     MOVE.B   (A3)+,(A2)
//01f9c0 66e2                     BNE      $-28 (=0x01f9a4)
  };
//01f9c2 486e ffce                PEA      -50(A6)
//01f9c6 3f3c 000c                MOVE.W   #12,-(A7)
//01f9ca 3f2e 000c                MOVE.W   12(A6),-(A7)
//01f9ce 3f2e 000a                MOVE.W   10(A6),-(A7)
//01f9d2 3f2e 0008                MOVE.W   8(A6),-(A7)
//01f9d6 4ead 0108                JSR      264(A5)    (=0x001c42=TextOutToScreen)
//01f9da defc 000c                ADD.W    #12,A7
  TextOutToScreen(P1, P2, P3, 12, b_50);
//01f9de 4cdf 0c00                MOVEM.L  (A7)+,A23
//01f9e2 4e5e                     UNLK     A6
//01f9e4 4e75                     RTS
}

extern ui32 VBLCount;

//*********************************************************
//
//*********************************************************
RESTARTABLE _TAG01f9e6(const i32 P1) //(void)
{ // The game is lost!  Or won!!!
  static dReg D0, D4, D5, D6, D7;
  static aReg A0, A2, A3;
  static CHARDESC *pcA0;
  static i16 LOCAL_142;
  static i16 LOCAL_132;
  static i8  LOCAL_130[130-110];
  static PALETTE LOCAL_110;
  static PALETTE LOCAL_78; //32bytes
  static PALETTE LOCAL_46;
  static pnt LOCAL_14;
  static pnt LOCAL_10;
  static CHARDESC *LOCAL_6;
  static i8  LOCAL_1;
  static i32 before, after;
  static i32 i;

  RESTARTMAP
    RESTART(1)
    RESTART(2)
    RESTART(3)
    RESTART(4)
    RESTART(5)
    RESTART(6)
    RESTART(7)
    RESTART(8)
    RESTART(9)
    RESTART(10)
    RESTART(11)
    RESTART(12)
    RESTART(13)
    RESTART(14)
    RESTART(15)
    RESTART(16)
    RESTART(17)
    RESTART(18)
    RESTART(19)
    RESTART(20)
    RESTART(21)
    RESTART(22)
    RESTART(23)
    RESTART(24)
  END_RESTARTMAP
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//01f9e6 4e56 ff72                LINK     A6,#-142
//01f9ea 48e7 0f30                MOVEM.L  D4567A23,-(A7)
//01f9ee 3d7c 0001 ff7c           MOVE.W   #1,-132(A6)
  LOCAL_132 = 1;
  LOCAL_14 = NULL;
  A2 = NULL;
//01f9f4 4267                     CLR.W    -(A7)
//01f9f6 4ead 0144                JSR      324(A5)    (=0x002456)
//01f9fa 548f                     ADDQ.L   #2,A7
  SetCursorShape(0);
//01f9fc 4ead 0024                JSR      36(A5)    (=0x002fd2)
  STHideCursor();
//01fa00 42ac be18                CLR.L    -16872(A4)
//01fa04 42ac be14                CLR.L    -16876(A4)
//01fa08 42ac be10                CLR.L    -16880(A4)
//01fa0c 42ac be0c                CLR.L    -16884(A4)
  d.PrimaryButtonList = NULL;
  d.SecondaryButtonList = NULL;
  d.pKeyXlate1 = NULL;
  d.pKeyXlate2 = NULL;
//01fa10 302e 0008                MOVE.W   8(A6),D0
//01fa14 6724                     BEQ      $+38 (=0x01fa3a)
  if (P1)
  {
//01fa16 302c d252                MOVE.W   -11694(A4),D0
//01fa1a 661e                     BNE      $+32 (=0x01fa3a)
    if (d.Word11694 == 0)
    {
//01fa1c 4267                     CLR.W    -(A7)
//01fa1e 3f2c d248                MOVE.W   -11704(A4),-(A7)
//01fa22 3f2c d24a                MOVE.W   -11702(A4),-(A7)
//01fa26 3f3c 0006                MOVE.W   #6,-(A7)
//01fa2a 4ead 0120                JSR      288(A5)    (=0x00219a)
//01fa2e 508f                     ADDQ.L   #0,A7
      QueueSound(6, d.partyX, d.partyY, 0);//Dying sound
//01fa30 3f3c 00f0                MOVE.W   #240,-(A7)
//01fa34 4ead 019e                JSR      414(A5)    (=0x000fb2)
//01fa38 548f                     ADDQ.L   #2,A7
      VBLDelay(_1_,240); // About 4 seconds
    };
  };
//01fa3a 4267                     CLR.W    -(A7)
//01fa3c 4267                     CLR.W    -(A7)
//01fa3e 4eba e068                JSR      $-8086 (=0x01daa8)
//01fa42 588f                     ADDQ.L   #4,A7
  TAG01daa8(_17_, 0, 0);
//01fa44 4ead 05fa                JSR      1530(A5)    (=0x021d36)
  openGraphicsFile();
//01fa48 266c f7ca                MOVE.L   -2102(A4),A3
  A3 = d.Pointer2102;
//01fa4c 302e 0008                MOVE.W   8(A6),D0
//01fa50 673e                     BEQ      $+64 (=0x01fa90)
  if (P1)
  {
//01fa52 244b                     MOVE.L   A3,A2
    A2 = A3;
//01fa54 d7fc 0000 0230           ADD.L    #560,A3
    A3 += 560;
//01fa5a 4267                     CLR.W    -(A7)
//01fa5c 4267                     CLR.W    -(A7)
//01fa5e 2f0a                     MOVE.L   A2,-(A7)
//01fa60 3f3c 0006                MOVE.W   #6,-(A7)
//01fa64 4ead 0606                JSR      1542(A5)    (=0x022b86)
//01fa68 defc 000a                ADD.W    #10,A7
    ReadAndExpandGraphic(6, A2, 0, 0);
//01fa6c 302c d252                MOVE.W   -11694(A4),D0
//01fa70 671e                     BEQ      $+32 (=0x01fa90)
    if (d.Word11694)
    {
//01fa72 2d4b fff2                MOVE.L   A3,-14(A6)
      LOCAL_14 = A3;
//01fa76 d7fc 0000 0560           ADD.L    #1376,A3
      A3 += 1376;
//01fa7c 4267                     CLR.W    -(A7)
//01fa7e 4267                     CLR.W    -(A7)
//01fa80 2f2e fff2                MOVE.L   -14(A6),-(A7)
//01fa84 3f3c 00d0                MOVE.W   #208,-(A7)
//01fa88 4ead 0606                JSR      1542(A5)    (=0x022b86)
//01fa8c defc 000a                ADD.W    #10,A7
      ReadAndExpandGraphic(208, LOCAL_14, 0, 0);
    };
  };
//01fa90 4267                     CLR.W    -(A7)
//01fa92 4267                     CLR.W    -(A7)
//01fa94 200b                     MOVE.L   A3,D0
//01fa96 2d40 fff6                MOVE.L   D0,-10(A6)
//01fa9a 2f00                     MOVE.L   D0,-(A7)
//01fa9c 3f3c 8005                MOVE.W   #32773,-(A7)
//01faa0 4ead 0606                JSR      1542(A5)    (=0x022b86)
//01faa4 defc 000a                ADD.W    #10,A7
  ReadAndExpandGraphic(0x8005, A3, 0, 0);
  LOCAL_10 = A3;
//01faa8 4ead 0600                JSR      1536(A5)    (=0x021d76)
  closeGraphicsFile();
//01faac 302c d226                MOVE.W   -11738(A4),D0
//01fab0 6700 0098                BEQ      $+154 (=0x01fb4a)
  if (d.DynamicPaletteSwitching)
  {
//01fab4 3f3c 0020                MOVE.W   #32,-(A7)
//01fab8 486e ffb2                PEA      -78(A6)
//01fabc 486c d136                PEA      -11978(A4)
//01fac0 4ead 0006                JSR      6(A5)    (=0x0009dc)
//01fac4 defc 000a                ADD.W    #10,A7
    MemMove((pnt)&d.Palette11978, (pnt)&LOCAL_78, 32);
//01fac8 4246                     CLR.W    D6
//01faca 6054                     BRA      $+86 (=0x01fb20)
    for (D6W=0; D6W<=7; D6W++)
    {
//01facc 3f3c 0025                MOVE.W   #37,-(A7)
//01fad0 4ead 0138                JSR      312(A5)    (=0x001ce8)
//01fad4 548f                     ADDQ.L   #2,A7
      wvbl(_2_);
//01fad6 4247                     CLR.W    D7
//01fad8 603e                     BRA      $+64 (=0x01fb18)
     for (D7W=0; D7W<16; D7W++)
     {
//01fada 3007                     MOVE.W   D7,D0
//01fadc e380                     ASL.L    #1,D0
//01fade 41ec d156                LEA      -11946(A4),A0
//01fae2 d0c0                     ADD.W    D0,A0
//01fae4 3f10                     MOVE.W   (A0),-(A7)
//01fae6 4eba e166                JSR      $-7832 (=0x01dc4e)
//01faea 548f                     ADDQ.L   #2,A7
        D0W = Darken(d.Palette11946.color[D7W]);
//01faec 3207                     MOVE.W   D7,D1
//01faee e381                     ASL.L    #1,D1
//01faf0 41ec d156                LEA      -11946(A4),A0
//01faf4 d0c1                     ADD.W    D1,A0
//01faf6 3080                     MOVE.W   D0,(A0)
        d.Palette11946.color[D7W] = D0W;
//01faf8 3007                     MOVE.W   D7,D0
//01fafa e380                     ASL.L    #1,D0
//01fafc 41ec d136                LEA      -11978(A4),A0
//01fb00 d0c0                     ADD.W    D0,A0
//01fb02 3f10                     MOVE.W   (A0),-(A7)
//01fb04 4eba e148                JSR      $-7862 (=0x01dc4e)
//01fb08 548f                     ADDQ.L   #2,A7
        D0W = Darken(d.Palette11978.color[D7W]);
//01fb0a 3207                     MOVE.W   D7,D1
//01fb0c e381                     ASL.L    #1,D1
//01fb0e 41ec d136                LEA      -11978(A4),A0
//01fb12 d0c1                     ADD.W    D1,A0
//01fb14 3080                     MOVE.W   D0,(A0)
        d.Palette11978.color[D7W] = D0W;
//01fb16 5247                     ADDQ.W   #1,D7
//
//01fb18 0c47 0010                CMP.W    #16,D7
//01fb1c 6dbc                     BLT      $-66 (=0x01fada)
     };
//01fb1e 5246                     ADDQ.W   #1,D6
//
//01fb20 0c46 0007                CMP.W    #7,D6
//01fb24 6fa6                     BLE      $-88 (=0x01facc)
    };
//01fb26 426c d226                CLR.W    -11738(A4)
//01fb2a 3f3c 0025                MOVE.W   #37,-(A7)
//01fb2e 4ead 0138                JSR      312(A5)    (=0x001ce8)
//01fb32 548f                     ADDQ.L   #2,A7
    wvbl(_3_);
//01fb34 3f3c 0020                MOVE.W   #32,-(A7)
//01fb38 486c d136                PEA      -11978(A4)
//01fb3c 486e ffb2                PEA      -78(A6)
//01fb40 4ead 0006                JSR      6(A5)    (=0x0009dc)
//01fb44 defc 000a                ADD.W    #10,A7
    MemMove((pnt)&LOCAL_78, (pnt)&d.Palette11978, 32);
//01fb48 600a                     BRA      $+12 (=0x01fb54)
  }
  else
  {
//01fb4a 486c d176                PEA      -11914(A4)
//01fb4e 4eba f4fe                JSR      $-2816 (=0x01f04e)
//01fb52 588f                     ADDQ.L   #4,A7
    FadeToPalette(_4_,&d.Palette11914);
  };
//01fb54 302e 0008                MOVE.W   8(A6),D0
//01fb58 6700 0322                BEQ      $+804 (=0x01fe7c)
  if (P1)
  {
//01fb5c 302c d252                MOVE.W   -11694(A4),D0
//01fb60 6700 01ae                BEQ      $+432 (=0x01fd10)
    if (d.Word11694)
    {
//01fb64 2f3c 000c 0fa0           MOVE.L   #790432,-(A7)
//01fb6a 2f2c d132                MOVE.L   -11982(A4),-(A7)
//01fb6e 4ead 01c8                JSR      456(A5)    (=0x008e1c)
//01fb72 508f                     ADDQ.L   #0,A7
      Flood(d.LogicalScreenBase, 12, 0xfa0);
//01fb74 4247                     CLR.W    D7
//01fb76 6000 0182                BRA      $+388 (=0x01fcfa)
      for (D7W=0; D7W<d.NumCharacter; D7W++)
      {
//01fb7a 3c07                     MOVE.W   D7,D6
//01fb7c cdfc 0030                MULS     #48,D6
        D6L = 48 * D7W;
//01fb80 3007                     MOVE.W   D7,D0
//01fb82 c1fc 0320                MULS     #800,D0
//01fb86 41ec bf9e                LEA      -16482(A4),A0
//01fb8a d0c0                     ADD.W    D0,A0
//01fb8c 41d0                     LEA      (A0),A0
        pcA0 = &d.CH16482[D7W];
//01fb8e 2d48 fffa                MOVE.L   A0,-6(A6)
        LOCAL_6 = pcA0;
//01fb92 2f3c 0020 000a           MOVE.L   #2097162,-(A7)
//01fb98 486c ff7c                PEA      -132(A4)
//01fb9c 2f2e fff2                MOVE.L   -14(A6),-(A7)
//01fba0 4ead 00a2                JSR      162(A5)    (=0x000f7e)
//01fba4 defc 000c                ADD.W    #12,A7
        BLT2Screen(LOCAL_14, (RectPos *)d.Word132, 32, 10);
//01fba8 2f3c 0010 0001           MOVE.L   #1048577,-(A7)
//01fbae 486c ff74                PEA      -140(A4)
//01fbb2 206e fffa                MOVE.L   -6(A6),A0
//01fbb6 41e8 0150                LEA      336(A0),A0
//01fbba 2f08                     MOVE.L   A0,-(A7)
//01fbbc 4ead 00a2                JSR      162(A5)    (=0x000f7e)
//01fbc0 defc 000c                ADD.W    #12,A7
        BLT2Screen(LOCAL_6->portrait, (RectPos *)d.Word140, 16, 1);
//01fbc4 206e fffa                MOVE.L   -6(A6),A0
//01fbc8 41d0                     LEA      (A0),A0
//01fbca 2f08                     MOVE.L   A0,-(A7)
//01fbcc 3f3c 0009                MOVE.W   #9,-(A7)
//01fbd0 3006                     MOVE.W   D6,D0
//01fbd2 d07c 000e                ADD.W    #14,D0
//01fbd6 3c00                     MOVE.W   D0,D6
//01fbd8 3f00                     MOVE.W   D0,-(A7)
//01fbda 3f3c 0057                MOVE.W   #87,-(A7)
//01fbde 4eba fdb0                JSR      $-590 (=0x01f990)
//01fbe2 defc 000a                ADD.W    #10,A7
        DisplayHeroName(87, D6W=sw(D6W+14), 9, LOCAL_6->name);
//01fbe6 206e fffa                MOVE.L   -6(A6),A0
//01fbea 41d0                     LEA      (A0),A0
//01fbec 2f08                     MOVE.L   A0,-(A7)
//01fbee 4ead 006c                JSR      108(A5)    (=0x0032ba)
//01fbf2 588f                     ADDQ.L   #4,A7
//01fbf4 3d40 ff72                MOVE.W   D0,-142(A6)
        LOCAL_142 = StrLen(LOCAL_6->name);
//01fbf8 303c 0006                MOVE.W   #6,D0
//01fbfc c1ee ff72                MULU     -142(A6),D0
//01fc00 d07c 0057                ADD.W    #87,D0
//01fc04 3a00                     MOVE.W   D0,D5
        D5W = sw(6 * LOCAL_142 + 87);
//01fc06 206e fffa                MOVE.L   -6(A6),A0
        A0 = LOCAL_6->name;
//01fc0a 1d68 0008 ffff           MOVE.B   8(A0),-1(A6)
        LOCAL_1 = *(A0+9);
//01fc10 102e ffff                MOVE.B   -1(A6),D0
//01fc14 4880                     EXT.W    D0
//01fc16 b07c 002c                CMP.W    #44,D0
//01fc1a 671a                     BEQ      $+28 (=0x01fc36)
        if (LOCAL_1 != 44)
        {
//01fc1c 102e ffff                MOVE.B   -1(A6),D0
//01fc20 4880                     EXT.W    D0
//01fc22 b07c 003b                CMP.W    #59,D0
//01fc26 670e                     BEQ      $+16 (=0x01fc36)
          if (LOCAL_1 != 59)
          {
//01fc28 102e ffff                MOVE.B   -1(A6),D0
//01fc2c 4880                     EXT.W    D0
//01fc2e b07c 002d                CMP.W    #45,D0
//01fc32 6702                     BEQ      $+4 (=0x01fc36)
            if (LOCAL_1 != 45)
            {
//01fc34 5c45                     ADDQ.W   #6,D5
              D5W += 5;
            };
          };
        };
//01fc36 206e fffa                MOVE.L   -6(A6),A0
//01fc3a 41e8 0008                LEA      8(A0),A0
//01fc3e 2f08                     MOVE.L   A0,-(A7)
//01fc40 3f3c 0009                MOVE.W   #9,-(A7)
//01fc44 3006                     MOVE.W   D6,D0
//01fc46 5246                     ADDQ.W   #1,D6
//01fc48 3f00                     MOVE.W   D0,-(A7)
//01fc4a 3f05                     MOVE.W   D5,-(A7)
//01fc4c 4eba fd42                JSR      $-700 (=0x01f990)
//01fc50 defc 000a                ADD.W    #10,A7
        DisplayHeroName(D5W, D6W++, 9, LOCAL_6->title);
//01fc54 4245                     CLR.W    D5
//01fc56 6000 0080                BRA      $+130 (=0x01fcd8)
        for (D5W=0; D5W<=3; D5W++)
        {
//01fc5a 3005                     MOVE.W   D5,D0
//01fc5c 807c c000                OR.W     #49152,D0
//01fc60 3f00                     MOVE.W   D0,-(A7)
//01fc62 3f07                     MOVE.W   D7,-(A7)
//01fc64 4ead 03f6                JSR      1014(A5)    (=0x015f1e)
//01fc68 588f                     ADDQ.L   #4,A7
          D0W = sw(DetermineMastery(D7W, D5W | 0xc000));
//01fc6a 3f00                     MOVE.W   D0,-(A7)
//01fc6c 3f3c 0010                MOVE.W   #16,-(A7)
//01fc70 4ead 00d8                JSR      216(A5)    (=0x000fe2)
//01fc74 588f                     ADDQ.L   #4,A7
//01fc76 3800                     MOVE.W   D0,D4
          D4W = sw(Smaller(16, D0W));
//01fc78 0c44 0001                CMP.W    #1,D4
//01fc7c 6602                     BNE      $+4 (=0x01fc80)
//01fc7e 6056                     BRA      $+88 (=0x01fcd6)
          if (D4W == 1) continue;
//01fc80 3004                     MOVE.W   D4,D0
//01fc82 e580                     ASL.L    #2,D0
//01fc84 41ec be7e                LEA      -16770(A4),A0
//01fc88 d0c0                     ADD.W    D0,A0
//01fc8a 2f10                     MOVE.L   (A0),-(A7)
//01fc8c 486e ff7e                PEA      -130(A6)
//01fc90 4ead 005a                JSR      90(A5)    (=0x003264)
//01fc94 508f                     ADDQ.L   #0,A7
          StrCpy(LOCAL_130, d.Pointer16770[D4W]);
//01fc96 486c 0578                PEA      1400(A4)
//01fc9a 486e ff7e                PEA      -130(A6)
//01fc9e 4ead 0078                JSR      120(A5)    (=0x0031e8)
//01fca2 508f                     ADDQ.L   #0,A7
          StrCat(LOCAL_130, " ");
//01fca4 3005                     MOVE.W   D5,D0
//01fca6 e580                     ASL.L    #2,D0
//01fca8 41ec bf2c                LEA      -16596(A4),A0
//01fcac d0c0                     ADD.W    D0,A0
//01fcae 2f10                     MOVE.L   (A0),-(A7)
//01fcb0 486e ff7e                PEA      -130(A6)
//01fcb4 4ead 0078                JSR      120(A5)    (=0x0031e8)
//01fcb8 508f                     ADDQ.L   #0,A7
          StrCat(LOCAL_130, d.Pointer16596[D5W]);
//01fcba 486e ff7e                PEA      -130(A6)
//01fcbe 3f3c 000d                MOVE.W   #13,-(A7)
//01fcc2 3006                     MOVE.W   D6,D0
//01fcc4 5040                     ADDQ.W   #0,D0
//01fcc6 3c00                     MOVE.W   D0,D6
//01fcc8 3f00                     MOVE.W   D0,-(A7)
//01fcca 3f3c 0069                MOVE.W   #105,-(A7)
//01fcce 4eba fcc0                JSR      $-830 (=0x01f990)
//01fcd2 defc 000a                ADD.W    #10,A7
          DisplayHeroName(105, D6W=sw(D6W+8), 13, LOCAL_130);
//01fcd6 5245                     ADDQ.W   #1,D5
//
//01fcd8 0c45 0003                CMP.W    #3,D5
//01fcdc 6f00 ff7c                BLE      $-130 (=0x01fc5a)
        };
//01fce0 066c 0030 ff80           ADD.W    #48,-128(A4)
//01fce6 066c 0030 ff82           ADD.W    #48,-126(A4)
//01fcec 066c 0030 ff78           ADD.W    #48,-136(A4)
//01fcf2 066c 0030 ff7a           ADD.W    #48,-134(A4)
        d.Word132[3] += 48;
        d.Word132[2] += 48;
        d.Word140[3] += 48;
        d.Word140[2] += 48;
//01fcf8 5247                     ADDQ.W   #1,D7
//
//01fcfa 3007                     MOVE.W   D7,D0
//01fcfc b06c d24c                CMP.W    -11700(A4),D0
//01fd00 6500 fe78                BCS      $-390 (=0x01fb7a)
      };
//01fd04 486e ffb2                PEA      -78(A6)
//01fd08 4eba f344                JSR      $-3258 (=0x01f04e)
//01fd0c 588f                     ADDQ.L   #4,A7
      d.DynamicPaletteSwitching = 0;
      FadeToPalette(_5_,&LOCAL_78); //Show Champion's Levels
//01fd0e 60fe                     BRA      $+0 (=0x01fd0e)
      for (i=0;(i<2000)&&(RepeatGame) || (!RepeatGame); i++)
      {
        wvbl(_24_)
      };
      GameIsComplete = true;
      RETURN;
    };
tag01fd10:
//01fd10 3f3c 7d00                MOVE.W   #32000,-(A7)
//01fd14 2f2c d132                MOVE.L   -11982(A4),-(A7)
//01fd18 4ead 0054                JSR      84(A5)    (=0x000a84)
//01fd1c 5c8f                     ADDQ.L   #6,A7
    ClearMemory(d.LogicalScreenBase, 32000);
//01fd1e 2f3c 0028 ffff           MOVE.L   #2686975,-(A7)
//01fd24 486c ff94                PEA      -108(A4)
//01fd28 2f0a                     MOVE.L   A2,-(A7)
//01fd2a 4ead 00a2                JSR      162(A5)    (=0x000f7e)
//01fd2e defc 000c                ADD.W    #12,A7
    BLT2Screen(A2, (RectPos *)d.Word108, 40, -1);
//01fd32 2f3c 0002 0002           MOVE.L   #131074,-(A7)
//01fd38 3f3c 0010                MOVE.W   #16,-(A7)
//01fd3c 486e ff92                PEA      -110(A6)
//01fd40 4ead 002a                JSR      42(A5)    (=0x000af6)
//01fd44 defc 000a                ADD.W    #10,A7
    fillMemory((i16 *)&LOCAL_110, 16, 2, 2);
//01fd48 3f3c 0020                MOVE.W   #32,-(A7)
//01fd4c 486e ffd2                PEA      -46(A6)
//01fd50 486e ff92                PEA      -110(A6)
//01fd54 4ead 0006                JSR      6(A5)    (=0x0009dc)
//01fd58 defc 000a                ADD.W    #10,A7
    MemMove((pnt)&LOCAL_110, (pnt)&LOCAL_46, 32);
    ForceScreenDraw();
//01fd5c 3d7c 0777 fff0           MOVE.W   #1911,-16(A6)
    LOCAL_46.color[15] = 0x777;
//01fd62 486e ffd2                PEA      -46(A6)
//01fd66 4eba f2e6                JSR      $-3352 (=0x01f04e)
//01fd6a 588f                     ADDQ.L   #4,A7
    FadeToPalette(_6_,&LOCAL_46);
//01fd6c 302e ff7c                MOVE.W   -132(A6),D0
//01fd70 670a                     BEQ      $+12 (=0x01fd7c)
    if (LOCAL_132)
    {
//01fd72 3f3c 012c                MOVE.W   #300,-(A7)
//01fd76 4ead 019e                JSR      414(A5)    (=0x000fb2)
//01fd7a 548f                     ADDQ.L   #2,A7
      VBLDelay(_7_,300); // About 5 seconds
    };
//01fd7c 302c a7c6                MOVE.W   -22586(A4),D0
//01fd80 6700 00f0                BEQ      $+242 (=0x01fe72)
    if (d.Word22586)
    {
//01fd84 426c a608                CLR.W    -23032(A4)
      d.UseByteCoordinates = 0;
//01fd88 2f3c 0001 00a0           MOVE.L   #65696,-(A7)
//01fd8e 486c ff8c                PEA      -116(A4)
//01fd92 2f2c d132                MOVE.L   -11982(A4),-(A7)
//01fd96 4ead 01ce                JSR      462(A5)    (=0x008e60)
//01fd9a defc 000c                ADD.W    #12,A7
      FillRectangle(d.LogicalScreenBase, (RectPos *)d.Word116, 1, 160);
      ForceScreenDraw();
      wvbl(_21_);
//01fd9e 3f3c 00a0                MOVE.W   #160,-(A7)
//01fda2 4267                     CLR.W    -(A7)
//01fda4 486c ff84                PEA      -124(A4)
//01fda8 2f2c d132                MOVE.L   -11982(A4),-(A7)
//01fdac 4ead 01ce                JSR      462(A5)    (=0x008e60)
//01fdb0 defc 000c                ADD.W    #12,A7
      FillRectangle(d.LogicalScreenBase, (RectPos *)d.Word124, 0, 160);
//01fdb4 486c 057a                PEA      1402(A4)
//01fdb8 4267                     CLR.W    -(A7)
//01fdba 2f3c 009a 0004           MOVE.L   #10092548,-(A7)
//01fdc0 3f3c 006e                MOVE.W   #110,-(A7)
//01fdc4 4ead 0108                JSR      264(A5)    (=0x001c42)
//01fdc8 defc 000c                ADD.W    #12,A7
      TextOutToScreen(110, 0x9a, 4, 0, "RESTART THIS GAME");
//01fdcc 3d7c 0437 ffd4           MOVE.W   #1079,-44(A6)
//01fdd2 3d7c 0777 ffda           MOVE.W   #1911,-38(A6)
//01fdd8 41ec bdc4                LEA      -16956(A4),A0
//01fddc 2948 be18                MOVE.L   A0,-16872(A4)
      LOCAL_46.color[1] = 0x437;
      LOCAL_46.color[4] = 0x777;
      d.PrimaryButtonList = d.Buttons16956;
//01fde0 4ead 052e                JSR      1326(A5)    (=0x01953a)
      TAG01953a();
//01fde4 4ead 00a8                JSR      168(A5)    (=0x003026)
      STShowCursor();
//01fde8 486e ffd2                PEA      -46(A6)
//01fdec 4eba f260                JSR      $-3486 (=0x01f04e)
//01fdf0 588f                     ADDQ.L   #4,A7
      FadeToPalette(_8_,&LOCAL_46);
//01fdf2 3e3c 0384                MOVE.W   #900,D7
//01fdf6 600e                     BRA      $+16 (=0x01fe06)
      for (D7W=900; (--D7W!=0)&&(d.Word22584==0);)
      {
//01fdf8 4ead 051c                JSR      1308(A5)    (=0x01a7b2)
        HandleMouseEvents(_22_,-999887); //initialize
        HandleMouseEvents(_15_,0);
        if (DiskMenuNeeded) DisplayDiskMenu(_23_);
//01fdfc 3f3c 0025                MOVE.W   #37,-(A7)
//01fe00 4ead 0138                JSR      312(A5)    (=0x001ce8)
//01fe04 548f                     ADDQ.L   #2,A7
        wvbl(_9_);
//01fe06 5347                     SUBQ.W   #1,D7
//01fe08 3007                     MOVE.W   D7,D0
//01fe0a 6706                     BEQ      $+8 (=0x01fe12)
//
//01fe0c 302c a7c8                MOVE.W   -22584(A4),D0
//01fe10 67e6                     BEQ      $-24 (=0x01fdf8)
      };
//01fe12 4ead 0024                JSR      36(A5)    (=0x002fd2)
      STHideCursor();
      ForceScreenDraw();
//01fe16 302c a7c8                MOVE.W   -22584(A4),D0
//01fe1a 6756                     BEQ      $+88 (=0x01fe72)
      if (d.Word22584)
      {
//01fe1c 486e ff92                PEA      -110(A6)
//01fe20 4eba f22c                JSR      $-3538 (=0x01f04e)
//01fe24 588f                     ADDQ.L   #4,A7
        FadeToPalette(_10_,&LOCAL_110);
//01fe26 3f3c 7d00                MOVE.W   #32000,-(A7)
//01fe2a 2f2c d132                MOVE.L   -11982(A4),-(A7)
//01fe2e 4ead 0054                JSR      84(A5)    (=0x000a84)
//01fe32 5c8f                     ADDQ.L   #6,A7
        ClearMemory(d.LogicalScreenBase, 32000);
//01fe34 486c fdd8                PEA      -552(A4)
//01fe38 4eba f214                JSR      $-3562 (=0x01f04e)
//01fe3c 588f                     ADDQ.L   #4,A7
        FadeToPalette(_11_,&d.Palette552[0]);
//01fe3e 3f3c 0020                MOVE.W   #32,-(A7)
//01fe42 486c d156                PEA      -11946(A4)
//01fe46 486c fdd8                PEA      -552(A4)
//01fe4a 4ead 0006                JSR      6(A5)    (=0x0009dc)
//01fe4e defc 000a                ADD.W    #10,A7
        MemMove((pnt)&d.Palette552[0], (pnt)&d.Palette11946, 32);
//01fe52 426c d25a                CLR.W    -11686(A4)
        d.Word11686 = 0;
//01fe56 4eba ecc0                JSR      $-4926 (=0x01eb18)
        TAG01eb18(_16_);
        D0W = i16Result;
//01fe5a 0c40 ffff                CMP.W    #65535,D0
//01fe5e 6712                     BEQ      $+20 (=0x01fe72)
        if (D0W != -1)
        {
//01fe60 4eba 11c6                JSR      $+4552 (=0x021028)
          TAG021028(_18_);
//01fe64 426c a7c8                CLR.W    -22584(A4)
          d.Word22584 = 0;
//01fe68 4ead 00a8                JSR      168(A5)    (=0x003026)
          STShowCursor();
//01fe6c 4ead 052e                JSR      1326(A5)    (=0x01953a)
          TAG01953a();
//01fe70 605c                     BRA      $+94 (=0x01fece)
          RETURN;
        };
      };
    };
//01fe72 486e ff92                PEA      -110(A6)
//01fe76 4eba f1d6                JSR      $-3624 (=0x01f04e)
//01fe7a 588f                     ADDQ.L   #4,A7
    FadeToPalette(_12_,&LOCAL_110);
  };
//01fe7c 4267                     CLR.W    -(A7)
//01fe7e 4267                     CLR.W    -(A7)
//01fe80 2f2c d132                MOVE.L   -11982(A4),-(A7)
//01fe84 2f2e fff6                MOVE.L   -10(A6),-(A7)
//01fe88 4ead 05d0                JSR      1488(A5)    (=0x0213ec)
//01fe8c defc 000c                ADD.W    #12,A7
  ExpandGraphic(LOCAL_10, d.LogicalScreenBase, 0, 0);
//01fe90 486c feb8                PEA      -328(A4)
//01fe94 4eba f1b8                JSR      $-3654 (=0x01f04e)
//01fe98 588f                     ADDQ.L   #4,A7
  FadeToPalette(_13_,&d.Palette328);
  i=0;
  do
  {
    i++;
//01fe9a 302c a5b0                MOVE.W   -23120(A4),D0
//01fe9e 660e                     BNE      $+16 (=0x01feae)
    if (d.MouseSwitches != 0) break;
    wvbl(_19_);//NotImplemented(0x1fea0);//pumper();
//01fea0 3f3c 000b                MOVE.W   #11,-(A7)
//01fea4 4ead 0096                JSR      150(A5)    (=0x001cf8)
    D0W = (I16)UI_CONSTAT();
//01fea8 548f                     ADDQ.L   #2,A7
//01feaa 4a40                     TST.W    D0
//01feac 67ec                     BEQ      $-18 (=0x01fe9a)
  } while ((D0W == 0)&&(!RepeatGame) || (i<2000)&&(RepeatGame));
//01feae 302c a7c6                MOVE.W   -22586(A4),D0
//01feb2 6718                     BEQ      $+26 (=0x01fecc)
  if (d.Word22586)
  {
//01feb4 302e 0008                MOVE.W   8(A6),D0
//01feb8 6712                     BEQ      $+20 (=0x01fecc)
    if (P1)
    {
//01feba 426e ff7c                CLR.W    -132(A6)
      LOCAL_132 = 0;
//01febe 486e ff92                PEA      -110(A6)
//01fec2 4eba f18a                JSR      $-3700 (=0x01f04e)
//01fec6 588f                     ADDQ.L   #4,A7
      FadeToPalette(_14_,&LOCAL_110);
//01fec8 6000 fe46                BRA      $-440 (=0x01fd10)
      goto tag01fd10;
    };
  };
//01fecc 60fe                     BRA      $+0 (=0x01fecc)
  for(i=0;(i<2000)&&(RepeatGame) || (!RepeatGame); i++)  {wvbl(_20_);};
//01fece 4cdf 0cf0                MOVEM.L  (A7)+,D4567A23
//01fed2 4e5e                     UNLK     A6
//01fed4 4e75                     RTS
  //RETURN;
}
