#include "stdafx.h"

#include "UI.h"

#include <stdio.h>

#include "Objects.h"
#include "Dispatch.h"
#include "CSB.h"
#include "data.h"


void TAG021234(void)
{
  HopefullyNotNeeded(0x21234); 
}

void TAG021960(i16 *entries,i16 numEnt)
{
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//021960 4e56 fff8                LINK     A6,#-8   
  //pnt A3;
  ui16 uwD0, uwD1, uwD4, uwD5, uwD6, uwD7;
  ui16 uwLOCAL_8;
  ui16 uwLOCAL_6;
  ui16 logNumEnt;
  i32 i;
//021964 48e7 0f10                MOVEM.L  D4567A3,-(A7)   
//021968 266e 0008                MOVE.L   8(A6),A3   
//02196c 426e fffc                CLR.W    -4(A6)   
  logNumEnt = 0;
//021970 3d6e 000c fffe           MOVE.W   12(A6),-2(A6)   
  i = numEnt;
//021976 6004                     BRA      $+6 (=0x02197c)   
  while ((i >>= 1) != 0)
  {
//021978 526e fffc                ADDQ.W   #1,-4(A6)   
    logNumEnt++;
//02197c 302e fffe                MOVE.W   -2(A6),D0   
//021980 e240                     ASR.W    #1,D0   
//021982 3d40 fffe                MOVE.W   D0,-2(A6)   
//021986 66f0                     BNE      $-14 (=0x021978)   
  };
//021988 302e fffc                MOVE.W   -4(A6),D0   
//02198c 5340                     SUBQ.W   #1,D0   
//02198e 3d40 fffe                MOVE.W   D0,-2(A6)   
  for (i=logNumEnt-1; i>=0; i--)
  {
//021992 6000 00a0                BRA      $+162 (=0x021a34)   
//021996 303c 0001                MOVE.W   #1,D0   
//02199a 362e fffe                MOVE.W   -2(A6),D3   
//02199e e760                     ASL.W    D3,D0   
//0219a0 5340                     SUBQ.W   #1,D0   
//0219a2 3d40 fffa                MOVE.W   D0,-6(A6)   
    uwLOCAL_6 = uw((1 << i) - 1);
//0219a6 e340                     ASL.W    #1,D0   
//0219a8 3d40 fff8                MOVE.W   D0,-8(A6)   
    uwLOCAL_8 = uw(uwLOCAL_6 << 1);
//0219ac 3c2e fffa                MOVE.W   -6(A6),D6   
//0219b0 6076                     BRA      $+120 (=0x021a28)   
    for (uwD6=uwLOCAL_6; uwD6<=uwLOCAL_8; uwD6++) // 2nd half of current part??
    {
//0219b2 3806                     MOVE.W   D6,D4   
//0219b4 3e04                     MOVE.W   D4,D7   
      uwD7 = uwD6;
//0219b6 e384                     ASL.L    #1,D4   
//0219b8 204b                     MOVE.L   A3,A0   
//0219ba d0c4                     ADD.W    D4,A0   
//0219bc 3810                     MOVE.W   (A0),D4   
      uwD4 = entries[uwD6]; // Middle entry
      for (;;)
      {
//0219be 3007                     MOVE.W   D7,D0   
//0219c0 e340                     ASL.W    #1,D0   
//0219c2 5240                     ADDQ.W   #1,D0   
//0219c4 3a00                     MOVE.W   D0,D5   
//0219c6 b06e 000c                CMP.W    12(A6),D0   
        uwD5 = uw((uwD7<<1)+1);
//0219ca 6502                     BCS      $+4 (=0x0219ce)   
//0219cc 604e                     BRA      $+80 (=0x021a1c)   
        if ((ui16)uwD5 >= numEnt) break;
//0219ce 3005                     MOVE.W   D5,D0   
//0219d0 5240                     ADDQ.W   #1,D0   
//0219d2 b06e 000c                CMP.W    12(A6),D0   
//0219d6 641a                     BCC      $+28 (=0x0219f2)   
        if ((ui16)uwD5+1 < numEnt)
        {
//0219d8 3005                     MOVE.W   D5,D0   
//0219da e380                     ASL.L    #1,D0   
//0219dc 204b                     MOVE.L   A3,A0   
//0219de d0c0                     ADD.W    D0,A0   
//0219e0 3028 0002                MOVE.W   2(A0),D0   
          uwD0 = entries[uwD5+1];
//0219e4 3205                     MOVE.W   D5,D1   
//0219e6 e381                     ASL.L    #1,D1   
//0219e8 204b                     MOVE.L   A3,A0   
//0219ea d0c1                     ADD.W    D1,A0   
//0219ec b050                     CMP.W    (A0),D0   
          if ((ui16)uwD0 >= entries[uwD5]) uwD5++;
//0219ee 6502                     BCS      $+4 (=0x0219f2)   
//0219f0 5245                     ADDQ.W   #1,D5   
        };
//0219f2 3004                     MOVE.W   D4,D0   
//0219f4 3205                     MOVE.W   D5,D1   
//0219f6 e381                     ASL.L    #1,D1   
//0219f8 204b                     MOVE.L   A3,A0   
//0219fa d0c1                     ADD.W    D1,A0   
//0219fc b050                     CMP.W    (A0),D0   
//0219fe 6418                     BCC      $+26 (=0x021a18)   
        if ((ui16)uwD4 >= (ui16)entries[uwD5]) break;
//021a00 3005                     MOVE.W   D5,D0   
//021a02 e380                     ASL.L    #1,D0   
//021a04 204b                     MOVE.L   A3,A0   
//021a06 d0c0                     ADD.W    D0,A0   
//021a08 3010                     MOVE.W   (A0),D0   
        uwD0 = entries[uwD5];
//021a0a 3207                     MOVE.W   D7,D1   
//021a0c e381                     ASL.L    #1,D1   
//021a0e 204b                     MOVE.L   A3,A0   
//021a10 d0c1                     ADD.W    D1,A0   
//021a12 3080                     MOVE.W   D0,(A0)   
        entries[uwD7] = uwD0;
//021a14 3e05                     MOVE.W   D5,D7   
        uwD7 = uwD5;
//021a16 6002                     BRA      $+4 (=0x021a1a)   
        //continue;
//021a18 6002                     BRA      $+4 (=0x021a1c)   
//021a1a 60a2                     BRA      $-92 (=0x0219be)   
      };
//021a1c 3007                     MOVE.W   D7,D0   
//021a1e e380                     ASL.L    #1,D0   
//021a20 204b                     MOVE.L   A3,A0   
//021a22 d0c0                     ADD.W    D0,A0   
//021a24 3084                     MOVE.W   D4,(A0)   
      entries[uwD7] = uwD4;
//021a26 5246                     ADDQ.W   #1,D6   
//
//021a28 3006                     MOVE.W   D6,D0   
//021a2a b06e fff8                CMP.W    -8(A6),D0   
//021a2e 6382                     BLS      $-124 (=0x0219b2)   
    };
//021a30 536e fffe                SUBQ.W   #1,-2(A6)   
//
//021a34 4a6e fffe                TST.W    -2(A6)   
//021a38 6c00 ff5c                BGE      $-162 (=0x021996)   
  };
//021a3c 302e 000c                MOVE.W   12(A6),D0   
//021a40 5340                     SUBQ.W   #1,D0   
//021a42 3d40 fffa                MOVE.W   D0,-6(A6)   
  for (uwLOCAL_6=uw(numEnt-1); uwLOCAL_6!=0; uwLOCAL_6--)
  {
//021a46 6000 0098                BRA      $+154 (=0x021ae0)   
//021a4a 382e fffa                MOVE.W   -6(A6),D4   
//021a4e e384                     ASL.L    #1,D4   
//021a50 204b                     MOVE.L   A3,A0   
//021a52 d0c4                     ADD.W    D4,A0   
//021a54 3810                     MOVE.W   (A0),D4   
    uwD4 = entries[uwLOCAL_6];
//021a56 303c 0000                MOVE.W   #0,D0   
    uwD7=0;
//021a5a 3e00                     MOVE.W   D0,D7   
//021a5c e380                     ASL.L    #1,D0   
//021a5e 204b                     MOVE.L   A3,A0   
//021a60 d0c0                     ADD.W    D0,A0   
//021a62 3010                     MOVE.W   (A0),D0   
//021a64 322e fffa                MOVE.W   -6(A6),D1   
    uwD0 = entries[uwD7];
    uwD1 = uwLOCAL_6;
//021a68 e381                     ASL.L    #1,D1   
//021a6a 204b                     MOVE.L   A3,A0   
//021a6c d0c1                     ADD.W    D1,A0   
//021a6e 3080                     MOVE.W   D0,(A0)   
    entries[uwD1] = uwD0;
    for (;;)
    {
//021a70 3007                     MOVE.W   D7,D0   
//021a72 e340                     ASL.W    #1,D0   
//021a74 5240                     ADDQ.W   #1,D0   
//021a76 3a00                     MOVE.W   D0,D5   
      uwD5 = uw((uwD7<<1)+1);
//021a78 322e fffa                MOVE.W   -6(A6),D1   
//021a7c 5341                     SUBQ.W   #1,D1   
//021a7e b041                     CMP.W    D1,D0   
//021a80 6302                     BLS      $+4 (=0x021a84)   
//021a82 604e                     BRA      $+80 (=0x021ad2)   
      if (uwD5 > uwLOCAL_6-1) break;
//021a84 3005                     MOVE.W   D5,D0   
//021a86 5240                     ADDQ.W   #1,D0   
//021a88 b06e fffa                CMP.W    -6(A6),D0   
//021a8c 641a                     BCC      $+28 (=0x021aa8)   
      if (uwD5 < uwLOCAL_6 - 1)
      {
//021a8e 3005                     MOVE.W   D5,D0   
//021a90 e380                     ASL.L    #1,D0   
//021a92 204b                     MOVE.L   A3,A0   
//021a94 d0c0                     ADD.W    D0,A0   
//021a96 3028 0002                MOVE.W   2(A0),D0   
        uwD0 = entries[uwD5+1];
//021a9a 3205                     MOVE.W   D5,D1   
//021a9c e381                     ASL.L    #1,D1   
//021a9e 204b                     MOVE.L   A3,A0   
//021aa0 d0c1                     ADD.W    D1,A0   
//021aa2 b050                     CMP.W    (A0),D0   
//021aa4 6502                     BCS      $+4 (=0x021aa8)   
        if (uwD0 >= entries[uwD5]) uwD5++;
//021aa6 5245                     ADDQ.W   #1,D5   
      };
//021aa8 3004                     MOVE.W   D4,D0   
//021aaa 3205                     MOVE.W   D5,D1   
//021aac e381                     ASL.L    #1,D1   
//021aae 204b                     MOVE.L   A3,A0   
//021ab0 d0c1                     ADD.W    D1,A0   
//021ab2 b050                     CMP.W    (A0),D0   
//021ab4 6418                     BCC      $+26 (=0x021ace)   
      if (uwD4 >= entries[uwD5]) break;
//021ab6 3005                     MOVE.W   D5,D0   
//021ab8 e380                     ASL.L    #1,D0   
//021aba 204b                     MOVE.L   A3,A0   
//021abc d0c0                     ADD.W    D0,A0   
//021abe 3010                     MOVE.W   (A0),D0   
      uwD0 = entries[uwD5];
//021ac0 3207                     MOVE.W   D7,D1   
//021ac2 e381                     ASL.L    #1,D1   
//021ac4 204b                     MOVE.L   A3,A0   
//021ac6 d0c1                     ADD.W    D1,A0   
//021ac8 3080                     MOVE.W   D0,(A0)   
      entries[uwD7] = uwD0;
//021aca 3e05                     MOVE.W   D5,D7   
      uwD7 = uwD5;
//021acc 6002                     BRA      $+4 (=0x021ad0)   
//021ace 6002                     BRA      $+4 (=0x021ad2)   
//021ad0 609e                     BRA      $-96 (=0x021a70)   
    }; // while (1)
//021ad2 3007                     MOVE.W   D7,D0   
//021ad4 e380                     ASL.L    #1,D0   
//021ad6 204b                     MOVE.L   A3,A0   
//021ad8 d0c0                     ADD.W    D0,A0   
//021ada 3084                     MOVE.W   D4,(A0)   
    entries[uwD7] = uwD4;
//021adc 536e fffa                SUBQ.W   #1,-6(A6)   
//
//021ae0 0c6e 0001 fffa           CMP.W    #1,-6(A6)   
//021ae6 6400 ff62                BCC      $-156 (=0x021a4a)   
  };
//021aea 4cdf 08f0                MOVEM.L  (A7)+,D4567A3   
//021aee 4e5e                     UNLK     A6   
//021af0 4e75                     RTS         
}    

void TAG0220fa(i32 P1)
{
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//0220fa 4e56 0000                LINK     A6,#0   
//0220fe 6024                     BRA      $+38 (=0x022124)   
  while (d.Long23336 < P1)
  {
//022100 4aac a4d0                TST.L    -23344(A4)   
//022104 660a                     BNE      $+12 (=0x022110)   
    if (d.pqFirstGraphic == NULL)
    {
//022106 3f3c 002b                MOVE.W   #43,-(A7)   
//02210a 4ead 00cc                JSR      204(A5)    (=0x000efc)
//02210e 548f                     ADDQ.L   #2,A7   
      SystemError(43);
    };
//022110 202c a4d0                MOVE.L   -23344(A4),D0   
//022114 d0bc 0000 000a           ADD.L    #10,D0   
//02211a 2040                     MOVE.L   D0,A0   
//02211c 3f10                     MOVE.W   (A0),-(A7)   
//02211e 4eba fe3e                JSR      $-448 (=0x021f5e)   
//022122 548f                     ADDQ.L   #2,A7   
    DeleteGraphic(d.pqFirstGraphic->graphicNum);

//022124 202c a4d8                MOVE.L   -23336(A4),D0   
//022128 b0ae 0008                CMP.L    8(A6),D0   
//02212c 6dd2                     BLT      $-44 (=0x022100)   
  };
//02212e 4e5e                     UNLK     A6   
//022130 4e75                     RTS         
}

//*********************************************************
//
//*********************************************************
//   TAG022132
void CompactMemory(void)
{
  dReg D5, D6, D7;
  pnt A2, A3;
  VerifyGraphicFreeList();
#ifdef _VERIFYPPQ
  verifyppq();
#endif
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//022132 4e56 0000                LINK     A6,#0   
//022136 48e7 0730                MOVEM.L  D567A23,-(A7)   
//02213a 4aac a4d4                TST.L    -23340(A4)   
//02213e 6604                     BNE      $+6 (=0x022144)   
//022140 6000 00ac                BRA      $+174 (=0x0221ee)   
  if (d.pgUnused == NULL) return;
//022144 202c a510                MOVE.L   -23280(A4),D0   
//022148 2440                     MOVE.L   D0,A2   
//02214a 2640                     MOVE.L   D0,A3   
  A2 = A3 = d.Pointer23280;
  do 
  {
//02214c 200a                     MOVE.L   A2,D0   
//02214e 2040                     MOVE.L   D0,A0   
//022150 2010                     MOVE.L   (A0),D0   
//022152 2e00                     MOVE.L   D0,D7   
    D7L = longGear(A2);
//022154 4a80                     TST.L    D0   
//022156 6f06                     BLE      $+8 (=0x02215e)   
    if (D7L > 0) // Not being used
    {
//022158 d5c7                     ADD.L    D7,A2   
      A2 += D7L; // Look for next buffer in use
//02215a 6000 0080                BRA      $+130 (=0x0221dc)   
    }
    else
    {
//02215e 2007                     MOVE.L   D7,D0   
//022160 4480                     NEG.L    D0   
//022162 2e00                     MOVE.L   D0,D7   
      D7L = -D7L;
//022164 200a                     MOVE.L   A2,D0   
//022166 b08b                     CMP.L    A3,D0   
//022168 676e                     BEQ      $+112 (=0x0221d8)   
      if (A2 != A3)
      {
//02216a 2c0a                     MOVE.L   A2,D6   
//02216c dcbc 0000 000a           ADD.L    #10,D6   
//022172 2046                     MOVE.L   D6,A0   
//022174 3c10                     MOVE.W   (A0),D6   
        D6W = wordGear(A2+10);
//022176 4a46                     TST.W    D6   
//022178 6d0e                     BLT      $+16 (=0x022188)   
        if (D6W >= 0)
        {
//02217a 3a06                     MOVE.W   D6,D5   
//02217c e385                     ASL.L    #1,D5   
//02217e 206c a51e                MOVE.L   -23266(A4),A0   
//022182 d0c5                     ADD.W    D5,A0   
//022184 3a10                     MOVE.W   (A0),D5   
          D5W = d.pwPointer23266[D6W];
//022186 6010                     BRA      $+18 (=0x022198)   
        }
        else
        {
//022188 3a06                     MOVE.W   D6,D5   
//02218a ca7c 7fff                AND.W    #32767,D5   
//02218e e385                     ASL.L    #1,D5   
//022190 206c a51a                MOVE.L   -23270(A4),A0   
//022194 d0c5                     ADD.W    D5,A0   
//022196 3a10                     MOVE.W   (A0),D5   
          D5W = d.GraphicIndex[D6W & 0x7fff];
        };
//022198 3005                     MOVE.W   D5,D0   
//02219a e580                     ASL.L    #2,D0   
//02219c 206c a4dc                MOVE.L   -23332(A4),A0   
//0221a0 d0c0                     ADD.W    D0,A0   
//0221a2 208b                     MOVE.L   A3,(A0)   
        d.ppqBuffers[D5W] = (ITEMQ *)A3;
//0221a4 2007                     MOVE.L   D7,D0   
//0221a6 3f00                     MOVE.W   D0,-(A7)   
//0221a8 2f0b                     MOVE.L   A3,-(A7)   
//0221aa 2f0a                     MOVE.L   A2,-(A7)   
//0221ac 4ead 0006                JSR      6(A5)    (=0x0009dc)
//0221b0 defc 000a                ADD.W    #10,A7   
        MemMove(A2, A3, D7W);
//0221b4 202c a4d0                MOVE.L   -23344(A4),D0   
//0221b8 b08a                     CMP.L    A2,D0   
//0221ba 6604                     BNE      $+6 (=0x0221c0)   
        if (d.pqFirstGraphic == (ITEMQ *)A2)
        {
//0221bc 294b a4d0                MOVE.L   A3,-23344(A4)   
          d.pqFirstGraphic = (ITEMQ *)A3;
        };
//0221c0 202c a4cc                MOVE.L   -23348(A4),D0   
//0221c4 b08a                     CMP.L    A2,D0   
//0221c6 6604                     BNE      $+6 (=0x0221cc)   
        if (d.pqLastGraphic == (ITEMQ *)A2)
        {
//0221c8 294b a4cc                MOVE.L   A3,-23348(A4)   
          d.pqLastGraphic = (ITEMQ *)A3;
        };
//0221cc 202c a4c8                MOVE.L   -23352(A4),D0   
//0221d0 b08a                     CMP.L    A2,D0   
//0221d2 6604                     BNE      $+6 (=0x0221d8)   
        if (d.pqFirstGraphic2 == (ITEMQ *)A2)
        {
//0221d4 294b a4c8                MOVE.L   A3,-23352(A4)   
          d.pqFirstGraphic2 = (ITEMQ *)A3;
        };
      };
//0221d8 d5c7                     ADD.L    D7,A2   
//0221da d7c7                     ADD.L    D7,A3   
      ASSERT(longGear(A3) == longGear(A3+D7L-4));
      A2 += D7L;
      A3 += D7L;
    };
//0221dc 200a                     MOVE.L   A2,D0   
//0221de b0ac a4ea                CMP.L    -23318(A4),D0   
//0221e2 6600 ff68                BNE      $-150 (=0x02214c)   
  } while (A2 != d.Pointer23318);
//0221e6 294b a4ea                MOVE.L   A3,-23318(A4)   
//0221ea 42ac a4d4                CLR.L    -23340(A4)   
#ifdef _VERIFYPPQ
  verifyppq();
#endif
  d.Pointer23318 = A3;
  d.pgUnused = NULL;
//0221ee 4cdf 0ce0                MOVEM.L  (A7)+,D567A23   
//0221f2 4e5e                     UNLK     A6   
//0221f4 4e75                     RTS         
}

//*********************************************************
//
//*********************************************************
RESTARTABLE _TAG0222ea(i16 *P1, const i32 Count)
{//(void)
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//0222ea 4e56 ffe8                LINK     A6,#-24   
  static dReg D0, D4, D5, D6, D7;
  static aReg A0, A2, A3;
  static i32 iLOCAL_24;
  static i16 wLOCAL_14;
  static pnt pLOCAL_12;
  static i32 iLOCAL_8;
  static i32 iLOCAL_4;
  static i16 count;
  RESTARTMAP
    RESTART(1)
  END_RESTARTMAP
  count=sw(Count);
//0222ee 48e7 0f30                MOVEM.L  D4567A23,-(A7)   
//0222f2 426e fff2                CLR.W    -14(A6)   
  wLOCAL_14 = 0;
//0222f6 3f2e 000c                MOVE.W   12(A6),-(A7)   
//0222fa 2f2e 0008                MOVE.L   8(A6),-(A7)   
//0222fe 4eba f660                JSR      $-2462 (=0x021960)   
//022302 5c8f                     ADDQ.L   #6,A7   
  TAG021960(P1, count);
//022304 42ae fffc                CLR.L    -4(A6)   
  iLOCAL_4 = 0;
//022308 4247                     CLR.W    D7   
//02230a 6000 0088                BRA      $+138 (=0x022394)   
  for (D7W=0; D7W<count; D7W++)
  {
//02230e 3a07                     MOVE.W   D7,D5   
//022310 e385                     ASL.L    #1,D5   
//022312 206e 0008                MOVE.L   8(A6),A0   
//022316 d0c5                     ADD.W    D5,A0   
//022318 3a10                     MOVE.W   (A0),D5   
    D5W = P1[D7W];
//02231a 6032                     BRA      $+52 (=0x02234e)   
    while (  ((D6W=sw(D7W+1)) < count)
           &&(D5W == P1[D6W]) )
    {
//02231c 302e 000c                MOVE.W   12(A6),D0   
//022320 536e 000c                SUBQ.W   #1,12(A6)   
//022324 9046                     SUB.W    D6,D0   
//022326 e340                     ASL.W    #1,D0   
//022328 3f00                     MOVE.W   D0,-(A7)   
//02232a 3007                     MOVE.W   D7,D0   
//02232c e380                     ASL.L    #1,D0   
//02232e 206e 0008                MOVE.L   8(A6),A0   
//022332 d0c0                     ADD.W    D0,A0   
//022334 41d0                     LEA      (A0),A0   
//022336 2f08                     MOVE.L   A0,-(A7)   
//022338 3006                     MOVE.W   D6,D0   
//02233a e380                     ASL.L    #1,D0   
//02233c 206e 0008                MOVE.L   8(A6),A0   
//022340 d0c0                     ADD.W    D0,A0   
//022342 41d0                     LEA      (A0),A0   
//022344 2f08                     MOVE.L   A0,-(A7)   
//022346 4ead 0006                JSR      6(A5)    (=0x0009dc)
//02234a defc 000a                ADD.W    #10,A7  
    MemMove((pnt)&P1[D6W], (pnt)&P1[D7W], 2*((count--)-D6W)); 
//02234e 3007                     MOVE.W   D7,D0   
//022350 5240                     ADDQ.W   #1,D0   
//022352 3c00                     MOVE.W   D0,D6   
//022354 b06e 000c                CMP.W    12(A6),D0   
//022358 6c10                     BGE      $+18 (=0x02236a)   
 

//02235a 3005                     MOVE.W   D5,D0   
//02235c 3206                     MOVE.W   D6,D1   
//02235e e381                     ASL.L    #1,D1   
//022360 206e 0008                MOVE.L   8(A6),A0   
//022364 d0c1                     ADD.W    D1,A0   
//022366 b050                     CMP.W    (A0),D0   
//022368 67b2                     BEQ      $-76 (=0x02231c)   
    };
//02236a 383c 0002                MOVE.W   #2,D4   
//02236e 3205                     MOVE.W   D5,D1   
//022370 e381                     ASL.L    #1,D1   
//022372 206c a526                MOVE.L   -23258(A4),A0   
//022376 d0c1                     ADD.W    D1,A0   
//022378 d850                     ADD.W    (A0),D4   
    D4W = sw(d.GraphicExpSizes[D5W] + 2);
    D4L &= 0xffff;
//02237a c8bc 0000 ffff           AND.L    #65535,D4   
//022380 2004                     MOVE.L   D4,D0   
//022382 c0bc 0000 0001           AND.L    #1,D0   
//022388 6702                     BEQ      $+4 (=0x02238c)   
    if (D4L & 1) D4L++;  
//02238a 5284                     ADDQ.L   #1,D4   
//02238c 2004                     MOVE.L   D4,D0   
//02238e d1ae fffc                ADD.L    D0,-4(A6)   
    iLOCAL_4 += D4L;
//022392 5247                     ADDQ.W   #1,D7   

//022394 3007                     MOVE.W   D7,D0   
//022396 b06e 000c                CMP.W    12(A6),D0   
//02239a 6d00 ff72                BLT      $-140 (=0x02230e)   
  };
//02239e 302c a4e0                MOVE.W   -23328(A4),D0   
//0223a2 6714                     BEQ      $+22 (=0x0223b8)   
  if (d.Word23328 != 0)
  {
//0223a4 202c a4f2                MOVE.L   -23310(A4),D0   
//0223a8 90ae fffc                SUB.L    -4(A6),D0   
    iLOCAL_8 = d.Pointer23310 - iLOCAL_4 - d.Pointer23280;
//0223ac 222c a510                MOVE.L   -23280(A4),D1   
//0223b0 9081                     SUB.L    D1,D0   
//0223b2 2d40 fff8                MOVE.L   D0,-8(A6)   
//0223b6 600e                     BRA      $+16 (=0x0223c6)   
  }
  else
  {
//0223b8 202c a50c                MOVE.L   -23284(A4),D0   
//0223bc 222c a510                MOVE.L   -23280(A4),D1   
//0223c0 9081                     SUB.L    D1,D0   
//0223c2 2d40 fff8                MOVE.L   D0,-8(A6)   
    iLOCAL_8 = d.Pointer23284 - d.Pointer23280;
  };
//0223c6 206c d132                MOVE.L   -11982(A4),A0   
//0223ca 216e fff8 7d00           MOVE.L   -8(A6),32000(A0)   
  A0 = d.LogicalScreenBase;
  longGear(A0+32000) = iLOCAL_8;
//0223d0 203c 0000 4c78           MOVE.L   #19576,D0   
//0223d6 b0ae fff8                CMP.L    -8(A6),D0   
//0223da 6f0a                     BLE      $+12 (=0x0223e6)   
  if (iLOCAL_8 < 19576)
  {
//0223dc 3f3c 002c                MOVE.W   #44,-(A7)   
//0223e0 4ead 00cc                JSR      204(A5)    (=0x000efc)
//0223e4 548f                     ADDQ.L   #2,A7   
    SystemError(44); // Error number
  };
//0223e6 4247                     CLR.W    D7   
//0223e8 6020                     BRA      $+34 (=0x02240a)   
  for (D7W=0; D7W<730; D7W++)
  {
//0223ea 3007                     MOVE.W   D7,D0   
//0223ec e380                     ASL.L    #1,D0   
//0223ee 206c a51a                MOVE.L   -23270(A4),A0   
//0223f2 d0c0                     ADD.W    D0,A0   
//0223f4 0c50 ffff                CMP.W    #65535,(A0)   
    if (d.GraphicIndex[D7W] != -1)
    {
//0223f8 670e                     BEQ      $+16 (=0x022408)   
//0223fa 3007                     MOVE.W   D7,D0   
//0223fc 807c 8000                OR.W     #32768,D0   
//022400 3f00                     MOVE.W   D0,-(A7)   
//022402 4eba fb5a                JSR      $-1188 (=0x021f5e)   
//022406 548f                     ADDQ.L   #2,A7   
      DeleteGraphic(D7W|0x8000);
    };
//022408 5247                     ADDQ.W   #1,D7   
//
//02240a 0c47 02da                CMP.W    #730,D7   
//02240e 6dda                     BLT      $-36 (=0x0223ea)   
  };
//022410 3c3c 0000                MOVE.W   #0,D6   
//022414 3e06                     MOVE.W   D6,D7   
  D7W = 0;
  do
  {
//022416 3a07                     MOVE.W   D7,D5   
//022418 e385                     ASL.L    #1,D5   
//02241a 206e 0008                MOVE.L   8(A6),A0   
//02241e d0c5                     ADD.W    D5,A0   
//022420 3a10                     MOVE.W   (A0),D5   
    D5W = P1[D7W];
//022422 6052                     BRA      $+84 (=0x022476)   
    for (D6W=0; D6W<D5W; D6W++)
    {
//022424 3006                     MOVE.W   D6,D0   
//022426 e580                     ASL.L    #2,D0   
//022428 206c a522                MOVE.L   -23262(A4),A0   
//02242c d0c0                     ADD.W    D0,A0   
//02242e 2010                     MOVE.L   (A0),D0   
//022430 2640                     MOVE.L   D0,A3   
      A3 = d.ppPointer23262[D6W];
//022432 4a80                     TST.L    D0   
//022434 673e                     BEQ      $+64 (=0x022474)   
      if (A3 == NULL) continue;
//022436 3f06                     MOVE.W   D6,-(A7)   
//022438 4eba fb24                JSR      $-1242 (=0x021f5e)   
//02243c 548f                     ADDQ.L   #2,A7   
      DeleteGraphic(D6W);
//02243e 3006                     MOVE.W   D6,D0   
//022440 e580                     ASL.L    #2,D0   
//022442 206c a522                MOVE.L   -23262(A4),A0   
//022446 d0c0                     ADD.W    D0,A0   
//022448 4290                     CLR.L    (A0)   
      d.ppPointer23262[D6W] = NULL;
//02244a 3806                     MOVE.W   D6,D4   
//02244c e384                     ASL.L    #1,D4   
//02244e 206c a526                MOVE.L   -23258(A4),A0   
//022452 d0c4                     ADD.W    D4,A0   
//022454 3810                     MOVE.W   (A0),D4   
      D4W = d.GraphicExpSizes[D6W];
      D4L &= 0xffff;
//022456 c8bc 0000 ffff           AND.L    #65535,D4   
//02245c 2004                     MOVE.L   D4,D0   
//02245e c0bc 0000 0001           AND.L    #1,D0   
//022464 6702                     BEQ      $+4 (=0x022468)   
      if (D4L & 1) D4L++;
//022466 5284                     ADDQ.L   #1,D4   
//022468 2004                     MOVE.L   D4,D0   
//02246a 4480                     NEG.L    D0   
      D0L = -D4L;
//02246c 220b                     MOVE.L   A3,D1   
//02246e d284                     ADD.L    D4,D1   
//022470 2041                     MOVE.L   D1,A0   
//022472 3080                     MOVE.W   D0,(A0)   
      longGear(A3 + D4L) = D0W;
//022474 5246                     ADDQ.W   #1,D6   

//022476 3006                     MOVE.W   D6,D0   
//022478 b045                     CMP.W    D5,D0   
//02247a 6da8                     BLT      $-86 (=0x022424)   
    };
//02247c 3006                     MOVE.W   D6,D0   
//02247e 5246                     ADDQ.W   #1,D6   
//022480 e580                     ASL.L    #2,D0   
//022482 206c a522                MOVE.L   -23262(A4),A0   
//022486 d0c0                     ADD.W    D0,A0   
//022488 4a90                     TST.L    (A0)   
    if (d.ppPointer23262[D6W++] != NULL)
//02248a 671a                     BEQ      $+28 (=0x0224a6)   
    {
//02248c 3007                     MOVE.W   D7,D0   
//02248e e380                     ASL.L    #1,D0   
//022490 206e 0008                MOVE.L   8(A6),A0   
//022494 d0c0                     ADD.W    D0,A0   
//022496 3010                     MOVE.W   (A0),D0   
      P1[D7W] ^= 0xffff;
//022498 4640                     NOT.W    D0     
//02249a 3207                     MOVE.W   D7,D1   
//02249c e381                     ASL.L    #1,D1   
//02249e 206e 0008                MOVE.L   8(A6),A0   
//0224a2 d0c1                     ADD.W    D1,A0   
//0224a4 3080                     MOVE.W   D0,(A0)
    };
//0224a6 5247                     ADDQ.W   #1,D7   
    D7W++;
//0224a8 3007                     MOVE.W   D7,D0   
//0224aa b06e 000c                CMP.W    12(A6),D0   
//0224ae 6d00 ff66                BLT      $-152 (=0x022416)   
  } while (D7W < count);
//0224b2 6052                     BRA      $+84 (=0x022506)   
  for (; D6W<d.NumGraphic; D6W++)
  {
//0224b4 3006                     MOVE.W   D6,D0   
//0224b6 e580                     ASL.L    #2,D0   
//0224b8 206c a522                MOVE.L   -23262(A4),A0   
//0224bc d0c0                     ADD.W    D0,A0   
//0224be 2010                     MOVE.L   (A0),D0   
    A3 = d.ppPointer23262[D6W];
//0224c0 2640                     MOVE.L   D0,A3   
//0224c2 4a80                     TST.L    D0   
//0224c4 673e                     BEQ      $+64 (=0x022504)   
    if (A3 != NULL)
    {
//0224c6 3f06                     MOVE.W   D6,-(A7)   
//0224c8 4eba fa94                JSR      $-1386 (=0x021f5e)   
//0224cc 548f                     ADDQ.L   #2,A7   
      DeleteGraphic(D6W);
//0224ce 3006                     MOVE.W   D6,D0   
//0224d0 e580                     ASL.L    #2,D0   
//0224d2 206c a522                MOVE.L   -23262(A4),A0   
//0224d6 d0c0                     ADD.W    D0,A0   
//0224d8 4290                     CLR.L    (A0)   
      d.ppPointer23262[D6W] = NULL;
//0224da 3806                     MOVE.W   D6,D4   
//0224dc e384                     ASL.L    #1,D4   
//0224de 206c a526                MOVE.L   -23258(A4),A0   
//0224e2 d0c4                     ADD.W    D4,A0   
//0224e4 3810                     MOVE.W   (A0),D4   
      D4W = d.GraphicExpSizes[D6W];
      D4L &= 0xffff;
//0224e6 c8bc 0000 ffff           AND.L    #65535,D4   
//0224ec 2004                     MOVE.L   D4,D0   
//0224ee c0bc 0000 0001           AND.L    #1,D0   
//0224f4 6702                     BEQ      $+4 (=0x0224f8)   
//0224f6 5284                     ADDQ.L   #1,D4   
      D4L += D4L & 1;
//0224f8 2004                     MOVE.L   D4,D0   
//0224fa 4480                     NEG.L    D0   
//0224fc 220b                     MOVE.L   A3,D1   
//0224fe d284                     ADD.L    D4,D1   
//022500 2041                     MOVE.L   D1,A0   
//022502 3080                     MOVE.W   D0,(A0)   
      wordGear(A3 + D4L) = sw(-D4L);
    };
//022504 5246                     ADDQ.W   #1,D6   
//022506 3006                     MOVE.W   D6,D0   
//022508 b06c a532                CMP.W    -23246(A4),D0   
//02250c 65a6                     BCS      $-88 (=0x0224b4)   
  };
//02250e 302c a4e0                MOVE.W   -23328(A4),D0   
//022512 6724                     BEQ      $+38 (=0x022538)   
  if (d.Word23328 != 0)
  {
//022514 282c a4ee                MOVE.L   -23314(A4),D4   
//022518 222c a4f2                MOVE.L   -23310(A4),D1   
//02251c 92ae fffc                SUB.L    -4(A6),D1   
//022520 9881                     SUB.L    D1,D4   
    D4L = d.Pointer23314 - (d.Pointer23310 - iLOCAL_4);
//022522 4a84                     TST.L    D4   
//022524 6f08                     BLE      $+10 (=0x02252e)   
    if (D4L > 0)
    {
//022526 2f04                     MOVE.L   D4,-(A7)   
//022528 4eba fbd0                JSR      $-1070 (=0x0220fa)   
//02252c 588f                     ADDQ.L   #4,A7   
      TAG0220fa(D4L);
    };
//02252e 4eba fc02                JSR      $-1020 (=0x022132)   
    CompactMemory();
//022532 2004                     MOVE.L   D4,D0   
//022534 91ac a4d8                SUB.L    D0,-23336(A4)   
    d.Long23336 -= D4L;
  };
//022538 202c a4f2                MOVE.L   -23310(A4),D0   
//02253c 2440                     MOVE.L   D0,A2    
  A2 = d.Pointer23310;
//02253e 5580                     SUBQ.L   #2,D0   
//022540 2640                     MOVE.L   D0,A3   
  A3 = A2-2;
//022542 6060                     BRA      $+98 (=0x0225a4)   
  while (A3>d.Pointer23314)
  {
//022544 200b                     MOVE.L   A3,D0   
//022546 2040                     MOVE.L   D0,A0   
//022548 3010                     MOVE.W   (A0),D0   
//02254a 3a00                     MOVE.W   D0,D5   
    D5W = wordGear(A3);
//02254c 4a40                     TST.W    D0   
//02254e 6c0a                     BGE      $+12 (=0x02255a)   
    if (D5W < 0)
    {
//022550 3005                     MOVE.W   D5,D0   
//022552 5540                     SUBQ.W   #2,D0   
//022554 48c0                     EXT.L    D0   
//022556 d7c0                     ADD.L    D0,A3   
      A3 += D5W-2;
//022558 604a                     BRA      $+76 (=0x0225a4)   
    }
    else
    {
//02255a 280b                     MOVE.L   A3,D4   
//02255c 3205                     MOVE.W   D5,D1   
//02255e e581                     ASL.L    #2,D1   
//022560 206c a522                MOVE.L   -23262(A4),A0   
//022564 d0c1                     ADD.W    D1,A0   
//022566 2210                     MOVE.L   (A0),D1   
//022568 9881                     SUB.L    D1,D4   
//02256a 2d44 ffe8                MOVE.L   D4,-24(A6)   
      iLOCAL_24 = A3 - d.ppPointer23262[D5W];
//02256e 283c 0000 0002           MOVE.L   #2,D4   
//022574 d8ae ffe8                ADD.L    -24(A6),D4   
      D4L = iLOCAL_24+2;
//022578 95c4                     SUB.L    D4,A2   
//02257a 97c4                     SUB.L    D4,A3   
      A2 -= D4L;
      A3 -= D4L;
//02257c 200b                     MOVE.L   A3,D0   
//02257e 5480                     ADDQ.L   #2,D0   
//022580 b08a                     CMP.L    A2,D0   
//022582 6720                     BEQ      $+34 (=0x0225a4)   
      if (A2 != A3+2)
      {
//022584 2004                     MOVE.L   D4,D0   
//022586 3f00                     MOVE.W   D0,-(A7)   
//022588 2f0a                     MOVE.L   A2,-(A7)   
//02258a 200b                     MOVE.L   A3,D0   
//02258c 5480                     ADDQ.L   #2,D0   
//02258e 2f00                     MOVE.L   D0,-(A7)   
//022590 4ead 0006                JSR      6(A5)    (=0x0009dc)
//022594 defc 000a                ADD.W    #10,A7   
        MemMove(A3+2, A2, D4W);
//022598 3005                     MOVE.W   D5,D0   
//02259a e580                     ASL.L    #2,D0   
//02259c 206c a522                MOVE.L   -23262(A4),A0   
//0225a0 d0c0                     ADD.W    D0,A0   
//0225a2 208a                     MOVE.L   A2,(A0)   
        d.ppPointer23262[D5W] = A2;
      };
    };

//0225a4 200b                     MOVE.L   A3,D0   
//0225a6 b0ac a4ee                CMP.L    -23314(A4),D0   
//0225aa 6e98                     BGT      $-102 (=0x022544)   
  };
//0225ac 4267                     CLR.W    -(A7)   
//0225ae 2f3c 0000 138c           MOVE.L   #5004,-(A7)   
//0225b4 4eba f1a6                JSR      $-3672 (=0x02175c)   
//0225b8 5c8f                     ADDQ.L   #6,A7   
  pLOCAL_12 = allocateMemory(5004,0);
//0225ba 2d40 fff4                MOVE.L   D0,-12(A6)   
//0225be 302c a544                MOVE.W   -23228(A4),D0   
//0225c2 66fa                     BNE      $-4 (=0x0225be)   
  while (d.Word23228 != 0) {};
//0225c4 4247                     CLR.W    D7   
//0225c6 6000 0100                BRA      $+258 (=0x0226c8)   
  for (D7W=0; D7W<count; D7W++)
  {
//0225ca 3007                     MOVE.W   D7,D0   
//0225cc e380                     ASL.L    #1,D0   
//0225ce 206e 0008                MOVE.L   8(A6),A0   
//0225d2 d0c0                     ADD.W    D0,A0   
//0225d4 3010                     MOVE.W   (A0),D0   
//0225d6 3a00                     MOVE.W   D0,D5   
    D5W = P1[D7W];
//0225d8 4a40                     TST.W    D0   
//0225da 6c1e                     BGE      $+32 (=0x0225fa)   
    if (D5W < 0)
    {
//0225dc 3007                     MOVE.W   D7,D0   
//0225de e380                     ASL.L    #1,D0   
//0225e0 206e 0008                MOVE.L   8(A6),A0   
//0225e4 d0c0                     ADD.W    D0,A0   
//0225e6 3010                     MOVE.W   (A0),D0   
      P1[D7W] ^= 0xffff;
//0225e8 4640                     NOT.W    D0   
//0225ea 3207                     MOVE.W   D7,D1   
//0225ec e381                     ASL.L    #1,D1   
//0225ee 206e 0008                MOVE.L   8(A6),A0   
//0225f2 d0c1                     ADD.W    D1,A0   
//0225f4 3080                     MOVE.W   D0,(A0)   
//0225f6 6000 00ce                BRA      $+208 (=0x0226c6)   
    }
    else
    {
//0225fa 200a                     MOVE.L   A2,D0   
//0225fc 5580                     SUBQ.L   #2,D0   
//0225fe 2040                     MOVE.L   D0,A0   
//022600 3085                     MOVE.W   D5,(A0)   
      wordGear(A2-2) = D5W;
//022602 383c 0002                MOVE.W   #2,D4   
//022606 3205                     MOVE.W   D5,D1   
//022608 e381                     ASL.L    #1,D1   
//02260a 206c a526                MOVE.L   -23258(A4),A0   
//02260e d0c1                     ADD.W    D1,A0   
//022610 d850                     ADD.W    (A0),D4   
//022612 c8bc 0000 ffff           AND.L    #65535,D4   
      D4L = (d.GraphicExpSizes[D5W] + 3) & 0xfffe;
//022618 2004                     MOVE.L   D4,D0   
//02261a c0bc 0000 0001           AND.L    #1,D0   
//022620 6702                     BEQ      $+4 (=0x022624)   
//022622 5284                     ADDQ.L   #1,D4   
//022624 95c4                     SUB.L    D4,A2  
      A2 -= D4L;
//022626 302e fff2                MOVE.W   -14(A6),D0   
//02262a 6614                     BNE      $+22 (=0x022640)   
      if (wLOCAL_14 == 0)
      {
//02262c 4267                     CLR.W    -(A7)   
//02262e 4267                     CLR.W    -(A7)   
//022630 4ead 0570                JSR      1392(A5)    (=0x01daa8)
//022634 588f                     ADDQ.L   #4,A7   
        TAG01daa8(_1_, 0,0);
//022636 4eba f6fe                JSR      $-2304 (=0x021d36)   
        openGraphicsFile();
//02263a 3d7c 0001 fff2           MOVE.W   #1,-14(A6)   
        wLOCAL_14 = 1;
      };
//022640 3005                     MOVE.W   D5,D0   
//022642 e380                     ASL.L    #1,D0   
//022644 206c a52a                MOVE.L   -23254(A4),A0   
//022648 d0c0                     ADD.W    D0,A0   
//02264a 3010                     MOVE.W   (A0),D0   
      D0W = d.GraphicSizes[D5W];
//02264c 3205                     MOVE.W   D5,D1   
//02264e e381                     ASL.L    #1,D1   
//022650 206c a526                MOVE.L   -23258(A4),A0   
//022654 d0c1                     ADD.W    D1,A0   
//022656 b050                     CMP.W    (A0),D0   
//022658 6756                     BEQ      $+88 (=0x0226b0)   
      if (d.GraphicExpSizes[D5W] != D0W)
      {
//02265a 4267                     CLR.W    -(A7)   
//02265c 3f2c a536                MOVE.W   -23242(A4),-(A7)   
//022660 3f05                     MOVE.W   D5,-(A7)   
//022662 4eba f0b0                JSR      $-3918 (=0x021714)   
//022666 548f                     ADDQ.L   #2,A7   
//022668 2f00                     MOVE.L   D0,-(A7)   
//02266a 3f3c 0042                MOVE.W   #66,-(A7)   
//02266e 4ead 0096                JSR      150(A5)    (=0x001cf8)
//022672 defc 000a                ADD.W    #10,A7   
        LSEEK(LocateNthGraphic(D5W), // file address
              d.GraphicHandle,       // handle
              0);                    // relative to start of file
//022676 4a80                     TST.L    D0   
//022678 5cc0                     SGE      D0   
//02267a c07c 0001                AND.W    #1,D0   
//02267e 2f2e fff4                MOVE.L   -12(A6),-(A7)   
//022682 2f2c d25e                MOVE.L   -11682(A4),-(A7)   
//022686 2f0a                     MOVE.L   A2,-(A7)   
//022688 3005                     MOVE.W   D5,D0   
//02268a e380                     ASL.L    #1,D0   
//02268c 206c a52a                MOVE.L   -23254(A4),A0   
//022690 d0c0                     ADD.W    D0,A0   
//022692 3010                     MOVE.W   (A0),D0   
//022694 c0bc 0000 ffff           AND.L    #65535,D0   
//02269a 2f00                     MOVE.L   D0,-(A7)   
//02269c 3f2c a536                MOVE.W   -23242(A4),-(A7)   
//0226a0 4eba 08c2                JSR      $+2244 (=0x022f64)   
//0226a4 defc 0012                ADD.W    #18,A7   
        LZWExpand(d.GraphicHandle,    
                  d.GraphicSizes[D5W],
                  A2,   // dest
                  d.pViewportBMP,   // scratch area
                  pLOCAL_12);   // stack area
                  
//0226a8 397c 0001 d25c           MOVE.W   #1,-11684(A4)   
        d.Word11684 = 1;
//0226ae 600a                     BRA      $+12 (=0x0226ba)   
      }
      else
      {
//0226b0 2f0a                     MOVE.L   A2,-(A7)   
//0226b2 3f05                     MOVE.W   D5,-(A7)   
//0226b4 4eba f43c                JSR      $-3010 (=0x021af2)   
//0226b8 5c8f                     ADDQ.L   #6,A7   
        ReadGraphic(D5W, A2);
      };
//0226ba 3005                     MOVE.W   D5,D0   
//0226bc e580                     ASL.L    #2,D0   
//0226be 206c a522                MOVE.L   -23262(A4),A0   
//0226c2 d0c0                     ADD.W    D0,A0   
//0226c4 208a                     MOVE.L   A2,(A0)   
      d.ppPointer23262[D5W] = A2;
    };
//0226c6 5247                     ADDQ.W   #1,D7   
//
//0226c8 3007                     MOVE.W   D7,D0   
//0226ca b06e 000c                CMP.W    12(A6),D0   
//0226ce 6d00 fefa                BLT      $-260 (=0x0225ca)   
  };
//0226d2 302e fff2                MOVE.W   -14(A6),D0   
//0226d6 6704                     BEQ      $+6 (=0x0226dc)   
  if (wLOCAL_14 != 0) closeGraphicsFile();
//0226d8 4eba f69c                JSR      $-2402 (=0x021d76)   
//0226dc 294a a4ee                MOVE.L   A2,-23314(A4)   
  d.Pointer23314 = A2;
//0226e0 302c a4e0                MOVE.W   -23328(A4),D0   
//0226e4 6706                     BEQ      $+8 (=0x0226ec)   
  if (d.Word23328 != 0) d.Pointer23284 = d.Pointer23314;
//0226e6 296c a4ee a50c           MOVE.L   -23314(A4),-23284(A4)   
//0226ec 6100 eb46                BSR      $-5304 (=0x021234)   
  TAG021234();
//0226f0 601a                     BRA      $+28 (=0x02270c)   
//0226f2 4e71                     NOP         
//0226f4 4e71                     NOP         
//0226f6 4e71                     NOP         
//0226f8 4e71                     NOP         
//0226fa 4e71                     NOP         
//0226fc 4e71                     NOP         
//0226fe 4e71                     NOP         
//022700 4e71                     NOP         
//022702 4e71                     NOP         
//022704 4e71                     NOP         
//022706 4e71                     NOP         
//022708 4e71                     NOP         
//02270a 4e71                     NOP         
//02270c 2f3c 0000 138c           MOVE.L   #5004,-(A7)   
//022712 4eba f0c4                JSR      $-3898 (=0x0217d8)   
//022716 588f                     ADDQ.L   #4,A7   
  FreeTempMemory(5004);
//022718 4cdf 0cf0                MOVEM.L  (A7)+,D4567A23   
//02271c 4e5e                     UNLK     A6   
//02271e 4e75                     RTS         
  RETURN;
}