#include "stdafx.h"

#include "UI.h"

#include <stdio.h>

#include "Objects.h"
#include "Dispatch.h"
#include "CSB.h"
#include "Data.h"

//***********************************************************
//
//***********************************************************
//  TAG00dd90
i16 LaunchMissile(
              RN object,
              i32 mapX,
              i32 mapY,
              i32 pos,
              i32 dir,
              i32 P6,
              i32 P7,
              i32 P8)
{ //(i16)
  dReg D0, D1, D3;
  RN objD6;
  DB14 *DB14A3;
  TIMER timer;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//00dd90 4e56 fff6                LINK     A6,#-10
//00dd94 48e7 0310                MOVEM.L  D67A3,-(A7)
//00dd98 3e2e 0008                MOVE.W   8(A6),D7
//00dd9c 3f3c 000e                MOVE.W   #14,-(A7)
//00dda0 4ead 0228                JSR      552(A5)    (=0x00a0b0)
//00dda4 548f                     ADDQ.L   #2,A7
//00dda6 3c00                     MOVE.W   D0,D6
  objD6 = FindEmptyDB14Entry(false);
//00dda8 0c40 ffff                CMP.W    #65535,D0
//00ddac 6604                     BNE      $+6 (=0x00ddb2)
//00ddae 6000 00f0                BRA      $+242 (=0x00dea0)
  if (objD6 == RNnul) return (-1);
//00ddb2 3006                     MOVE.W   D6,D0
//00ddb4 c07c 3fff                AND.W    #16383,D0
//00ddb8 322e 000e                MOVE.W   14(A6),D1
//00ddbc ed41                     ASL.W    #6,D1
//00ddbe e141                     ASL.W    #8,D1
//00ddc0 8041                     OR.W     D1,D0
//00ddc2 3c00                     MOVE.W   D0,D6
  objD6.pos(pos);
//00ddc4 3f06                     MOVE.W   D6,-(A7)
//00ddc6 4ead 0312                JSR      786(A5)    (=0x009984)
//00ddca 548f                     ADDQ.L   #2,A7
//00ddcc 2640                     MOVE.L   D0,A3
  DB14A3 = GetRecordAddressDB14(objD6);
//00ddce 3747 0002                MOVE.W   D7,2(A3)
  DB14A3->flyingObject(object);
//00ddd2 3f3c 00ff                MOVE.W   #255,-(A7)
//00ddd6 4240                     CLR.W    D0
//00ddd8 102e 0013                MOVE.B   19(A6),D0
//00dddc 3f00                     MOVE.W   D0,-(A7)
//00ddde 4ead 00d8                JSR      216(A5)    (=0x000fe2=Min)
//00dde2 588f                     ADDQ.L   #4,A7
//00dde4 1740 0004                MOVE.B   D0,4(A3)
  DB14A3->energyRemaining(Smaller(ub(P6), 255));
//00dde8 176e 0015 0005           MOVE.B   21(A6),5(A3)
  DB14A3->energyRemaining2(ub(P7));
//00ddee 3f2e 000c                MOVE.W   12(A6),-(A7)
//00ddf2 3f2e 000a                MOVE.W   10(A6),-(A7)
//00ddf6 4267                     CLR.W    -(A7)
//00ddf8 3f06                     MOVE.W   D6,-(A7)
//00ddfa 4ead 02f4                JSR      756(A5)    (=0x009b08)
//00ddfe 508f                     ADDQ.L   #0,A7
  AddObjectToRoom(objD6, RN(RNempty), mapX, mapY);
//00de00 202c d23a                MOVE.L   -11718(A4),D0
//00de04 5280                     ADDQ.L   #1,D0
  D0L = d.Time+1;
//00de06 322c d746                MOVE.W   -10426(A4),D1
//00de0a 48c1                     EXT.L    D1
  D1L = d.LoadedLevel << 24;
//00de0c 263c 0000 0018           MOVE.L   #24,D3
//00de12 e7a1                     ASL.L    D3,D1
//00de14 8081                     OR.L     D1,D0
//00de16 2d40 fff6                MOVE.L   D0,-10(A6)
  timer.time = D0L | D1L;
//00de1a 302c cd60                MOVE.W   -12960(A4),D0
//00de1e 6708                     BEQ      $+10 (=0x00de28)
  if (d.Word12960 != 0)
  {
//00de20 1d7c 0031 fffa           MOVE.B   #49,-6(A6)
//00de26 6006                     BRA      $+8 (=0x00de2e)
    timer.function = 49;
  }
  else
  {
//00de28 1d7c 0030 fffa           MOVE.B   #48,-6(A6)
    timer.function = 48;
  };
//00de2e 422e fffb                CLR.B    -5(A6)
  timer.uByte5 = 0;
//00de32 3d46 fffc                MOVE.W   D6,-4(A6)
  timer.word6() = objD6.ConvertToInteger();
//00de36 302e 000a                MOVE.W   10(A6),D0
//00de3a c07c 001f                AND.W    #31,D0
//00de3e 3600                     MOVE.W   D0,D3
  D3W = (I16)(mapX & 31);
//00de40 026e ffe0 fffe           AND.W    #65504,-2(A6)
//00de46 876e fffe                OR.W     D3,-2(A6)
  timer.word8() = (I16)((timer.word8() & 0xffe0) | D3W);
//00de4a 302e 000c                MOVE.W   12(A6),D0
//00de4e c07c 001f                AND.W    #31,D0
//00de52 3600                     MOVE.W   D0,D3
//00de54 eb43                     ASL.W    #5,D3
//00de56 026e fc1f fffe           AND.W    #64543,-2(A6)
//00de5c 876e fffe                OR.W     D3,-2(A6)
  timer.word8() = (I16)((timer.word8() & 0xfc1f) | ((mapY & 31) << 5));
//00de60 4240                     CLR.W    D0
//00de62 102e 0017                MOVE.B   23(A6),D0
//00de66 c07c 000f                AND.W    #15,D0
//00de6a 3600                     MOVE.W   D0,D3
  D3W = (I16)(P8 & 15);
//00de6c e943                     ASL.W    #4,D3
//00de6e e143                     ASL.W    #8,D3
//00de70 026e 0fff fffe           AND.W    #4095,-2(A6)
//00de76 876e fffe                OR.W     D3,-2(A6)
  timer.word8() = (I16)((timer.word8() & 0x0fff) | (D3W << 12));
//00de7a 302e 0010                MOVE.W   16(A6),D0
//00de7e c07c 0003                AND.W    #3,D0
//00de82 3600                     MOVE.W   D0,D3
//00de84 e543                     ASL.W    #2,D3
//00de86 e143                     ASL.W    #8,D3
//00de88 026e f3ff fffe           AND.W    #62463,-2(A6)
//00de8e 876e fffe                OR.W     D3,-2(A6)
  timer.word8() = (I16)((timer.word8() & 0xf3ff) | ((dir & 3) << 10));
//00de92 486e fff6                PEA      -10(A6)
//00de96 4eba 2126                JSR      $+8488 (=0x00ffbe)
//00de9a 588f                     ADDQ.L   #4,A7
//00de9c 3740 0006                MOVE.W   D0,6(A3)
  DB14A3->timerIndex(SetTimer(&timer));
//00dea0 4cdf 08c0                MOVEM.L  (A7)+,D67A3
//00dea4 4e5e                     UNLK     A6
//00dea6 4e75                     RTS
  return sw((DB14A3->timerIndex()));
}


//***********************************************************
//
//***********************************************************
//   TAG01605a
void AdjustSkills(i32 chIdx,i32 skillNumber,i32 Experience)
{//(void)
  static dReg D0, D1, D5, D6, D7;
  static SKILL *psA3;
  static CHARDESC *pcA2;
  static i16 w_26;
  static i16 w_16;
  static i16 w_6;
  static i16 w_4;
  static i16 w_2;
  static i32 Increment;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//01605a 4e56 ffe6                LINK     A6,#-26
//01605e 48e7 0f30                MOVEM.L  D4567A23,-(A7)
//016062 3e2e 000c                MOVE.W   12(A6),D7
  ASSERT( (skillNumber>=0) && (skillNumber<=19));
  D7W = sw(Experience);
//016066 0c6e 0004 000a           CMP.W    #4,10(A6)
//01606c 6520                     BCS      $+34 (=0x01608e)
//01606e 0c6e 000b 000a           CMP.W    #11,10(A6)
//016074 6218                     BHI      $+26 (=0x01608e)
  if ( (skillNumber >= 4) && (skillNumber <= 11) )
  {
//016076 202c cd6a                MOVE.L   -12950(A4),D0
//01607a 222c d23a                MOVE.L   -11718(A4),D1
//01607e 92bc 0000 0096           SUB.L    #150,D1
//016084 b081                     CMP.L    D1,D0
//016086 6c06                     BGE      $+8 (=0x01608e)
    if (d.Long12950 < d.Time-150)
    {
//016088 3007                     MOVE.W   D7,D0
//01608a e248                     LSR.W    #1,D0
//01608c 3e00                     MOVE.W   D0,D7
      D7W /= 2;
    };
  };
//01608e 3007                     MOVE.W   D7,D0
//016090 6700 02e8                BEQ      $+746 (=0x01637a)
  if (D7W == 0) return;
//016094 206c d750                MOVE.L   -10416(A4),A0
//016098 3c28 000c                MOVE.W   12(A0),D6
//01609c cc7c f000                AND.W    #61440,D6
//0160a0 e84e                     LSR.W    #4,D6
//0160a2 e04e                     LSR.W    #8,D6
  D6W = d.pCurLevelDesc->experienceMultiplier();
//0160a4 6706                     BEQ      $+8 (=0x0160ac)
  if (D6W != 0)
  {
//0160a6 3007                     MOVE.W   D7,D0
//0160a8 c0c6                     MULU     D6,D0
//0160aa 3e00                     MOVE.W   D0,D7
    D7W = sw(D7W * D6W);
  };
//0160ac 302e 0008                MOVE.W   8(A6),D0
//0160b0 c1fc 0320                MULS     #800,D0
//0160b4 41ec bf9e                LEA      -16482(A4),A0
//0160b8 d0c0                     ADD.W    D0,A0
//0160ba 41d0                     LEA      (A0),A0
//0160bc 2448                     MOVE.L   A0,A2
  pcA2 = &d.CH16482[chIdx];
//0160be 0c6e 0004 000a           CMP.W    #4,10(A6)
//0160c4 650a                     BCS      $+12 (=0x0160d0)
  if (skillNumber >= 4)
  {
//0160c6 3a2e 000a                MOVE.W   10(A6),D5
//0160ca 5945                     SUBQ.W   #4,D5
//0160cc e44d                     LSR.W    #2,D5
    D5W = sw((skillNumber-4)/4);
//0160ce 6004                     BRA      $+6 (=0x0160d4)
  }
  else
  {
//0160d0 3a2e 000a                MOVE.W   10(A6),D5
    D5W = sw(skillNumber);
  };
//0160d4 282b 0002                MOVE.L   2(A3),D4   // What is this???
//0160d8 3005                     MOVE.W   D5,D0
//0160da 807c c000                OR.W     #49152,D0
//0160de 3f00                     MOVE.W   D0,-(A7)
//0160e0 3f2e 0008                MOVE.W   8(A6),-(A7)
//0160e4 4eba fe38                JSR      $-454 (=0x015f1e=DetermineMastery)
//0160e8 588f                     ADDQ.L   #4,A7
//0160ea 3c00                     MOVE.W   D0,D6
  D6W = (i16)DetermineMastery(chIdx, D5W | 0xc000);
//0160ec 0c6e 0004 000a           CMP.W    #4,10(A6)
//0160f2 6518                     BCS      $+26 (=0x01610c)
  if (skillNumber >= 4)
  {
//0160f4 202c cd6a                MOVE.L   -12950(A4),D0
//0160f8 222c d23a                MOVE.L   -11718(A4),D1
//0160fc 92bc 0000 0019           SUB.L    #25,D1
//016102 b081                     CMP.L    D1,D0
//016104 6f06                     BLE      $+8 (=0x01610c)
    if (d.Long12950 > d.Time-25)
    {
//016106 3007                     MOVE.W   D7,D0
//016108 e340                     ASL.W    #1,D0
//01610a 3e00                     MOVE.W   D0,D7
      D7W *= 2;
    };
  };
//01610c 302e 000a                MOVE.W   10(A6),D0
//016110 c1fc 0006                MULS     #6,D0
//016114 41ea 005c                LEA      92(A2),A0
//016118 d0c0                     ADD.W    D0,A0
//01611a 41d0                     LEA      (A0),A0
//01611c 2648                     MOVE.L   A0,A3
  psA3 = &pcA2->skills92[skillNumber];
//01611e 3007                     MOVE.W   D7,D0
//016120 c0bc 0000 ffff           AND.L    #65535,D0
//016126 d1ab 0002                ADD.L    D0,2(A3)
  psA3->Long2 += (UI16)(D7W);
  MostRecentlyAdjustedSkills[AdjustedSkillNumber] = skillNumber;
  LatestSkillValues[AdjustedSkillNumber] = psA3->Long2;
  AdjustedSkillNumber = (AdjustedSkillNumber + 1)%2;
//01612a 0c53 7d00                CMP.W    #32000,(A3)
//01612e 6c16                     BGE      $+24 (=0x016146)
  if (psA3->word0 < 32000)
  {
//016130 3f3c 0064                MOVE.W   #100,-(A7)
//016134 3007                     MOVE.W   D7,D0
//016136 e648                     LSR.W    #3,D0
//016138 3f00                     MOVE.W   D0,-(A7)
//01613a 3f3c 0001                MOVE.W   #1,-(A7)
//01613e 4ead 007e                JSR      126(A5)    (=0x00100e)
//016142 5c8f                     ADDQ.L   #6,A7
//016144 d153                     ADD.W    D0,(A3)
    psA3->word0 = sw(psA3->word0 + ApplyLimits(1, D7W/8, 100));
  };
//016146 3005                     MOVE.W   D5,D0
//016148 c1fc 0006                MULS     #6,D0
//01614c 41ea 005c                LEA      92(A2),A0
//016150 d0c0                     ADD.W    D0,A0
//016152 41d0                     LEA      (A0),A0
//016154 2648                     MOVE.L   A0,A3
  psA3 = &pcA2->skills92[D5W];
//016156 0c6e 0004 000a           CMP.W    #4,10(A6)
//01615c 650c                     BCS      $+14 (=0x01616a)
  if (skillNumber >= 4)
  {
//01615e 3007                     MOVE.W   D7,D0
//016160 c0bc 0000 ffff           AND.L    #65535,D0
//016166 d1ab 0002                ADD.L    D0,2(A3)
    psA3->Long2 += (UI16)(D7W);
  };
//01616a 3005                     MOVE.W   D5,D0
//01616c 807c c000                OR.W     #49152,D0
//016170 3f00                     MOVE.W   D0,-(A7)
//016172 3f2e 0008                MOVE.W   8(A6),-(A7)
//016176 4eba fda6                JSR      $-600 (=0x015f1e=DetermineMastery)
//01617a 588f                     ADDQ.L   #4,A7
//01617c 3e00                     MOVE.W   D0,D7
  D7W = (i16)DetermineMastery(chIdx, D5W | 0xc000);
//01617e 3007                     MOVE.W   D7,D0
//016180 b046                     CMP.W    D6,D0
//016182 6300 01f6                BLS      $+504 (=0x01637a)
  if (D7W <= D6W) return;
//016186 3d47 fffa                MOVE.W   D7,-6(A6)
  w_6 = D7W;
//01618a 4ead 0084                JSR      132(A5)    (=0x001050)
  D0L = STRandomBool();
//01618e 3d40 fffe                MOVE.W   D0,-2(A6)
  w_2 = D0W;
//016192 4ead 0084                JSR      132(A5)    (=0x001050)
  D1L = STRandomBool();
//016196 2200                     MOVE.L   D0,D1
//016198 303c 0001                MOVE.W   #1,D0
//01619c d041                     ADD.W    D1,D0
//01619e 3d40 fffc                MOVE.W   D0,-4(A6)
  w_4 = sw(D1W + 1);
//0161a2 4ead 0084                JSR      132(A5)    (=0x001050)
//0161a6 3c00                     MOVE.W   D0,D6
  D6W = STRandomBool();
//0161a8 0c45 0002                CMP.W    #2,D5
//0161ac 6702                     BEQ      $+4 (=0x0161b0)
  if (D5W != 2)
  {
//0161ae cc47                     AND.W    D7,D6
    D6W &= D7W;
  };
//0161b0 3006                     MOVE.W   D6,D0
//0161b2 d12a 0052                ADD.B    D0,82(A2)
  pcA2->Attributes[Vitality].IncrMaximum(D6W);
//0161b6 3c2a 003a                MOVE.W   58(A2),D6
  D6W = pcA2->maxStamina;
//0161ba 4ead 0084                JSR      132(A5)    (=0x001050)
//0161be 3207                     MOVE.W   D7,D1
//0161c0 4641                     NOT.W    D1
//0161c2 c041                     AND.W    D1,D0
//0161c4 d12a 0058                ADD.B    D0,88(A2)
  Increment = STRandomBool() & (~D7W);
  pcA2->Attributes[AntiFire].IncrMaximum(Increment);
//0161c8 3005                     MOVE.W   D5,D0
  switch (D5W)
  {
//0161ca 4a40                     TST.W    D0
//0161cc 6702                     BEQ      $+4 (=0x0161d0)
//0161ce 6022                     BRA      $+36 (=0x0161f2)
  case 0:
//0161d0 3006                     MOVE.W   D6,D0
//0161d2 e848                     LSR.W    #4,D0
//0161d4 3c00                     MOVE.W   D0,D6
    D6W /= 16;
//0161d6 3007                     MOVE.W   D7,D0
//0161d8 c0fc 0003                MULU     #3,D0
//0161dc 3e00                     MOVE.W   D0,D7
    D7W *= 3;
//0161de 302e fffc                MOVE.W   -4(A6),D0
//0161e2 d12a 0049                ADD.B    D0,73(A2)
    pcA2->Attributes[Strength].IncrMaximum(w_4);
//0161e6 302e fffe                MOVE.W   -2(A6),D0
//0161ea d12a 004c                ADD.B    D0,76(A2)
    pcA2->Attributes[Dexterity].IncrMaximum(w_2);
//0161ee 6000 00c2                BRA      $+196 (=0x0162b2)
    break;

//0161f2 b07c 0001                CMP.W    #1,D0
//0161f6 6702                     BEQ      $+4 (=0x0161fa)
//0161f8 6028                     BRA      $+42 (=0x016222)
  case 1:
//0161fa 3006                     MOVE.W   D6,D0
//0161fc c0bc 0000 ffff           AND.L    #65535,D0
//016202 80fc 0015                DIVU     #21,D0
//016206 3c00                     MOVE.W   D0,D6
    D6W = sw(D6W / 21);
//016208 3007                     MOVE.W   D7,D0
//01620a e340                     ASL.W    #1,D0
//01620c 3e00                     MOVE.W   D0,D7
    D7W = sw(2 * D7W);
//01620e 302e fffe                MOVE.W   -2(A6),D0
//016212 d12a 0049                ADD.B    D0,73(A2)
    pcA2->Attributes[Strength].IncrMaximum(w_2) ;
//016216 302e fffc                MOVE.W   -4(A6),D0
//01621a d12a 004c                ADD.B    D0,76(A2)
    pcA2->Attributes[Dexterity].IncrMaximum(w_4);
//01621e 6000 0092                BRA      $+148 (=0x0162b2)
    break;
//016222 b07c 0003                CMP.W    #3,D0
//016226 6702                     BEQ      $+4 (=0x01622a)
//016228 601c                     BRA      $+30 (=0x016246)
  case 3:
//01622a 3006                     MOVE.W   D6,D0
//01622c ea48                     LSR.W    #5,D0
//01622e 3c00                     MOVE.W   D0,D6
    D6W = sw(D6W / 32);
//016230 3007                     MOVE.W   D7,D0
//016232 3207                     MOVE.W   D7,D1
//016234 e249                     LSR.W    #1,D1
    //D0W = D7W;
    //D1W = D7W / 2;
//016236 d041                     ADD.W    D1,D0
//016238 d16a 003e                ADD.W    D0,62(A2)
    pcA2->maxMana = sw(pcA2->maxMana + D7W + D7W/2);
//01623c 302e fffc                MOVE.W   -4(A6),D0
//016240 d12a 004f                ADD.B    D0,79(A2)
    pcA2->Attributes[Wisdom].IncrMaximum(w_4);
//016244 602c                     BRA      $+46 (=0x016272)
    goto tag016272;
//016246 b07c 0002                CMP.W    #2,D0
//01624a 6702                     BEQ      $+4 (=0x01624e)
//01624c 6064                     BRA      $+102 (=0x0162b2)
  case 2:
//01624e 3006                     MOVE.W   D6,D0
//016250 c0bc 0000 ffff           AND.L    #65535,D0
//016256 80fc 0019                DIVU     #25,D0
//01625a 3c00                     MOVE.W   D0,D6
    D6W = sw(D6W / 25);
//01625c 3007                     MOVE.W   D7,D0
//01625e d16a 003e                ADD.W    D0,62(A2)
    pcA2->maxMana = sw(pcA2->maxMana + D7W);
//016262 3007                     MOVE.W   D7,D0
//016264 5240                     ADDQ.W   #1,D0
//016266 e248                     LSR.W    #1,D0
//016268 de40                     ADD.W    D0,D7
    D7W = sw(D7W + (D7W+1)/2);
//01626a 302e fffe                MOVE.W   -2(A6),D0
//01626e d12a 004f                ADD.B    D0,79(A2)
    pcA2->Attributes[Wisdom].IncrMaximum(w_2);
tag016272:
//016272 302e fffa                MOVE.W   -6(A6),D0
//016276 5340                     SUBQ.W   #1,D0
//016278 3f00                     MOVE.W   D0,-(A7)
//01627a 4ead 009c                JSR      156(A5)    (=0x001074)
//01627e 3f00                     MOVE.W   D0,-(A7)
//016280 4ead 00d8                JSR      216(A5)    (=0x000fe2=Min)
//016284 588f                     ADDQ.L   #4,A7
//016286 2200                     MOVE.L   D0,D1
    D1L = Smaller(STRandom0_3(), w_6-1);
//016288 302a 003e                MOVE.W   62(A2),D0
//01628c d041                     ADD.W    D1,D0
//01628e 3540 003e                MOVE.W   D0,62(A2)
    pcA2->maxMana = sw(pcA2->maxMana + D1W);
//016292 0c40 0384                CMP.W    #900,D0
//016296 6f06                     BLE      $+8 (=0x01629e)
    if (pcA2->maxMana > 900)
    {
//016298 357c 0384 003e           MOVE.W   #900,62(A2)
      pcA2->maxMana = 900;
    };
//01629e 4ead 0090                JSR      144(A5)    (=0x001030=Random)
//0162a2 c0bc 0000 ffff           AND.L    #65535,D0
//0162a8 80fc 0003                DIVU     #3,D0
//0162ac 4840                     SWAP     D0
//0162ae d12a 0055                ADD.B    D0,85(A2)
    pcA2->Attributes[AntiMagic].IncrMaximum(STRandom(3));
  };
//0162b2 4ead 0090                JSR      144(A5)    (=0x001030=Random)
//0162b6 2200                     MOVE.L   D0,D1
//0162b8 3007                     MOVE.W   D7,D0
//0162ba e248                     LSR.W    #1,D0
//0162bc 5240                     ADDQ.W   #1,D0
//0162be c2bc 0000 ffff           AND.L    #65535,D1
//0162c4 82c0                     DIVU     D0,D1
//0162c6 4841                     SWAP     D1
//0162c8 3d41 fff0                MOVE.W   D1,-16(A6)
  w_16 = uw(STRandom(((UI16)D7W / 2) + 1));
//0162cc 3207                     MOVE.W   D7,D1
//0162ce d26e fff0                ADD.W    -16(A6),D1
//0162d2 302a 0036                MOVE.W   54(A2),D0
//0162d6 d041                     ADD.W    D1,D0
//0162d8 3540 0036                MOVE.W   D0,54(A2)
  pcA2->maxHP = sw(pcA2->maxHP + D7W + w_16);
//0162dc b07c 03e7                CMP.W    #999,D0
//0162e0 6f06                     BLE      $+8 (=0x0162e8)
  if (pcA2->maxHP > 999)
  {
//0162e2 357c 03e7 0036           MOVE.W   #999,54(A2)
    pcA2->maxHP = 999;
  };
//0162e8 4ead 0090                JSR      144(A5)    (=0x001030=Random)
//0162ec 2200                     MOVE.L   D0,D1
//0162ee 3006                     MOVE.W   D6,D0
//0162f0 e248                     LSR.W    #1,D0
//0162f2 5240                     ADDQ.W   #1,D0
//0162f4 c2bc 0000 ffff           AND.L    #65535,D1
//0162fa 82c0                     DIVU     D0,D1
//0162fc 4841                     SWAP     D1
//0162fe 3d41 ffe6                MOVE.W   D1,-26(A6)
  w_26 = uw(STRandom(((UI16)D6W/2)+1));
//016302 3206                     MOVE.W   D6,D1
//016304 d26e ffe6                ADD.W    -26(A6),D1
//016308 302a 003a                MOVE.W   58(A2),D0
//01630c d041                     ADD.W    D1,D0
//01630e 3540 003a                MOVE.W   D0,58(A2)
  pcA2->maxStamina = sw(pcA2->maxStamina + D6W + w_26);
//016312 b07c 270f                CMP.W    #9999,D0
//016316 6f06                     BLE      $+8 (=0x01631e)
  if (pcA2->maxStamina >9999)
  {
//016318 357c 270f 003a           MOVE.W   #9999,58(A2)
    pcA2->maxStamina = 9999;
  };
//01631e 006a 0100 0030           OR.W     #256,48(A2)
  pcA2->word48 |= 0x100;
//016324 3f2e 0008                MOVE.W   8(A6),-(A7)
//016328 4eba eab6                JSR      $-5448 (=0x014de0)
  DrawCharacterState(chIdx);
//01632c 548f                     ADDQ.L   #2,A7
//01632e 4ead 00ba                JSR      186(A5)    (=0x001c02)
  PrintLinefeed();
//016332 41d2                     LEA      (A2),A0
//016334 2f08                     MOVE.L   A0,-(A7)
//016336 302e 0008                MOVE.W   8(A6),D0
//01633a 41ec fa96                LEA      -1386(A4),A0
//01633e d0c0                     ADD.W    D0,A0
//016340 4240                     CLR.W    D0
//016342 1010                     MOVE.B   (A0),D0
//016344 3e00                     MOVE.W   D0,D7
//016346 3f00                     MOVE.W   D0,-(A7)
//016348 4ead 00c0                JSR      192(A5)    (=0x001aa8)
//01634c 5c8f                     ADDQ.L   #6,A7
  QuePrintLines(D7W = (UI8)(d.Byte1386[chIdx]), pcA2->name);
//01634e 486c 007a                PEA      122(A4)
//016352 3f07                     MOVE.W   D7,-(A7)
//016354 4ead 00c0                JSR      192(A5)    (=0x001aa8)
//016358 5c8f                     ADDQ.L   #6,A7
  QuePrintLines(D7W, " JUST GAINED A ");
//01635a 3005                     MOVE.W   D5,D0
//01635c e580                     ASL.L    #2,D0
//01635e 41ec bf2c                LEA      -16596(A4),A0
//016362 d0c0                     ADD.W    D0,A0
//016364 2f10                     MOVE.L   (A0),-(A7)
//016366 3f07                     MOVE.W   D7,-(A7)
//016368 4ead 00c0                JSR      192(A5)    (=0x001aa8)
//01636c 5c8f                     ADDQ.L   #6,A7
  QuePrintLines(D7W, d.Pointer16596[D5W]); //"FIGHTER", "NINJA", etc
//01636e 486c 008a                PEA      138(A4)
//016372 3f07                     MOVE.W   D7,-(A7)
//016374 4ead 00c0                JSR      192(A5)    (=0x001aa8)
//016378 5c8f                     ADDQ.L   #6,A7
  QuePrintLines(D7W, " LEVEL");
//01637a 4cdf 0cf0                MOVEM.L  (A7)+,D4567A23
//01637e 4e5e                     UNLK     A6
//016380 4e75                     RTS
}

//***********************************************************
//
//***********************************************************
//  TAG017498
i16 LaunchObject(CHARDESC * pChar,RN object,i32 P3,i32 P4,i32 P5)
{//(i16)
  dReg D7;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//017498 4e56 0000                LINK     A6,#0
//01749c 48e7 0110                MOVEM.L  D7A3,-(A7)
//0174a0 266e 0008                MOVE.L   8(A6),A3
//0174a4 4247                     CLR.W    D7
//0174a6 1e2b 001c                MOVE.B   28(A3),D7
  D7W = pChar->facing;
//0174aa 3f2e 0012                MOVE.W   18(A6),-(A7)
//0174ae 3f2e 0010                MOVE.W   16(A6),-(A7)
//0174b2 3f2e 000e                MOVE.W   14(A6),-(A7)
//0174b6 3f07                     MOVE.W   D7,-(A7)
//0174b8 4240                     CLR.W    D0
//0174ba 102b 001d                MOVE.B   29(A3),D0
//0174be 9047                     SUB.W    D7,D0
//0174c0 5240                     ADDQ.W   #1,D0
//0174c2 c07c 0002                AND.W    #2,D0
//0174c6 e248                     LSR.W    #1,D0
//0174c8 d047                     ADD.W    D7,D0
//0174ca c07c 0003                AND.W    #3,D0
//0174ce 3f00                     MOVE.W   D0,-(A7)
//0174d0 3f2c d248                MOVE.W   -11704(A4),-(A7)
//0174d4 3f2c d24a                MOVE.W   -11702(A4),-(A7)
//0174d8 3f2e 000c                MOVE.W   12(A6),-(A7)
//0174dc 4ead 03a8                JSR      936(A5)    (=0x00dd90)
//0174e0 defc 0010                ADD.W    #16,A7
  return LaunchMissile(
                object,
                d.partyX,
                d.partyY,
                ((((pChar->position-D7W+1)&2)>>1)+D7W)&3,
                D7W,
                P3,
                P4,
                P5);
//0174e4 4cdf 0880                MOVEM.L  (A7)+,D7A3
//0174e8 4e5e                     UNLK     A6
//0174ea 4e75                     RTS
}

//***********************************************************
//
//***********************************************************
i16 TAG0174ec(i32 chIdx, RN object, i32 P3, i32 neededMana)
{//(i16)
  dReg D1, D6, D7;
  CHARDESC *pcA3;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//0174ec 4e56 0000                LINK     A6,#0
//0174f0 48e7 0310                MOVEM.L  D67A3,-(A7)
//0174f4 3e2e 000c                MOVE.W   12(A6),D7
  D7W = sw(P3);
//0174f8 302e 0008                MOVE.W   8(A6),D0
//0174fc c1fc 0320                MULS     #800,D0
//017500 41ec bf9e                LEA      -16482(A4),A0
//017504 d0c0                     ADD.W    D0,A0
//017506 41d0                     LEA      (A0),A0
//017508 2648                     MOVE.L   A0,A3
  pcA3 = &d.CH16482[chIdx];
//01750a 302b 003c                MOVE.W   60(A3),D0
//01750e b06e 000e                CMP.W    14(A6),D0
//017512 6406                     BCC      $+8 (=0x01751a)
  if (pcA3->mana < neededMana)
  {
//017514 303c 0000                MOVE.W   #0,D0
//017518 604e                     BRA      $+80 (=0x017568)
    return 0;
  }
//01751a 302e 000e                MOVE.W   14(A6),D0
//01751e 916b 003c                SUB.W    D0,60(A3)
  pcA3->mana = sw(pcA3->mana - neededMana);
//017522 006b 0100 0030           OR.W     #256,48(A3)
  pcA3->word48 |= 0x100;
//017528 302b 003e                MOVE.W   62(A3),D0
//01752c e640                     ASR.W    #3,D0
//01752e 3f00                     MOVE.W   D0,-(A7)
//017530 3f3c 0008                MOVE.W   #8,-(A7)
//017534 4ead 00d8                JSR      216(A5)    (=0x000fe2)
//017538 588f                     ADDQ.L   #4,A7
  D1L = Smaller(8, pcA3->maxMana/8);
//01753a 2200                     MOVE.L   D0,D1
//01753c 303c 000a                MOVE.W   #10,D0
//017540 9041                     SUB.W    D1,D0
  D6W = sw(10 - D1W);
//017542 3c00                     MOVE.W   D0,D6
//017544 3007                     MOVE.W   D7,D0
//017546 3206                     MOVE.W   D6,D1
//017548 e541                     ASL.W    #2,D1
//01754a b041                     CMP.W    D1,D0
//01754c 6c04                     BGE      $+6 (=0x017552)
  if (D7W < 4*D6W)
  {
//01754e 5647                     ADDQ.W   #3,D7
//017550 5346                     SUBQ.W   #1,D6
    D7W += 3;
    D6W -= 1;
  };
//017552 3f06                     MOVE.W   D6,-(A7)
//017554 3f3c 005a                MOVE.W   #90,-(A7)
//017558 3f07                     MOVE.W   D7,-(A7)
//01755a 3f2e 000a                MOVE.W   10(A6),-(A7)
//01755e 2f0b                     MOVE.L   A3,-(A7)
//017560 4eba ff36                JSR      $-200 (=0x017498)
//017564 defc 000c                ADD.W    #12,A7
  return LaunchObject(pcA3, object, D7W, 90, D6W);
//017568 4cdf 08c0                MOVEM.L  (A7)+,D67A3
//01756c 4e5e                     UNLK     A6
//01756e 4e75                     RTS
}

//***********************************************************
//
//***********************************************************
//   TAG017756
void DisableCharacterAction(i32 chIdx, i32 timeDelay)
{//(void)
  dReg D5, D6, D7;
  CHARDESC *pcA3;
  TIMER timer;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//017756 4e56 fff6                LINK     A6,#-10
//01775a 48e7 0710                MOVEM.L  D567A3,-(A7)
//01775e 302e 0008                MOVE.W   8(A6),D0
//017762 c1fc 0320                MULS     #800,D0
//017766 41ec bf9e                LEA      -16482(A4),A0
//01776a d0c0                     ADD.W    D0,A0
//01776c 41d0                     LEA      (A0),A0
//01776e 2648                     MOVE.L   A0,A3
  pcA3 = &d.CH16482[chIdx];
//017770 2e2c d23a                MOVE.L   -11718(A4),D7
  D7L = d.Time + timeDelay;
//017774 362e 000a                MOVE.W   10(A6),D3
//017778 c6bc 0000 ffff           AND.L    #65535,D3
//01777e de83                     ADD.L    D3,D7
//017780 1d7c 000b fffa           MOVE.B   #11,-6(A6)
  timer.function = 11;
//017786 302e 0008                MOVE.W   8(A6),D0
//01778a 1d40 fffb                MOVE.B   D0,-5(A6)
  timer.uByte5 = (ui8)chIdx;
//01778e 422e fffc                CLR.B    -4(A6)
  timer.uByte6 = 0;
//017792 302b 002c                MOVE.W   44(A3),D0
//017796 3a00                     MOVE.W   D0,D5
  D5W = pcA3->busyTimer;
//017798 4a40                     TST.W    D0
//01779a 6d40                     BLT      $+66 (=0x0177dc)
  if (D5W >= 0)
  {
//01779c 3c05                     MOVE.W   D5,D6
//01779e cdfc 000a                MULS     #10,D6
//0177a2 206c cd3e                MOVE.L   -12994(A4),A0
//0177a6 d0c6                     ADD.W    D6,A0
//0177a8 2c10                     MOVE.L   (A0),D6
    D6L = d.Timers[D5W].time & 0xffffff;
//0177aa ccbc 00ff ffff           AND.L    #16777215,D6
//0177b0 2007                     MOVE.L   D7,D0
//0177b2 b086                     CMP.L    D6,D0
//0177b4 6d0c                     BLT      $+14 (=0x0177c2)
    if (D7L >= D6L)
    {
//0177b6 2006                     MOVE.L   D6,D0
//0177b8 90ac d23a                SUB.L    -11718(A4),D0
//0177bc e280                     ASR.L    #1,D0   // Was (improperly) ROR.L
//0177be de80                     ADD.L    D0,D7
      D7L += (D6L-d.Time) >> 1;
//0177c0 6010                     BRA      $+18 (=0x0177d2)
    }
    else
    {
//0177c2 2e06                     MOVE.L   D6,D7
//0177c4 322e 000a                MOVE.W   10(A6),D1
//0177c8 e249                     LSR.W    #1,D1
//0177ca c2bc 0000 ffff           AND.L    #65535,D1
//0177d0 de81                     ADD.L    D1,D7
      D7L = D6L + timeDelay/2;
    };
//0177d2 3f05                     MOVE.W   D5,-(A7)
//0177d4 4ead 0360                JSR      864(A5)    (=0x00ff4c)
//0177d8 548f                     ADDQ.L   #2,A7
    DeleteTimer(D5W);
//0177da 6010                     BRA      $+18 (=0x0177ec)
  }
  else
  {
//0177dc 006b 8008 0030           OR.W     #32776,48(A3)
    pcA3->word48 |= 0x8008;
//0177e2 3f2e 0008                MOVE.W   8(A6),-(A7)
//0177e6 4eba d5f8                JSR      $-10758 (=0x014de0=DrawCharacterState)
//0177ea 548f                     ADDQ.L   #2,A7
    DrawCharacterState(chIdx);
  };
//0177ec 2007                     MOVE.L   D7,D0
//0177ee 322c d244                MOVE.W   -11708(A4),D1
//0177f2 48c1                     EXT.L    D1
//0177f4 263c 0000 0018           MOVE.L   #24,D3
//0177fa e7a1                     ASL.L    D3,D1
//0177fc 8081                     OR.L     D1,D0
//0177fe 2d40 fff6                MOVE.L   D0,-10(A6)
  timer.time = D7L | (d.partyLevel << 24);
//017802 486e fff6                PEA      -10(A6)
//017806 4ead 0366                JSR      870(A5)    (=0x00ffbe=SetTimer)
//01780a 588f                     ADDQ.L   #4,A7
  pcA3->busyTimer = SetTimer(&timer);
//01780c 3740 002c                MOVE.W   D0,44(A3)

//017810 4cdf 08e0                MOVEM.L  (A7)+,D567A3
//017814 4e5e                     UNLK     A6
//017816 4e75                     RTS
}


//*********************************************************
//
//*********************************************************
//   TAG019d90
RESTARTABLE _MagicSelection(const i32 button)
{//(void)
  static dReg D0, D7;
  static CHARDESC *pcA0;
  static i16 *pwA3;
  RESTARTMAP
    RESTART(1)
    RESTART(2)
    RESTART(3)
    RESTART(5)
  END_RESTARTMAP
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//019d90 4e56 0000                LINK     A6,#0
//019d94 48e7 0110                MOVEM.L  D7A3,-(A7)
//019d98 0c6e 006c 0008           CMP.W    #108,8(A6)
//019d9e 6656                     BNE      $+88 (=0x019df6)
  if (button == 108)
  {
//019da0 302c b0d6                MOVE.W   -20266(A4),D0
//019da4 c1fc 0320                MULS     #800,D0
//019da8 41ec bfc0                LEA      -16448(A4),A0
//019dac d0c0                     ADD.W    D0,A0
    pcA0 = &d.CH16482[d.MagicCaster];
//019dae 1010                     MOVE.B   (A0),D0
//019db0 4880                     EXT.W    D0
    D0W = pcA0->incantation[0];
//019db2 4a40                     TST.W    D0
//019db4 6604                     BNE      $+6 (=0x019dba)
//019db6 6000 008a                BRA      $+140 (=0x019e42)
    if (D0W == 0) RETURN;
//019dba 2f3c 003f 0049           MOVE.L   #4128841,-(A7)
//019dc0 2f3c 00ea 012f           MOVE.L   #15335727,-(A7)
//019dc6 4eba f9d4                JSR      $-1578 (=0x01979c)
//019dca 508f                     ADDQ.L   #0,A7
    FlashButton(_1_,0xea, 0x12f, 0x3f, 0x49);
//019dcc 0c6c 0088 fc6a           CMP.W    #136,-918(A4)
//019dd2 6014                     BRA      $+22 (=0x019de8)

//019dd4 486c d262                PEA      -11678(A4)
//019dd8 4ead 0378                JSR      888(A5)    (=0x01385a)
//019ddc 588f                     ADDQ.L   #4,A7
//019dde 4a40                     TST.W    D0
//019de0 6006                     BRA      $+8 (=0x019de8)
//019de2 397c 0c91 f054           MOVE.W   #3217,-4012(A4)

//019de8 4267                     CLR.W    -(A7)
//019dea 4eba 2a3a                JSR      $+10812 (=0x01c826)
//019dee 548f                     ADDQ.L   #2,A7
    CastMagic(_2_,0);
    d.clockTick = i16Result;
//019df0 3940 d228                MOVE.W   D0,-11736(A4)
//019df4 604c                     BRA      $+78 (=0x019e42)
    RETURN;
  };
//019df6 3e2e 0008                MOVE.W   8(A6),D7
//019dfa 9e7c 0065                SUB.W    #101,D7
//019dfe 3007                     MOVE.W   D7,D0
  D7W = sw(button-101);
//019e00 e780                     ASL.L    #3,D0
//019e02 41ec b788                LEA      -18552(A4),A0
//019e06 d0c0                     ADD.W    D0,A0
//019e08 41d0                     LEA      (A0),A0
//019e0a 2648                     MOVE.L   A0,A3
  pwA3 = &d.Word18552[4 * D7W];
//019e0c 3f2b 0006                MOVE.W   6(A3),-(A7)
//019e10 3f2b 0004                MOVE.W   4(A3),-(A7)
//019e14 3f2b 0002                MOVE.W   2(A3),-(A7)
//019e18 3f13                     MOVE.W   (A3),-(A7)
//019e1a 4eba f980                JSR      $-1662 (=0x01979c)
//019e1e 508f                     ADDQ.L   #0,A7
  FlashButton(_5_,pwA3[0], pwA3[1], pwA3[2], pwA3[3]);
//019e20 3f3c 0025                MOVE.W   #37,-(A7)
//019e24 4ead 0138                JSR      312(A5)    (=0x001ce8)
//019e28 548f                     ADDQ.L   #2,A7
  wvbl(_3_);
//019e2a 4eba f9a6                JSR      $-1624 (=0x0197d2)
  WaitForButtonFlash();// If any are active.
//019e2e 0c47 0006                CMP.W    #6,D7
//019e32 640a                     BCC      $+12 (=0x019e3e)
  if (D7W <6)
  {
//019e34 3f07                     MOVE.W   D7,-(A7)
//019e36 4eba 1b58                JSR      $+7002 (=0x01b990)
//019e3a 548f                     ADDQ.L   #2,A7
    TAG01b990(D7W);
//019e3c 6004                     BRA      $+6 (=0x019e42)
  }
  else
  {
//019e3e 4eba 1c1a                JSR      $+7196 (=0x01ba5a)
    BackspaceMagicSelection();
  };
//019e42 4cdf 0880                MOVEM.L  (A7)+,D7A3
//019e46 4e5e                     UNLK     A6
//019e48 4e75                     RTS
  RETURN;
}

// **********************************************************
//
// **********************************************************

//   TAG019e4a
RESTARTABLE _HandleMagicClick(const i32 clickX, const i32 clickY)
{//(void)
  static dReg D6, D7;
  RESTARTMAP
    RESTART(1)
  END_RESTARTMAP
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//019e4a 4e56 0000                LINK     A6,#0
//019e4e 48e7 0300                MOVEM.L  D67,-(A7)
//019e52 3c3c ffff                MOVE.W   #65535,D6
  D6W = -1;
//019e56 0c6e 0030 000a           CMP.W    #48,10(A6)
//019e5c 6200 0120                BHI      $+290 (=0x019f7e)
  if (clickY <= 48)
  {
//019e60 302c b0d6                MOVE.W   -20266(A4),D0
//019e64 4a40                     TST.W    D0
//019e66 6702                     BEQ      $+4 (=0x019e6a)
//019e68 603c                     BRA      $+62 (=0x019ea6)
    if (d.MagicCaster == 0)
    {
//019e6a 0c6e 0118 0008           CMP.W    #280,8(A6)
//019e70 650e                     BCS      $+16 (=0x019e80)
//019e72 0c6e 0123 0008           CMP.W    #291,8(A6)
//019e78 6206                     BHI      $+8 (=0x019e80)
      if (   ((clickX >= 280) && (clickX <= 291))
          || (clickX == 513)  )
      {
//019e7a 3c3c 0001                MOVE.W   #1,D6
        D6W = 1;
//019e7e 6022                     BRA      $+36 (=0x019ea2)
      }
      else
      {
//019e80 0c6e 0126 0008           CMP.W    #294,8(A6)
//019e86 650e                     BCS      $+16 (=0x019e96)
//019e88 0c6e 0131 0008           CMP.W    #305,8(A6)
//019e8e 6206                     BHI      $+8 (=0x019e96)
        if (   ((clickX >= 294) && (clickX <= 305))
            || (clickX == 514)  )
        {
//019e90 3c3c 0002                MOVE.W   #2,D6
          D6W = 2;
//019e94 600c                     BRA      $+14 (=0x019ea2)
        }
        else
        {
//019e96 0c6e 0134 0008           CMP.W    #308,8(A6)
//019e9c 6504                     BCS      $+6 (=0x019ea2)
          if (   ((clickX >= 308) && (clickX <= 319))
              || (clickX == 515) ) D6W = 3;
//019e9e 3c3c 0003                MOVE.W   #3,D6
        };
      };
//019ea2 6000 00c2                BRA      $+196 (=0x019f66)
    }
    else
    {
//019ea6 b07c 0001                CMP.W    #1,D0
//019eaa 6702                     BEQ      $+4 (=0x019eae)
//019eac 603a                     BRA      $+60 (=0x019ee8)
      if (d.MagicCaster == 1)
      {
//019eae 0c6e 00e9 0008           CMP.W    #233,8(A6)
//019eb4 650c                     BCS      $+14 (=0x019ec2)
//019eb6 0c6e 00f4 0008           CMP.W    #244,8(A6)
//019ebc 6204                     BHI      $+6 (=0x019ec2)
        if (   ((clickX >= 233) && (clickX <= 244))
            || (clickX == 512)  )
        {
//019ebe 4246                     CLR.W    D6
          D6W = 0;
//019ec0 6022                     BRA      $+36 (=0x019ee4)
        }
        else
        {
//019ec2 0c6e 0126 0008           CMP.W    #294,8(A6)
//019ec8 650e                     BCS      $+16 (=0x019ed8)
//019eca 0c6e 0131 0008           CMP.W    #305,8(A6)
//019ed0 6206                     BHI      $+8 (=0x019ed8)
          if (   ((clickX >= 294) && (clickX <= 305))
              || (clickX == 514)  )
          {
//019ed2 3c3c 0002                MOVE.W   #2,D6
            D6W = 2;
//019ed6 600c                     BRA      $+14 (=0x019ee4)
          }
          else
          {
//019ed8 0c6e 0134 0008           CMP.W    #308,8(A6)
//019ede 6504                     BCS      $+6 (=0x019ee4)
            if (   ((clickX >= 308) && (clickX <= 319))
                || (clickX == 515)  ) D6W = 3;
//019ee0 3c3c 0003                MOVE.W   #3,D6
//019ee4 6000 0080                BRA      $+130 (=0x019f66)
          };
        };
      }
      else
      {
//019ee8 b07c 0002                CMP.W    #2,D0
//019eec 6702                     BEQ      $+4 (=0x019ef0)
//019eee 6038                     BRA      $+58 (=0x019f28)
        if (d.MagicCaster == 2)
        {
//019ef0 0c6e 00e9 0008           CMP.W    #233,8(A6)
//019ef6 650c                     BCS      $+14 (=0x019f04)
//019ef8 0c6e 00f4 0008           CMP.W    #244,8(A6)
//019efe 6204                     BHI      $+6 (=0x019f04)
          if (   ((clickX >= 233) && (clickX <= 244))
              || (clickX == 512) )
          {
//019f00 4246                     CLR.W    D6
            D6W = 0;
//019f02 6022                     BRA      $+36 (=0x019f26)
          }
          else
          {
//019f04 0c6e 00f7 0008           CMP.W    #247,8(A6)
//019f0a 650e                     BCS      $+16 (=0x019f1a)
//019f0c 0c6e 0102 0008           CMP.W    #258,8(A6)
//019f12 6206                     BHI      $+8 (=0x019f1a)
            if (   ((clickX >= 247) && (clickX <= 258))
                || (clickX == 513)  )
            {
//019f14 3c3c 0001                MOVE.W   #1,D6
              D6W = 1;
//019f18 600c                     BRA      $+14 (=0x019f26)
            }
            else
            {
//019f1a 0c6e 0134 0008           CMP.W    #308,8(A6)
//019f20 6504                     BCS      $+6 (=0x019f26)
              if (   ((clickX >= 308) && (clickX <=319))
                  || (clickX == 515)  ) D6W = 3;
//019f22 3c3c 0003                MOVE.W   #3,D6
            };
          };
//019f26 603e                     BRA      $+64 (=0x019f66)
        }
        else
        {
//019f28 b07c 0003                CMP.W    #3,D0
//019f2c 6702                     BEQ      $+4 (=0x019f30)
//019f2e 6036                     BRA      $+56 (=0x019f66)
          if (d.MagicCaster == 3)
          {
//019f30 0c6e 00f7 0008           CMP.W    #247,8(A6)
//019f36 650e                     BCS      $+16 (=0x019f46)
//019f38 0c6e 0102 0008           CMP.W    #258,8(A6)
//019f3e 6206                     BHI      $+8 (=0x019f46)
            if (   ((clickX >= 247) && (clickX <= 258))
                || (clickX == 513)   )
            {
//019f40 3c3c 0001                MOVE.W   #1,D6
              D6W = 1;
//019f44 6020                     BRA      $+34 (=0x019f66)
            }
            else
            {
//019f46 0c6e 0105 0008           CMP.W    #261,8(A6)
//019f4c 650e                     BCS      $+16 (=0x019f5c)
//019f4e 0c6e 0110 0008           CMP.W    #272,8(A6)
//019f54 6206                     BHI      $+8 (=0x019f5c)
              if (   ((clickX >= 261) && (clickX <= 272))
                  || (clickX == 514)  )
              {

//019f56 3c3c 0002                MOVE.W   #2,D6
                D6W = 2;
//019f5a 600a                     BRA      $+12 (=0x019f66)
              }
              else
              {
//019f5c 0c6e 00f4 0008           CMP.W    #244,8(A6)
//019f62 6202                     BHI      $+4 (=0x019f66)
                if ( (clickX <= 244) || (clickX == 512) ) D6W = 0;
//019f64 4246                     CLR.W    D6
              };
            };
          };
        };
      };
    };
//019f66 0c46 ffff                CMP.W    #65535,D6
//019f6a 6710                     BEQ      $+18 (=0x019f7c)
    if (D6W != -1)
    {
//019f6c 3006                     MOVE.W   D6,D0
//019f6e b06c d24c                CMP.W    -11700(A4),D0
//019f72 6408                     BCC      $+10 (=0x019f7c)
      if (D6W < d.NumCharacter)
      {
//019f74 3f06                     MOVE.W   D6,-(A7)
//019f76 4eba 17ae                JSR      $+6064 (=0x01b726)
//019f7a 548f                     ADDQ.L   #2,A7
        SelectMagicCaster(D6W);
      };
    };
//019f7c 6026                     BRA      $+40 (=0x019fa4)
    RETURN;
  };
//019f7e 3f3c 0002                MOVE.W   #2,-(A7)
//019f82 3f2e 000a                MOVE.W   10(A6),-(A7)
//019f86 3f2e 0008                MOVE.W   8(A6),-(A7)
//019f8a 486c b974                PEA      -18060(A4)
//019f8e 4eba f5e0                JSR      $-2590 (=0x019570)
//019f92 defc 000a                ADD.W    #10,A7
//019f96 3e00                     MOVE.W   D0,D7
  D7W = SearchButtonList(d.Buttons18060,
                          clickX,
                          clickY,
                          2);
//019f98 4a47                     TST.W    D7
//019f9a 6708                     BEQ      $+10 (=0x019fa4)
  if (D7W)
  {
//019f9c 3f07                     MOVE.W   D7,-(A7)
//019f9e 4eba fdf0                JSR      $-526 (=0x019d90)
//019fa2 548f                     ADDQ.L   #2,A7
    MagicSelection(_1_, D7W);
  };
//019fa4 4cdf 00c0                MOVEM.L  (A7)+,D67
//019fa8 4e5e                     UNLK     A6
//019faa 4e75                     RTS
  RETURN;
}

//*******************************************************************
//
//*******************************************************************
//   TAG01b726
void SelectMagicCaster(i16 chIdx)
{
  dReg D5, D6;
  pnt pD4;
  CHARDESC *pcA3;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//01b726 4e56 0000                LINK     A6,#0
//01b72a 48e7 0f10                MOVEM.L  D4567A3,-(A7)
//01b72e 3e2e 0008                MOVE.W   8(A6),D7
  //D7W = P1;
//01b732 3007                     MOVE.W   D7,D0
//01b734 b06c b0d6                CMP.W    -20266(A4),D0
//01b738 6716                     BEQ      $+24 (=0x01b750)
  if (chIdx == d.MagicCaster) return;
//01b73a 0c47 ffff                CMP.W    #65535,D7
//01b73e 6714                     BEQ      $+22 (=0x01b754)
//01b740 3007                     MOVE.W   D7,D0
//01b742 c1fc 0320                MULS     #800,D0
//01b746 41ec bfd2                LEA      -16430(A4),A0
//01b74a d0c0                     ADD.W    D0,A0
//01b74c 3010                     MOVE.W   (A0),D0
//01b74e 6604                     BNE      $+6 (=0x01b754)
//01b750 6000 0126                BRA      $+296 (=0x01b878)
  if ( (chIdx!=-1) && (d.CH16482[chIdx].HP==0) ) return;
//01b754 0c6c ffff b0d6           CMP.W    #65535,-20266(A4)
//01b75a 6626                     BNE      $+40 (=0x01b782)
  if (d.MagicCaster == -1)
  {
//01b75c 4ead 0024                JSR      36(A5)    (=0x002fd2)
    STHideCursor();
//01b760 2f3c 0030 ffff           MOVE.L   #3211263,-(A7)
//01b766 486c fff4                PEA      -12(A4)
//01b76a 3f3c 0009                MOVE.W   #9,-(A7)
//01b76e 4ead 061e                JSR      1566(A5)    (=0x022a92)
//01b772 548f                     ADDQ.L   #2,A7
//01b774 2f00                     MOVE.L   D0,-(A7)
//01b776 4ead 00a2                JSR      162(A5)    (=0x000f7e)
//01b77a defc 000c                ADD.W    #12,A7
    BLT2Screen(GetGraphicAddress(9), (RectPos *)d.Word12, 48, -1);
//01b77e 4ead 00a8                JSR      168(A5)    (=0x003026)
    STShowCursor();
  };
//01b782 0c47 ffff                CMP.W    #65535,D7
//01b786 662c                     BNE      $+46 (=0x01b7b4)
  if (chIdx == -1)
  {
//01b788 397c ffff b0d6           MOVE.W   #65535,-20266(A4)
//01b78e 4ead 0024                JSR      36(A5)    (=0x002fd2)
    STHideCursor();
//01b792 426c a608                CLR.W    -23032(A4)
    d.UseByteCoordinates = 0;
//01b796 3f3c 00a0                MOVE.W   #160,-(A7)
//01b79a 4267                     CLR.W    -(A7)
//01b79c 486c fff4                PEA      -12(A4)
//01b7a0 2f2c d132                MOVE.L   -11982(A4),-(A7)
//01b7a4 4ead 01ce                JSR      462(A5)    (=0x008e60)
//01b7a8 defc 000c                ADD.W    #12,A7
    NotImplemented(0x1b7ac); // Check word12
    FillRectangle(d.LogicalScreenBase, (RectPos *)d.Word12, 0, 160);
//01b7ac 4ead 00a8                JSR      168(A5)    (=0x003026)
    STShowCursor();
//01b7b0 6000 00c6                BRA      $+200 (=0x01b878)
    return;
  };
//01b7b4 3007                     MOVE.W   D7,D0
//01b7b6 3940 b0d6                MOVE.W   D0,-20266(A4)
  d.MagicCaster = chIdx;
//01b7ba c1fc 0320                MULS     #800,D0
//01b7be 41ec bf9e                LEA      -16482(A4),A0
//01b7c2 d0c0                     ADD.W    D0,A0
//01b7c4 41d0                     LEA      (A0),A0
//01b7c6 2648                     MOVE.L   A0,A3
  pcA3 = &d.CH16482[chIdx];
//01b7c8 3f3c 0002                MOVE.W   #2,-(A7)
//01b7cc 4eba fc3a                JSR      $-964 (=0x01b408)
//01b7d0 548f                     ADDQ.L   #2,A7
  TAG01b408(2);
//01b7d2 4245                     CLR.W    D5
  D5W = 0;
//01b7d4 282c d132                MOVE.L   -11982(A4),D4
//01b7d8 d8bc 0000 1fb0           ADD.L    #8112,D4
  pD4 = d.LogicalScreenBase+8112;
//01b7de 4ead 0024                JSR      36(A5)    (=0x002fd2)
  STHideCursor();
//01b7e2 3f07                     MOVE.W   D7,-(A7)
//01b7e4 4eba fd28                JSR      $-726 (=0x01b50e)
//01b7e8 548f                     ADDQ.L   #2,A7
  TAG01b50e(chIdx);
//
//01b7ea 3c3c 0001                MOVE.W   #1,D6
//01b7ee 602e                     BRA      $+48 (=0x01b81e)
  for (D6W=1; D6W<12; D6W++)
  {
//01b7f0 3f3c 0030                MOVE.W   #48,-(A7)
//01b7f4 2004                     MOVE.L   D4,D0
//01b7f6 d0bc 0000 00a0           ADD.L    #160,D0
//01b7fc 2800                     MOVE.L   D0,D4
//01b7fe 2f00                     MOVE.L   D0,-(A7)
//01b800 3005                     MOVE.W   D5,D0
//01b802 d07c 0018                ADD.W    #24,D0
//01b806 3a00                     MOVE.W   D0,D5
//01b808 e380                     ASL.L    #1,D0
//01b80a 41ec ae96                LEA      -20842(A4),A0
//01b80e d0c0                     ADD.W    D0,A0
//01b810 41d0                     LEA      (A0),A0
//01b812 2f08                     MOVE.L   A0,-(A7)
//01b814 4ead 0006                JSR      6(A5)    (=0x0009dc)
//01b818 defc 000a                ADD.W    #10,A7
    D5W += 24;
    pD4 += 160;
    MemMove(d.Byte20842+2*D5W, pD4, 48);

//01b81c 5246                     ADDQ.W   #1,D6
//
//01b81e 0c46 000c                CMP.W    #12,D6
//01b822 65cc                     BCS      $-50 (=0x01b7f0)
  };
//01b824 3f3c 0003                MOVE.W   #3,-(A7)
//01b828 4eba fbde                JSR      $-1056 (=0x01b408)
//01b82c 548f                     ADDQ.L   #2,A7
  TAG01b408(3);
//01b82e 4245                     CLR.W    D5
  D5W = 0;
  pD4 = d.LogicalScreenBase + 10032;
//01b830 282c d132                MOVE.L   -11982(A4),D4
//01b834 d8bc 0000 2730           ADD.L    #10032,D4

//01b83a 3c3c 0001                MOVE.W   #1,D6
//01b83e 602e                     BRA      $+48 (=0x01b86e)
  for (D6W=1; D6W<12; D6W++)
  {
//01b840 3f3c 0030                MOVE.W   #48,-(A7)
//01b844 2004                     MOVE.L   D4,D0
//01b846 d0bc 0000 00a0           ADD.L    #160,D0
//01b84c 2800                     MOVE.L   D0,D4
//01b84e 2f00                     MOVE.L   D0,-(A7)
//01b850 3005                     MOVE.W   D5,D0
//01b852 d07c 0018                ADD.W    #24,D0
//01b856 3a00                     MOVE.W   D0,D5
//01b858 e380                     ASL.L    #1,D0
//01b85a 41ec ae96                LEA      -20842(A4),A0
//01b85e d0c0                     ADD.W    D0,A0
//01b860 41d0                     LEA      (A0),A0
//01b862 2f08                     MOVE.L   A0,-(A7)
//01b864 4ead 0006                JSR      6(A5)    (=0x0009dc)
//01b868 defc 000a                ADD.W    #10,A7
    pD4 += 160;
    D5W += 24;
    MemMove(d.Byte20842+2*D5W, pD4, 48);
//01b86c 5246                     ADDQ.W   #1,D6
//
//01b86e 0c46 000c                CMP.W    #12,D6
//01b872 65cc                     BCS      $-50 (=0x01b840)
  };
//01b874 4ead 00a8                JSR      168(A5)    (=0x003026)
  STShowCursor();
//01b878 4cdf 08f0                MOVEM.L  (A7)+,D4567A3
//01b87c 4e5e                     UNLK     A6
//01b87e 4e75                     RTS
}


//*******************************************************************
//
//*******************************************************************

//   TAG01b922
void DisplayMagicSelection(CHARDESC *pChar) // Magic button pressed
{
  dReg D5, D6, D7;
  i8 b_2[2];
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//01b922 4e56 fffe                LINK     A6,#-2
//01b926 48e7 0710                MOVEM.L  D567A3,-(A7)
//01b92a 266e 0008                MOVE.L   8(A6),A3
//
//01b92e 41eb 0022                LEA      34(A3),A0
//01b932 2f08                     MOVE.L   A0,-(A7)
//01b934 4ead 006c                JSR      108(A5)    (=0x0032ba)
//01b938 588f                     ADDQ.L   #4,A7
//01b93a 3a00                     MOVE.W   D0,D5
  D5W = StrLen(pChar->incantation);
//01b93c 3c3c 00e8                MOVE.W   #232,D6
  D6W = 232;
//01b940 422e ffff                CLR.B    -1(A6)
  b_2[1] = 0;
//01b944 4247                     CLR.W    D7
//01b946 603a                     BRA      $+60 (=0x01b982)
  for (D7W=0; D7W<4; D7W++)
  {
//01b948 3007                     MOVE.W   D7,D0
//01b94a b045                     CMP.W    D5,D0
//01b94c 6508                     BCS      $+10 (=0x01b956)
    if (D7W >= D5W)
    {
//01b94e 1d7c 0020 fffe           MOVE.B   #32,-2(A6)
      b_2[0]= ' ';
//01b954 600c                     BRA      $+14 (=0x01b962)
    }
    else
    {
//01b956 3007                     MOVE.W   D7,D0
//01b958 41eb 0022                LEA      34(A3),A0
//01b95c d0c0                     ADD.W    D0,A0
//01b95e 1d50 fffe                MOVE.B   (A0),-2(A6)
      b_2[0] = pChar->incantation[D7W];
    };
//01b962 486e fffe                PEA      -2(A6)
//01b966 4267                     CLR.W    -(A7)
//01b968 2f3c 0046 0004           MOVE.L   #4587524,-(A7)
//01b96e 3006                     MOVE.W   D6,D0
//01b970 d07c 0009                ADD.W    #9,D0
//01b974 3c00                     MOVE.W   D0,D6
//01b976 3f00                     MOVE.W   D0,-(A7)
//01b978 4ead 0108                JSR      264(A5)    (=0x001c42)
//01b97c defc 000c                ADD.W    #12,A7
    TextOutToScreen(D6W += 9, 70, 4, 0, b_2);

//01b980 5247                     ADDQ.W   #1,D7

//01b982 0c47 0004                CMP.W    #4,D7
//01b986 65c0                     BCS      $-62 (=0x01b948)
  };
//01b988 4cdf 08e0                MOVEM.L  (A7)+,D567A3
//01b98c 4e5e                     UNLK     A6
//01b98e 4e75                     RTS
}


//*********************************************************
//
//*********************************************************
//   TAG01ba5a
void BackspaceMagicSelection(void)
{
  dReg D0, D7;
  CHARDESC *pcA3;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//01ba5a 4e56 0000                LINK     A6,#0
//01ba5e 48e7 0310                MOVEM.L  D67A3,-(A7)
//01ba62 302c b0d6                MOVE.W   -20266(A4),D0
//01ba66 c1fc 0320                MULS     #800,D0
//01ba6a 41ec bf9e                LEA      -16482(A4),A0
//01ba6e d0c0                     ADD.W    D0,A0
//01ba70 41d0                     LEA      (A0),A0
//01ba72 2648                     MOVE.L   A0,A3
  pcA3 = &d.CH16482[d.MagicCaster];
//01ba74 41eb 0022                LEA      34(A3),A0
//01ba78 2f08                     MOVE.L   A0,-(A7)
//01ba7a 4ead 006c                JSR      108(A5)    (=0x0032ba)
//01ba7e 588f                     ADDQ.L   #4,A7
  D0W = StrLen(pcA3->incantation);
//01ba80 4a40                     TST.W    D0
//01ba82 6602                     BNE      $+4 (=0x01ba86)
//01ba84 6034                     BRA      $+54 (=0x01baba)
  if (D0W == 0) return;
//01ba86 4240                     CLR.W    D0
//01ba88 102b 0021                MOVE.B   33(A3),D0
  D0W = (UI8)(pcA3->byte33);
//01ba8c 5640                     ADDQ.W   #3,D0
//01ba8e c07c 0003                AND.W    #3,D0
//01ba92 3e00                     MOVE.W   D0,D7
  D7W = (I16)((D0W + 3) & 3);
//01ba94 1740 0021                MOVE.B   D0,33(A3)
  pcA3->byte33 = D7B;
//01ba98 3007                     MOVE.W   D7,D0
//01ba9a 41eb 0022                LEA      34(A3),A0
//01ba9e d0c0                     ADD.W    D0,A0
//01baa0 4210                     CLR.B    (A0)
  pcA3->incantation[D7W] = 0;
//01baa2 4ead 0024                JSR      36(A5)    (=0x002fd2=HideCursor)
  STHideCursor();
//01baa6 3f07                     MOVE.W   D7,-(A7)
//01baa8 4eba fe20                JSR      $-478 (=0x01b8ca)
  DrawSpellMenuCharacters(D7W); // Zo, Rath, etc.
//01baac 548f                     ADDQ.L   #2,A7
//01baae 2f0b                     MOVE.L   A3,-(A7)
//01bab0 4eba fe70                JSR      $-398 (=0x01b922)
//01bab4 588f                     ADDQ.L   #4,A7
  DisplayMagicSelection(pcA3);
//01bab6 4ead 00a8                JSR      168(A5)    (=0x003026)
  STShowCursor();
//01baba 4cdf 08c0                MOVEM.L  (A7)+,D67A3
//01babe 4e5e                     UNLK     A6
//01bac0 4e75                     RTS
}

//*********************************************************
//
//*********************************************************
//   TAG01be38
void SetBrightnessTimer(i32 deltaBrightness, i32 timeDelay)
{
  TIMER timer;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//01be38 4e56 fff6                LINK     A6,#-10
//01be3c 1d7c 0046 fffa           MOVE.B   #70,-6(A6)
  timer.function = 70;
//01be42 3d6e 0008 fffc           MOVE.W   8(A6),-4(A6)
  timer.word6() = sw(deltaBrightness);
//01be48 202c d23a                MOVE.L   -11718(A4),D0
//01be4c 362e 000a                MOVE.W   10(A6),D3
//01be50 c6bc 0000 ffff           AND.L    #65535,D3
//01be56 d083                     ADD.L    D3,D0
//01be58 322c d244                MOVE.W   -11708(A4),D1
//01be5c 48c1                     EXT.L    D1
//01be5e 263c 0000 0018           MOVE.L   #24,D3
//01be64 e7a1                     ASL.L    D3,D1
//01be66 8081                     OR.L     D1,D0
//01be68 2d40 fff6                MOVE.L   D0,-10(A6)
  timer.time = (d.Time + timeDelay) | (d.partyLevel << 24);
//01be6c 422e fffb                CLR.B    -5(A6)
  timer.uByte5 = 0;
//01be70 486e fff6                PEA      -10(A6)
//01be74 4ead 0366                JSR      870(A5)    (=0x00ffbe=SetTimer)
//01be78 588f                     ADDQ.L   #4,A7
  SetTimer(&timer);
//01be7a 4ead 04ce                JSR      1230(A5)    (=0x017fa8)
  SelectPaletteForLightLevel();
//01be7e 4e5e                     UNLK     A6
//01be80 4e75                     RTS
}

//*********************************************************************
//
//**********************************************************************
//  TAG01c826
RESTARTABLE _CastMagic(const i32)
{ //(i16)
  static dReg D7;
  static CHARDESC *pcA3;
  RESTARTMAP
//    RESTART(1)
  END_RESTARTMAP
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//01c826 4e56 0000                LINK     A6,#0
//01c82a 48e7 0110                MOVEM.L  D7A3,-(A7)
//01c82e 302c b0d6                MOVE.W   -20266(A4),D0
//01c832 c1fc 0320                MULS     #800,D0
//01c836 41ec bf9e                LEA      -16482(A4),A0
//01c83a d0c0                     ADD.W    D0,A0
//01c83c 41d0                     LEA      (A0),A0
//01c83e 2648                     MOVE.L   A0,A3
  pcA3 = &d.CH16482[d.MagicCaster];
//01c840 4ead 0024                JSR      36(A5)    (=0x002fd2)
  STHideCursor();
//01c844 4eba cf8c                JSR      $-12402 (=0x0197d2)
  WaitForButtonFlash(); // If any are active.
//01c848 3f2c b0d6                MOVE.W   -20266(A4),-(A7)
//01c84c 4eba 01be                JSR      $+448 (=0x01ca0c)
//01c850 548f                     ADDQ.L   #2,A7
//01c852 3e00                     MOVE.W   D0,D7
  D7W = CastSpell(d.MagicCaster);
//01c854 0c40 0003                CMP.W    #3,D0
//01c858 6724                     BEQ      $+38 (=0x01c87e)
  if (D7W != 3)
  {
//01c85a 422b 0022                CLR.B    34(A3)
    pcA3->incantation[0] = 0;
//01c85e 4240                     CLR.W    D0
//01c860 103c 0000                MOVE.B   #0,D0
//01c864 1740 0021                MOVE.B   D0,33(A3)
    pcA3->byte33 = 0;
//01c868 c07c 00ff                AND.W    #255,D0
//01c86c 3f00                     MOVE.W   D0,-(A7)
//01c86e 4eba f05a                JSR      $-4004 (=0x01b8ca)
//01c872 548f                     ADDQ.L   #2,A7
    DrawSpellMenuCharacters(0);//Zo, Rath, etc.
//01c874 2f0b                     MOVE.L   A3,-(A7)
//01c876 4eba f0aa                JSR      $-3924 (=0x01b922)
//01c87a 588f                     ADDQ.L   #4,A7
    DisplayMagicSelection(pcA3); // clear magic selection display
//01c87c 6002                     BRA      $+4 (=0x01c880)
  }
  else
  {
//01c87e 4247                     CLR.W    D7
    D7W = 0;
  };
//01c880 4ead 00a8                JSR      168(A5)    (=0x003026)
  STShowCursor();
//01c884 3007                     MOVE.W   D7,D0
  RETURN_i16(D7W);
//01c886 4cdf 0880                MOVEM.L  (A7)+,D7A3
//01c88a 4e5e                     UNLK     A6
//01c88c 4e75                     RTS
}

//************************************************************
//
//************************************************************
//    TAG01c88e
SPELL *Incantation2Spell(pnt incantation)
{
  dReg D6, D7;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//01c88e 4e56 0000                LINK     A6,#0
//01c892 48e7 0330                MOVEM.L  D67A23,-(A7)
//01c896 266e 0008                MOVE.L   8(A6),A3
//01c89a 200b                     MOVE.L   A3,D0
//01c89c 5280                     ADDQ.L   #1,D0
//01c89e 2040                     MOVE.L   D0,A0
//01c8a0 1010                     MOVE.B   (A0),D0
  if (incantation[1] == 0) return NULL;
//01c8a2 675a                     BEQ      $+92 (=0x01c8fe)
//01c8a4 3c3c 0018                MOVE.W   #24,D6
  D6W = 24;
//01c8a8 4287                     CLR.L    D7
  D7L = 0;
  do
  { // Gather incantation bytes into longword D7L
//01c8aa 4240                     CLR.W    D0
//01c8ac 101b                     MOVE.B   (A3)+,D0
//01c8ae 48c0                     EXT.L    D0
//01c8b0 eda0                     ASL.L    D6,D0
//01c8b2 8e80                     OR.L     D0,D7
    D7L |= ((UI8)(*(incantation++)))<<D6W;
//01c8b4 1013                     MOVE.B   (A3),D0
//01c8b6 670a                     BEQ      $+12 (=0x01c8c2)
    if (*incantation == 0) break;
//01c8b8 3006                     MOVE.W   D6,D0
//01c8ba 5140                     SUBQ.W   #0,D0
//01c8bc 3c00                     MOVE.W   D0,D6
//01c8be 4a40                     TST.W    D0
//01c8c0 6ce8                     BGE      $-22 (=0x01c8aa)
  } while  ((D6W -= 8) >= 0);
//01c8c2 41ec b4f0                LEA      -19216(A4),A0
//01c8c6 2448                     MOVE.L   A0,A2
//01c8c8 3c3c 0019                MOVE.W   #25,D6
//01c8cc 6028                     BRA      $+42 (=0x01c8f6)
  for (D6W = 0; D6W < 25; D6W++)
  {
//01c8ce 2012                     MOVE.L   (A2),D0
//01c8d0 c0bc ff00 0000           AND.L    #-16777216,D0
//01c8d6 670c                     BEQ      $+14 (=0x01c8e4)
    if (d.Spells[D6W].spellID & 0xff000000)
    { // All the spells in d.Spells have byte0 = 0 !
//01c8d8 2007                     MOVE.L   D7,D0
//01c8da b092                     CMP.L    (A2),D0
//01c8dc 6604                     BNE      $+6 (=0x01c8e2)
      ASSERT(0); // I don't think this is possible!
      if (D7L == d.Spells[D6W].spellID)
      {
//01c8de 200a                     MOVE.L   A2,D0
//01c8e0 6022                     BRA      $+36 (=0x01c904)
        return &d.Spells[D6W];;
      }
//01c8e2 6010                     BRA      $+18 (=0x01c8f4)
    }
    else
    {
//01c8e4 2007                     MOVE.L   D7,D0
//01c8e6 c0bc 00ff ffff           AND.L    #16777215,D0
//01c8ec b092                     CMP.L    (A2),D0
//01c8ee 6604                     BNE      $+6 (=0x01c8f4)
      if ((D7L & 0xffffff) == d.Spells[D6W].spellID)
                return &d.Spells[D6W];
//01c8f0 200a                     MOVE.L   A2,D0
//01c8f2 6010                     BRA      $+18 (=0x01c904)
    };
//01c8f4 508a                     ADDQ.L   #0,A2
//
//01c8f6 3006                     MOVE.W   D6,D0
//01c8f8 5346                     SUBQ.W   #1,D6
//01c8fa 4a40                     TST.W    D0
//01c8fc 66d0                     BNE      $-46 (=0x01c8ce)
  };
//01c8fe 203c 0000 0000           MOVE.L   #0,D0
  return NULL;
//01c904 4cdf 0cc0                MOVEM.L  (A7)+,D67A23
//01c908 4e5e                     UNLK     A6
//01c90a 4e75                     RTS
}

//************************************************************
//
//************************************************************
//   TAG01c90c
void SpellErrorMsg(CHARDESC *pChar,i16 P2,i16 P3)
{
  pnt msg="UNKNOWN SPELL ERROR";
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//01c90c 4e56 0000                LINK     A6,#0
//01c910 2f0b                     MOVE.L   A3,-(A7)
//01c912 0c6e 0003 000e           CMP.W    #3,14(A6)
//01c918 6314                     BLS      $+22 (=0x01c92e)
  if (P3 > 3)
  {
//01c91a 302e 000e                MOVE.W   14(A6),D0
//01c91e 5940                     SUBQ.W   #4,D0
//01c920 c0bc 0000 ffff           AND.L    #65535,D0
//01c926 80fc 0004                DIVU     #4,D0
//01c92a 3d40 000e                MOVE.W   D0,14(A6)
    P3 = sw(((P3-4)&0xffff) / 4);
  };
//01c92e 4ead 00ba                JSR      186(A5)    (=0x001c02)
//01c932 206e 0008                MOVE.L   8(A6),A0
  PrintLinefeed();
//01c936 41d0                     LEA      (A0),A0
//01c938 2f08                     MOVE.L   A0,-(A7)
//01c93a 3f3c 0004                MOVE.W   #4,-(A7)
//01c93e 4ead 00c0                JSR      192(A5)    (=0x001aa8=PrintLines)
//01c942 5c8f                     ADDQ.L   #6,A7
  QuePrintLines(4, pChar->name);
//01c944 302e 000c                MOVE.W   12(A6),D0
//01c948 4a40                     TST.W    D0
//01c94a 6702                     BEQ      $+4 (=0x01c94e)
//01c94c 6034                     BRA      $+54 (=0x01c982)
  if (P2 == 0)
  {
//01c94e 41ec 0278                LEA      632(A4),A0
//01c952 2648                     MOVE.L   A0,A3
    msg = " NEEDS MORE PRACTICE WITH THIS ";
//01c954 486c 0298                PEA      664(A4)
//01c958 3f3c 0004                MOVE.W   #4,-(A7)
//01c95c 4ead 00c0                JSR      192(A5)    (=0x001aa8=PrintLines)
//01c960 5c8f                     ADDQ.L   #6,A7
    QuePrintLines(4, " NEEDS MORE PRACTICE WITH THIS ");
//01c962 302e 000e                MOVE.W   14(A6),D0
//01c966 e580                     ASL.L    #2,D0
//01c968 41ec bf2c                LEA      -16596(A4),A0
//01c96c d0c0                     ADD.W    D0,A0
//01c96e 2f10                     MOVE.L   (A0),-(A7)
//01c970 3f3c 0004                MOVE.W   #4,-(A7)
//01c974 4ead 00c0                JSR      192(A5)    (=0x001aa8=PrintLines)
//01c978 5c8f                     ADDQ.L   #6,A7
    QuePrintLines(4, d.Pointer16596[P3]);
//01c97a 41ec 02b8                LEA      696(A4),A0
//01c97e 2648                     MOVE.L   A0,A3
    msg = " SPELL.";
//01c980 601e                     BRA      $+32 (=0x01c9a0)
  }
  else
  {
//01c982 b07c 0001                CMP.W    #1,D0
//01c986 6702                     BEQ      $+4 (=0x01c98a)
//01c988 6008                     BRA      $+10 (=0x01c992)
    if (P2 == 1)
    {
//01c98a 41ec 02c0                LEA      704(A4),A0
//01c98e 2648                     MOVE.L   A0,A3
      msg = " MUMBLES A MEANINGLSS SPELL.";
//01c990 600e                     BRA      $+16 (=0x01c9a0)
    }
    else
    {
//01c992 b07c 000a                CMP.W    #10,D0
//01c996 6702                     BEQ      $+4 (=0x01c99a)
//01c998 6006                     BRA      $+8 (=0x01c9a0)
      if (P2 == 10)
//01c99a 41ec 02de                LEA      734(A4),A0
//01c99e 2648                     MOVE.L   A0,A3
    msg = " NEEDS AN EMPTY FLASK IN HAND FOR POTION.";
    };
  };
//01c9a0 2f0b                     MOVE.L   A3,-(A7)
//01c9a2 3f3c 0004                MOVE.W   #4,-(A7)
//01c9a6 4ead 00c0                JSR      192(A5)    (=0x001aa8=PrintLines)
//01c9aa 5c8f                     ADDQ.L   #6,A7
  QuePrintLines(4, msg);
//01c9ac 265f                     MOVE.L   (A7)+,A3
//01c9ae 4e5e                     UNLK     A6
//01c9b0 4e75                     RTS
}
//       TAG01c9b2
DB8 *GetFlaskInHand(CHARDESC *pChar,RN *pObject)
{
  dReg D6;
  RN objD7;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//01c9b2 4e56 0000                LINK     A6,#0
//01c9b6 48e7 0330                MOVEM.L  D67A23,-(A7)
//01c9ba 266e 0008                MOVE.L   8(A6),A3
//01c9be 246e 000c                MOVE.L   12(A6),A2
//01c9c2 3c3c 0002                MOVE.W   #2,D6
//01c9c6 602e                     BRA      $+48 (=0x01c9f6)
  for (D6W=2; (--D6W)>=0; )
  {
//01c9c8 3006                     MOVE.W   D6,D0
//01c9ca e380                     ASL.L    #1,D0
//01c9cc 41eb 00d4                LEA      212(A3),A0
//01c9d0 d0c0                     ADD.W    D0,A0
//01c9d2 3010                     MOVE.W   (A0),D0
//01c9d4 3e00                     MOVE.W   D0,D7
    objD7 = pChar->possessions[D6W];
//01c9d6 0c40 ffff                CMP.W    #65535,D0
//01c9da 671a                     BEQ      $+28 (=0x01c9f6)
    if (objD7 == RNnul) continue;
//01c9dc 3f07                     MOVE.W   D7,-(A7)
//01c9de 4ead 014a                JSR      330(A5)    (=0x001188)
//01c9e2 548f                     ADDQ.L   #2,A7
//01c9e4 0c40 00c3                CMP.W    #195,D0
//01c9e8 660c                     BNE      $+14 (=0x01c9f6)
    if (GetModifiedObjectType(objD7) != obj_EmptyFlask) continue;
//01c9ea 3487                     MOVE.W   D7,(A2)
    *pObject = objD7;
//01c9ec 3f07                     MOVE.W   D7,-(A7)
//01c9ee 4ead 0312                JSR      786(A5)    (=0x009984=GetRecordAddress)
//01c9f2 548f                     ADDQ.L   #2,A7
//01c9f4 600e                     BRA      $+16 (=0x01ca04)
    return GetRecordAddressDB8(objD7);
//
//01c9f6 5346                     SUBQ.W   #1,D6
//01c9f8 3006                     MOVE.W   D6,D0
//01c9fa 4a40                     TST.W    D0
//01c9fc 6cca                     BGE      $-52 (=0x01c9c8)
  };
  return NULL;
//01c9fe 203c 0000 0000           MOVE.L   #0,D0
//01ca04 4cdf 0cc0                MOVEM.L  (A7)+,D67A23
//01ca08 4e5e                     UNLK     A6
//01ca0a 4e75                     RTS
}

//************************************************************
//
//************************************************************
//  TAG01ca0c
i16 CastSpell(i16 chIdx)
{//(i16)
  dReg D0, D1, D3, D4, D5, D6, D7;
  SPELL *pSpell;
  CHARDESC *pcA3;
  DB10    *pDB10_24;
  TIMER timer_20;
  DB8      *pDB8_10;
  i16 w_6;
  i16 w_4;
  RN  obj_2;
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//01ca0c 4e56 ffe8                LINK     A6,#-24
//01ca10 48e7 0f30                MOVEM.L  D4567A23,-(A7)
//01ca14 3e2e 0008                MOVE.W   8(A6),D7
  D7W = chIdx;
//01ca18 3007                     MOVE.W   D7,D0
//01ca1a b06c d24c                CMP.W    -11700(A4),D0
//01ca1e 6508                     BCS      $+10 (=0x01ca28)
  if (D7W >= d.NumCharacter) return 0;
//01ca20 303c 0000                MOVE.W   #0,D0
//01ca24 6000 04a4                BRA      $+1190 (=0x01ceca)

//01ca28 3007                     MOVE.W   D7,D0
//01ca2a c1fc 0320                MULS     #800,D0
//01ca2e 41ec bf9e                LEA      -16482(A4),A0
//01ca32 d0c0                     ADD.W    D0,A0
//01ca34 41d0                     LEA      (A0),A0
//01ca36 2648                     MOVE.L   A0,A3
  pcA3 = &d.CH16482[D7W];
//01ca38 302b 0034                MOVE.W   52(A3),D0
//01ca3c 6608                     BNE      $+10 (=0x01ca46)
//01ca3e 303c 0000                MOVE.W   #0,D0
//01ca42 6000 0486                BRA      $+1160 (=0x01ceca)
  if (pcA3->HP == 0) return 0;
//01ca46 41eb 0022                LEA      34(A3),A0
//01ca4a 2f08                     MOVE.L   A0,-(A7)
//01ca4c 4eba fe40                JSR      $-446 (=0x01c88e)
//01ca50 588f                     ADDQ.L   #4,A7
//01ca52 2440                     MOVE.L   D0,A2
  pSpell = Incantation2Spell(pcA3->incantation);
//01ca54 4a80                     TST.L    D0
//01ca56 6616                     BNE      $+24 (=0x01ca6e)
  if (pSpell == NULL)
  {
//01ca58 4267                     CLR.W    -(A7)
//01ca5a 3f3c 0001                MOVE.W   #1,-(A7)
//01ca5e 2f0b                     MOVE.L   A3,-(A7)
//01ca60 4eba feaa                JSR      $-340 (=0x01c90c)
    SpellErrorMsg(pcA3, 1, 0);
//01ca64 508f                     ADDQ.L   #0,A7
//01ca66 303c 0000                MOVE.W   #0,D0
//01ca6a 6000 045e                BRA      $+1120 (=0x01ceca)
    return 0;
  };
//01ca6e 1a2b 0022                MOVE.B   34(A3),D5
//01ca72 4885                     EXT.W    D5
//01ca74 9a7c 005f                SUB.W    #95,D5
  D5W = sw(pcA3->incantation[0] - 95); // spell power?
//01ca78 4ead 0090                JSR      144(A5)    (=0x001030)
  D0L = STRandom() & 7;
//01ca7c c07c 0007                AND.W    #7,D0
//01ca80 4241                     CLR.W    D1
//01ca82 122a 0004                MOVE.B   4(A2),D1
//01ca86 d245                     ADD.W    D5,D1
//01ca88 3801                     MOVE.W   D1,D4
  D4W = sw(pSpell->skillRequired + D5W);
//01ca8a e941                     ASL.W    #4,D1
//01ca8c d041                     ADD.W    D1,D0
  D0W = sw(D0W + 16 * D4W);
//01ca8e 3205                     MOVE.W   D5,D1
//01ca90 5341                     SUBQ.W   #1,D1
  D1W = sw(D5W - 1);
//01ca92 4242                     CLR.W    D2
//01ca94 142a 0004                MOVE.B   4(A2),D2
//01ca98 c3c2                     MULU     D2,D1
  D1W = sw(8 * (D1W * pSpell->skillRequired));
//01ca9a e741                     ASL.W    #3,D1
//01ca9c d041                     ADD.W    D1,D0
  D0W = sw(D0W + D1W);
//01ca9e 3204                     MOVE.W   D4,D1
//01caa0 c2c4                     MULU     D4,D1
//01caa2 d041                     ADD.W    D1,D0
  w_4 = sw(D0W + D4W * D4W);
//01caa4 3d40 fffc                MOVE.W   D0,-4(A6)
//01caa8 4240                     CLR.W    D0
//01caaa 102a 0005                MOVE.B   5(A2),D0
//01caae 3f00                     MOVE.W   D0,-(A7)
//01cab0 3f07                     MOVE.W   D7,-(A7)
//01cab2 4ead 03f6                JSR      1014(A5)    (=0x015f1e)
//01cab6 588f                     ADDQ.L   #4,A7
//01cab8 3c00                     MOVE.W   D0,D6
  D6W = (ui16)DetermineMastery(D7W, pSpell->byte5);
//01caba 3006                     MOVE.W   D6,D0
//01cabc b044                     CMP.W    D4,D0
//01cabe 6474                     BCC      $+118 (=0x01cb34)
  if (D6W < D4W)
  {
//01cac0 3004                     MOVE.W   D4,D0
//01cac2 9046                     SUB.W    D6,D0
//01cac4 3d40 fffa                MOVE.W   D0,-6(A6)
//
//01cac8 605e                     BRA      $+96 (=0x01cb28)
    for (w_6=sw(D4W - D6W); w_6--!=0; )
    {
//01caca 4ead 0090                JSR      144(A5)    (=0x001030)
      D0L = STRandom() & 127;
//01cace c07c 007f                AND.W    #127,D0
//01cad2 2f00                     MOVE.L   D0,-(A7)
//01cad4 3f3c 0073                MOVE.W   #115,-(A7)
//01cad8 4240                     CLR.W    D0
//01cada 102b 0050                MOVE.B   80(A3),D0
//01cade d07c 000f                ADD.W    #15,D0
//01cae2 3f00                     MOVE.W   D0,-(A7)
//01cae4 4ead 00d8                JSR      216(A5)    (=0x000fe2)
//01cae8 588f                     ADDQ.L   #4,A7
//01caea 2200                     MOVE.L   D0,D1
    D1L = Smaller(pcA3->Attributes[Wisdom].Current()+15, 115);
//01caec 201f                     MOVE.L   (A7)+,D0
//01caee b041                     CMP.W    D1,D0
//01caf0 6336                     BLS      $+56 (=0x01cb28)
      if (D0W > D1W)
      {
//01caf2 302e fffc                MOVE.W   -4(A6),D0
//01caf6 3204                     MOVE.W   D4,D1
//01caf8 9246                     SUB.W    D6,D1
//01cafa e268                     LSR.W    D1,D0
//01cafc 3f00                     MOVE.W   D0,-(A7)
//01cafe 4240                     CLR.W    D0
//01cb00 102a 0005                MOVE.B   5(A2),D0
//01cb04 3f00                     MOVE.W   D0,-(A7)
//01cb06 3f07                     MOVE.W   D7,-(A7)
//01cb08 4ead 04d4                JSR      1236(A5)    (=0x01605a)
//01cb0c 5c8f                     ADDQ.L   #6,A7
        AdjustSkills(D7W,                //chIdx
                     pSpell->byte5,       //Which skill
                     w_4 >> (D4W-D6W)); //Experience gained
//01cb0e 4240                     CLR.W    D0
//01cb10 102a 0005                MOVE.B   5(A2),D0
//01cb14 3f00                     MOVE.W   D0,-(A7)
//01cb16 4267                     CLR.W    -(A7)
//01cb18 2f0b                     MOVE.L   A3,-(A7)
//01cb1a 4eba fdf0                JSR      $-526 (=0x01c90c)
//01cb1e 508f                     ADDQ.L   #0,A7
        SpellErrorMsg(pcA3, 0, pSpell->byte5);
//01cb20 303c 0000                MOVE.W   #0,D0
//01cb24 6000 03a4                BRA      $+934 (=0x01ceca)
        return 0;
      };
    };
//01cb28 302e fffa                MOVE.W   -6(A6),D0
//01cb2c 536e fffa                SUBQ.W   #1,-6(A6)
//01cb30 4a40                     TST.W    D0
//01cb32 6696                     BNE      $-104 (=0x01caca)
  };
//01cb34 302a 0006                MOVE.W   6(A2),D0
//01cb38 c07c 000f                AND.W    #15,D0
  switch (pSpell->word6 & 15)
  {
//01cb3c b07c 0001                CMP.W    #1,D0
//01cb40 6704                     BEQ      $+6 (=0x01cb46)
//01cb42 6000 00ae                BRA      $+176 (=0x01cbf2)

  case 1: // make potion, for example.  Needs flask
//01cb46 486e fffe                PEA      -2(A6)
//01cb4a 2f0b                     MOVE.L   A3,-(A7)
//01cb4c 4eba fe64                JSR      $-410 (=0x01c9b2)
//01cb50 508f                     ADDQ.L   #0,A7
//01cb52 2d40 fff6                MOVE.L   D0,-10(A6)
      pDB8_10 = GetFlaskInHand(pcA3, &obj_2);//TAG01c9b2
//01cb56 4a80                     TST.L    D0
//01cb58 6616                     BNE      $+24 (=0x01cb70)
      if (pDB8_10 == NULL)
      {
//01cb5a 4267                     CLR.W    -(A7)
//01cb5c 3f3c 000a                MOVE.W   #10,-(A7)
//01cb60 2f0b                     MOVE.L   A3,-(A7)
//01cb62 4eba fda8                JSR      $-598 (=0x01c90c)
//01cb66 508f                     ADDQ.L   #0,A7
        SpellErrorMsg(pcA3, 10, 0);
//01cb68 303c 0003                MOVE.W   #3,D0
//01cb6c 6000 035c                BRA      $+862 (=0x01ceca)
        return (3);
      };
//01cb70 3f2e fffe                MOVE.W   -2(A6),-(A7)
//01cb74 4ead 0234                JSR      564(A5)    (=0x0091e6)
//01cb78 548f                     ADDQ.L   #2,A7
      D4W = sw(GetObjectWeight(obj_2));
//01cb7a 3800                     MOVE.W   D0,D4
//01cb7c 302a 0006                MOVE.W   6(A2),D0
//01cb80 e848                     LSR.W    #4,D0
//01cb82 c07c 003f                AND.W    #63,D0
//01cb86 206e fff6                MOVE.L   -10(A6),A0
//01cb8a c07c 007f                AND.W    #127,D0
//01cb8e 3600                     MOVE.W   D0,D3
//01cb90 e143                     ASL.W    #8,D3
//01cb92 0268 80ff 0002           AND.W    #33023,2(A0)
//01cb98 8768 0002                OR.W     D3,2(A0)
      pDB8_10->potionType(POTIONTYPE((pSpell->word6>>4)&0x3f));
//01cb9c 4ead 0090                JSR      144(A5)    (=0x001030)
//01cba0 c07c 000f                AND.W    #15,D0
//01cba4 3205                     MOVE.W   D5,D1
//01cba6 c3fc 0028                MULS     #40,D1
//01cbaa d041                     ADD.W    D1,D0
      D3W = sw(40*D5W + STRandom(16));
//01cbac 206e fff6                MOVE.L   -10(A6),A0
//01cbb0 c07c 00ff                AND.W    #255,D0
//01cbb4 3600                     MOVE.W   D0,D3
      D3W &= 255;
//01cbb6 0268 ff00 0002           AND.W    #65280,2(A0)
//01cbbc 8768 0002                OR.W     D3,2(A0)
      pDB8_10->strength(D3W);
//01cbc0 3f2e fffe                MOVE.W   -2(A6),-(A7)
//01cbc4 4ead 0234                JSR      564(A5)    (=0x0091e6)
//01cbc8 548f                     ADDQ.L   #2,A7
//01cbca 9044                     SUB.W    D4,D0
//01cbcc d16b 0110                ADD.W    D0,272(A3)
      pcA3->load = sw(pcA3->load + GetObjectWeight(obj_2) - D4W);
      ASSERT(pcA3->load < MAXLOAD);
//01cbd0 4ead 04c2                JSR      1218(A5)    (=0x015508)
      DrawEightHands();
//01cbd4 302c bf1a                MOVE.W   -16614(A4),D0
//01cbd8 3207                     MOVE.W   D7,D1
//01cbda 5241                     ADDQ.W   #1,D1
//01cbdc b041                     CMP.W    D1,D0
//01cbde 660e                     BNE      $+16 (=0x01cbee)
      if (d.SelectedCharacterOrdinal == D7W+1)
      {
//01cbe0 006b 0200 0030           OR.W     #512,48(A3)
        pcA3->word48 |= 0x200;
//01cbe6 3f07                     MOVE.W   D7,-(A7)
//01cbe8 4ead 04a4                JSR      1188(A5)    (=0x014de0)
//01cbec 548f                     ADDQ.L   #2,A7
        DrawCharacterState(D7W);
      };
//01cbee 6000 02ac                BRA      $+686 (=0x01ce9c)
      break;
//01cbf2 b07c 0002                CMP.W    #2,D0
//01cbf6 6702                     BEQ      $+4 (=0x01cbfa)
//01cbf8 6078                     BRA      $+122 (=0x01cc72)

  case 2: // Fireball, for example
//01cbfa 4240                     CLR.W    D0
//01cbfc 102b 001c                MOVE.B   28(A3),D0
//01cc00 b06c d246                CMP.W    -11706(A4),D0
//01cc04 6716                     BEQ      $+24 (=0x01cc1c)
      if (d.partyFacing != (UI8)(pcA3->facing))
      {
//01cc06 302c d246                MOVE.W   -11706(A4),D0
//01cc0a 1740 001c                MOVE.B   D0,28(A3)
        pcA3->facing = (ui8)d.partyFacing;
//01cc0e 006b 0400 0030           OR.W     #1024,48(A3)
        pcA3->word48 |= 0x400;
//01cc14 3f07                     MOVE.W   D7,-(A7)
//01cc16 4ead 04a4                JSR      1188(A5)    (=0x014de0)
//01cc1a 548f                     ADDQ.L   #2,A7
        DrawCharacterState(D7W);
      };
//01cc1c 302a 0006                MOVE.W   6(A2),D0
//01cc20 e848                     LSR.W    #4,D0
//01cc22 c07c 003f                AND.W    #63,D0
//01cc26 0c40 0004                CMP.W    #4,D0
//01cc2a 6606                     BNE      $+8 (=0x01cc32)
      if (BITS4_9(pSpell->word6) == 4)
      {
//01cc2c 3006                     MOVE.W   D6,D0
//01cc2e e340                     ASL.W    #1,D0
//01cc30 3c00                     MOVE.W   D0,D6
        D6W *= 2;
      };
//01cc32 4267                     CLR.W    -(A7)
//01cc34 3f3c 00ff                MOVE.W   #255,-(A7)
//01cc38 323c 0004                MOVE.W   #4,D1
//01cc3c 3006                     MOVE.W   D6,D0
//01cc3e e340                     ASL.W    #1,D0
//01cc40 d240                     ADD.W    D0,D1
//01cc42 3005                     MOVE.W   D5,D0
//01cc44 5440                     ADDQ.W   #2,D0
//01cc46 c0c1                     MULU     D1,D0
//01cc48 3f00                     MOVE.W   D0,-(A7)
//01cc4a 3f3c 0015                MOVE.W   #21,-(A7)
//01cc4e 4ead 007e                JSR      126(A5)    (=0x00100e)
//01cc52 5c8f                     ADDQ.L   #6,A7
//01cc54 3f00                     MOVE.W   D0,-(A7)
//01cc56 302a 0006                MOVE.W   6(A2),D0
//01cc5a e848                     LSR.W    #4,D0
//01cc5c c07c 003f                AND.W    #63,D0
//01cc60 d07c ff80                ADD.W    #65408,D0
//01cc64 3f00                     MOVE.W   D0,-(A7)
//01cc66 3f07                     MOVE.W   D7,-(A7)
//01cc68 4ead 043e                JSR      1086(A5)    (=0x0174ec)
//01cc6c 508f                     ADDQ.L   #0,A7
      TAG0174ec(
                D7W,
                RN(3,15,BITS4_9(pSpell->word6)+0x380), //0xff80+type
                ApplyLimits(21, (2*D6W+4)*(D5W+2),255),
                0); // required mana
//01cc6e 6000 022c                BRA      $+558 (=0x01ce9c)
      break;
//01cc72 b07c 0003                CMP.W    #3,D0
//01cc76 6704                     BEQ      $+6 (=0x01cc7c)
//01cc78 6000 0222                BRA      $+548 (=0x01ce9c)
  case 3: // Light, for example
//01cc7c 422e fff1                CLR.B    -15(A6)
      timer_20.uByte5 = 0;
//01cc80 3c05                     MOVE.W   D5,D6
//01cc82 5246                     ADDQ.W   #1,D6
//01cc84 e546                     ASL.W    #2,D6
      D6W = sw(4*(D5W + 1));
//01cc86 302a 0006                MOVE.W   6(A2),D0
//01cc8a e848                     LSR.W    #4,D0
//01cc8c c07c 003f                AND.W    #63,D0
      switch (BITS4_9(pSpell->word6))
      {
//01cc90 4a40                     TST.W    D0
//01cc92 6702                     BEQ      $+4 (=0x01cc96)
//01cc94 6018                     BRA      $+26 (=0x01ccae)
      case 0: //(3-4-5) OH IR RA Light
//01cc96 383c 2710                MOVE.W   #10000,D4
          D4W = 10000;
//01cc9a 3206                     MOVE.W   D6,D1
//01cc9c 5141                     SUBQ.W   #0,D1
//01cc9e e341                     ASL.W    #1,D1
//01cca0 e141                     ASL.W    #8,D1
          D1W = sw((D6W - 8) * 512);
//01cca2 d841                     ADD.W    D1,D4
          D4W = sw(D4W + D1W);
//01cca4 3006                     MOVE.W   D6,D0
//01cca6 e248                     LSR.W    #1,D0
//01cca8 3c00                     MOVE.W   D0,D6
          D6W /= 2;
//01ccaa 5346                     SUBQ.W   #1,D6
          D6W--;
//01ccac 601c                     BRA      $+30 (=0x01ccca)
          goto tag01ccca;
//01ccae b07c 0005                CMP.W    #5,D0
//01ccb2 6702                     BEQ      $+4 (=0x01ccb6)
//01ccb4 6036                     BRA      $+56 (=0x01ccec)
      case 5:
//01ccb6 383c 07d0                MOVE.W   #2000,D4
          D4W = sw(4000 + 128 * (D6W-3));
//01ccba 3206                     MOVE.W   D6,D1
//01ccbc 5741                     SUBQ.W   #3,D1
//01ccbe ef41                     ASL.W    #7,D1
//01ccc0 d841                     ADD.W    D1,D4
//01ccc2 3006                     MOVE.W   D6,D0
//01ccc4 e448                     LSR.W    #2,D0
//01ccc6 3c00                     MOVE.W   D0,D6
//01ccc8 5246                     ADDQ.W   #1,D6
          D6W = sw(D6W/4 + 1);
tag01ccca:
//01ccca 3006                     MOVE.W   D6,D0
//01cccc e380                     ASL.L    #1,D0
//01ccce 41ec fbce                LEA      -1074(A4),A0
//01ccd2 d0c0                     ADD.W    D0,A0
//01ccd4 3010                     MOVE.W   (A0),D0
//01ccd6 d16c cc1e                ADD.W    D0,-13282(A4)
          ASSERT(D6W < 16);
          d.Brightness = sw(d.Brightness + d.Word1074[D6W]);
//01ccda 3f04                     MOVE.W   D4,-(A7)
//01ccdc 3006                     MOVE.W   D6,D0
//01ccde 4440                     NEG.W    D0
//01cce0 3f00                     MOVE.W   D0,-(A7)
//01cce2 4eba f154                JSR      $-3754 (=0x01be38)
//01cce6 588f                     ADDQ.L   #4,A7
          SetBrightnessTimer(-D6W, D4W); // Set to decrement brightness later
//01cce8 6000 01b2                BRA      $+436 (=0x01ce9c)
         break;
//01ccec b07c 0001                CMP.W    #1,D0
//01ccf0 6702                     BEQ      $+4 (=0x01ccf4)
//01ccf2 6026                     BRA      $+40 (=0x01cd1a)
      case 1: //(5-4-6 spell) DES IR SAR  Darkness
//01ccf4 3006                     MOVE.W   D6,D0
//01ccf6 e448                     LSR.W    #2,D0
//01ccf8 3c00                     MOVE.W   D0,D6
          D6W /= 4;
//01ccfa 3006                     MOVE.W   D6,D0
//01ccfc e380                     ASL.L    #1,D0
//01ccfe 41ec fbce                LEA      -1074(A4),A0
//01cd02 d0c0                     ADD.W    D0,A0
//01cd04 3010                     MOVE.W   (A0),D0
          D0W = d.Word1074[D6W];
//01cd06 916c cc1e                SUB.W    D0,-13282(A4)
          d.Brightness = sw(d.Brightness - D0W);
//01cd0a 3f3c 0062                MOVE.W   #98,-(A7)
//01cd0e 3f06                     MOVE.W   D6,-(A7)
//01cd10 4eba f126                JSR      $-3800 (=0x01be38)
//01cd14 588f                     ADDQ.L   #4,A7
          SetBrightnessTimer(D6W, 98);
//01cd16 6000 0184                BRA      $+390 (=0x01ce9c)
          break;
//01cd1a b07c 0002                CMP.W    #2,D0
//01cd1e 6702                     BEQ      $+4 (=0x01cd22)
//01cd20 6012                     BRA      $+20 (=0x01cd34)
      case 2: // 3-2-5  OH EW RA See thru walls
//01cd22 1d7c 0049 fff0           MOVE.B   #73,-16(A6)
          timer_20.function = 73;
//01cd28 522c cc20                ADDQ.B   #1,-13280(A4)
          d.SeeThruWalls++;
//01cd2c 3006                     MOVE.W   D6,D0
//01cd2e e248                     LSR.W    #1,D0
//01cd30 3c00                     MOVE.W   D0,D6
          D6W /= 2;
//01cd32 6070                     BRA      $+114 (=0x01cda4)
          goto tag01cda4;
//01cd34 b07c 0003                CMP.W    #3,D0
//01cd38 6702                     BEQ      $+4 (=0x01cd3c)
//01cd3a 600c                     BRA      $+14 (=0x01cd48)
      case 3: //(3-2-6) OH EW SAR = invisibility
//01cd3c 1d7c 0047 fff0           MOVE.B   #71,-16(A6)
          timer_20.function = 71;
//01cd42 522c cc74                ADDQ.B   #1,-13196(A4)
          d.Invisible++;
//01cd46 6062                     BRA      $+100 (=0x01cdaa)
          goto tag01cdaa;
//01cd48 b07c 0004                CMP.W    #4,D0
//01cd4c 6702                     BEQ      $+4 (=0x01cd50)
//01cd4e 602a                     BRA      $+44 (=0x01cd7a)
      case 4: // 1-4 YA-IR
//01cd50 1d7c 004a fff0           MOVE.B   #74,-16(A6)
          timer_20.function = 74;
//01cd56 3d46 fff2                MOVE.W   D6,-14(A6)
          timer_20.word6() = D6W;
//01cd5a 0c6c 0032 cc22           CMP.W    #50,-13278(A4)
//01cd60 6f0a                     BLE      $+12 (=0x01cd6c)
          if (d.Word13278 > 50)
          {
//01cd62 302e fff2                MOVE.W   -14(A6),D0
//01cd66 e440                     ASR.W    #2,D0
//01cd68 3d40 fff2                MOVE.W   D0,-14(A6)
            timer_20.word6() >>= 2;
          };
//01cd6c 302e fff2                MOVE.W   -14(A6),D0
//01cd70 d16c cc22                ADD.W    D0,-13278(A4)
          d.Word13278 = sw(d.Word13278 + timer_20.word6());
//01cd74 4ead 0384                JSR      900(A5)    (=0x011664)
          MarkAllChar1000();
//01cd78 602a                     BRA      $+44 (=0x01cda4)
          goto tag01cda4;
//01cd7a b07c 0006                CMP.W    #6,D0
//01cd7e 6702                     BEQ      $+4 (=0x01cd82)
//01cd80 6056                     BRA      $+88 (=0x01cdd8)
      case 6: //1-5-2 YA-BRO-ROS
//01cd82 1d7c 004f fff0           MOVE.B   #79,-16(A6)
          timer_20.function = 79;
//01cd88 522c cc21                ADDQ.B   #1,-13279(A4)
          d.Byte13279++;
//01cd8c 196c cc28 cc2a           MOVE.B   -13272(A4),-13270(A4)
          d.Byte13270 = d.NumHistEnt;
//01cd92 0c45 0003                CMP.W    #3,D5
//01cd96 6c08                     BGE      $+10 (=0x01cda0)
          if (D5W < 3)
          {
//01cd98 196c cc2a cc2b           MOVE.B   -13270(A4),-13269(A4)
            d.Byte13269 = d.Byte13270;
//01cd9e 6004                     BRA      $+6 (=0x01cda4)
          }
          else
          {
//01cda0 422c cc2b                CLR.B    -13269(A4)
            d.Byte13269 = 0;
          };
tag01cda4:
//01cda4 3006                     MOVE.W   D6,D0
//01cda6 c0c6                     MULU     D6,D0
//01cda8 3c00                     MOVE.W   D0,D6
          D6W = sw(D6W * D6W);
tag01cdaa:
//01cdaa 202c d23a                MOVE.L   -11718(A4),D0
          D0L = d.Time;
//01cdae ccbc 0000 ffff           AND.L    #65535,D6
          D6L &= 0xffff;
//01cdb4 d086                     ADD.L    D6,D0
          D0L += D6L;
//01cdb6 322c d244                MOVE.W   -11708(A4),D1
//01cdba 48c1                     EXT.L    D1
//01cdbc 263c 0000 0018           MOVE.L   #24,D3
//01cdc2 e7a1                     ASL.L    D3,D1
          D1L = d.partyLevel << 24;
//01cdc4 8081                     OR.L     D1,D0
//01cdc6 2d40 ffec                MOVE.L   D0,-20(A6)
          timer_20.time = D1L | D0L;
//01cdca 486e ffec                PEA      -20(A6)
//01cdce 4ead 0366                JSR      870(A5)    (=0x00ffbe)
//01cdd2 588f                     ADDQ.L   #4,A7
          SetTimer(&timer_20);
//01cdd4 6000 00c6                BRA      $+200 (=0x01ce9c)
          break;
//01cdd8 b07c 0007                CMP.W    #7,D0
//01cddc 6704                     BEQ      $+6 (=0x01cde2)
//01cdde 6000 009c                BRA      $+158 (=0x01ce7c)
      case 7:
//01cde2 3f3c 000a                MOVE.W   #10,-(A7)
//01cde6 4ead 0228                JSR      552(A5)    (=0x00a0b0)
//01cdea 548f                     ADDQ.L   #2,A7
//01cdec 3d40 fffe                MOVE.W   D0,-2(A6)
          obj_2 = FindEmptyDB10Entry(false);
//01cdf0 0c40 ffff                CMP.W    #65535,D0
//01cdf4 6604                     BNE      $+6 (=0x01cdfa)
//01cdf6 6000 00a4                BRA      $+166 (=0x01ce9c)
          if (obj_2 == RNnul) break;
//01cdfa 3f2e fffe                MOVE.W   -2(A6),-(A7)
//01cdfe 4ead 0312                JSR      786(A5)    (=0x009984)
//01ce02 548f                     ADDQ.L   #2,A7
//01ce04 2d40 ffe8                MOVE.L   D0,-24(A6)
          pDB10_24 = GetRecordAddressDB10(obj_2);
//01ce08 303c 0033                MOVE.W   #51,D0
//01ce0c 206e ffe8                MOVE.L   -24(A6),A0
//01ce10 c07c 007f                AND.W    #127,D0
//01ce14 3600                     MOVE.W   D0,D3
//01ce16 0268 ff80 0002           AND.W    #65408,2(A0)
//01ce1c 8768 0002                OR.W     D3,2(A0)
          SETWBITS0_6(pDB10_24->word2, 51);
//01ce20 0c6b ffff 00d4           CMP.W    #65535,212(A3)
//01ce26 6604                     BNE      $+6 (=0x01ce2c)
          if (pcA3->possessions[0] == RNnul)
          {
//01ce28 4246                     CLR.W    D6
//01ce2a 6012                     BRA      $+20 (=0x01ce3e)
            D6W = 0;
          }
          else
          {
//01ce2c 0c6b ffff 00d6           CMP.W    #65535,214(A3)
//01ce32 6606                     BNE      $+8 (=0x01ce3a)
            if (pcA3->possessions[1] == RNnul)
            {
//01ce34 3c3c 0001                MOVE.W   #1,D6
              D6W = 1;
//01ce38 6004                     BRA      $+6 (=0x01ce3e)
            }
            else
            {
//01ce3a 3c3c ffff                MOVE.W   #65535,D6
              D6W = -1;
            };
          };
//01ce3e 4a46                     TST.W    D6
//01ce40 6706                     BEQ      $+8 (=0x01ce48)
//01ce42 0c46 0001                CMP.W    #1,D6
//01ce46 6618                     BNE      $+26 (=0x01ce60)
          if ((D6W == 0) || (D6W==1))
          {
//01ce48 3f06                     MOVE.W   D6,-(A7)
//01ce4a 3f2e fffe                MOVE.W   -2(A6),-(A7)
//01ce4e 3f07                     MOVE.W   D7,-(A7)
//01ce50 4ead 04e6                JSR      1254(A5)    (=0x015c4c)
//01ce54 5c8f                     ADDQ.L   #6,A7
            PlaceObjectOnCharacter(chIdx, obj_2, D6W);
//01ce56 3f07                     MOVE.W   D7,-(A7)
//01ce58 4ead 04a4                JSR      1188(A5)    (=0x014de0)
//01ce5c 548f                     ADDQ.L   #2,A7
            DrawCharacterState(chIdx);
//01ce5e 601a                     BRA      $+28 (=0x01ce7a)
          }
          else
          {
//01ce60 3f2c d248                MOVE.W   -11704(A4),-(A7)
//01ce64 3f2c d24a                MOVE.W   -11702(A4),-(A7)
//01ce68 4267                     CLR.W    -(A7)
//01ce6a 3f3c ffff                MOVE.W   #65535,-(A7)
//01ce6e 3f2e fffe                MOVE.W   -2(A6),-(A7)
//01ce72 4ead 03a2                JSR      930(A5)    (=0x011f52)
//01ce76 defc 000a                ADD.W    #10,A7
            MoveObject(obj_2, -1, 0, d.partyX, d.partyY);
          };
//01ce7a 6020                     BRA      $+34 (=0x01ce9c)
          break;
//01ce7c b07c 0008                CMP.W    #8,D0
//01ce80 6702                     BEQ      $+4 (=0x01ce84)
//01ce82 6018                     BRA      $+26 (=0x01ce9c)
      case 8:
//01ce84 4267                     CLR.W    -(A7)
//01ce86 3006                     MOVE.W   D6,D0
//01ce88 c0c6                     MULU     D6,D0
//01ce8a d07c 0064                ADD.W    #100,D0
//01ce8e 3f00                     MOVE.W   D0,-(A7)
//01ce90 4267                     CLR.W    -(A7)
//01ce92 2f0b                     MOVE.L   A3,-(A7)
//01ce94 4eba eec8                JSR      $-4406 (=0x01bd5e)
//01ce98 defc 000a                ADD.W    #10,A7
          TAG01bd5e(pcA3, 0, D6W * D6W + 100, 0);
          break;
      default: NotImplemented(0x1ce98);
      }; //switch
  }; // switch
//01ce9c 3f2e fffc                MOVE.W   -4(A6),-(A7)
//01cea0 4240                     CLR.W    D0
//01cea2 102a 0005                MOVE.B   5(A2),D0
//01cea6 3f00                     MOVE.W   D0,-(A7)
//01cea8 3f07                     MOVE.W   D7,-(A7)
//01ceaa 4ead 04d4                JSR      1236(A5)    (=0x01605a)
//01ceae 5c8f                     ADDQ.L   #6,A7
  AdjustSkills(D7W,          //chIdx
               pSpell->byte5, //Which skill
               w_4);          //Experience gained
//01ceb0 302a 0006                MOVE.W   6(A2),D0
//01ceb4 e448                     LSR.W    #2,D0
//01ceb6 e048                     LSR.W    #8,D0
//01ceb8 c07c 003f                AND.W    #63,D0
//01cebc 3f00                     MOVE.W   D0,-(A7)
//01cebe 3f07                     MOVE.W   D7,-(A7)
//01cec0 4ead 0432                JSR      1074(A5)    (=0x017756)
//01cec4 588f                     ADDQ.L   #4,A7
  DisableCharacterAction(D7W, BITS10_15(pSpell->word6));
//01cec6 303c 0001                MOVE.W   #1,D0
  return (1);
//01ceca 4cdf 0cf0                MOVEM.L  (A7)+,D4567A23
//01cece 4e5e                     UNLK     A6
//01ced0 4e75                     RTS
}
