#include "stdafx.h"

#include "UI.h"

#include <stdio.h>

#include "Objects.h"
#include "Dispatch.h"
#include "CSB.h"
#include "Data.h"

//#ifdef _DEBUG

void traceFlash (char * /*msg*/,i32 /*x*/,i32 /*y*/)
{
  /*
  if (x==-1) 
  {
    if (TraceFileActive)
    {
      fprintf(TraceFile,"%08x %s\n",d.Time,msg);
    };
    return;
  };
  if (TraceFileActive)
  {
    char *name = "??????";
    fprintf(TraceFile,"%08x vblFlashButn x=%d,y=%d",d.Time, x,y);
    switch (x)
    {
    case 291:
      switch (y)
      {
      case 125: name = "Turn Right"; break;
      case 147: name = "Slide Right"; break;
      };
      break;
    case 263:
      switch (y)
      {
      case 125: name = "Forward"; break;
      case 147: name = "Backward"; break;
      };
      break;
    case 234:
      switch (y)
      {
      case 125: name = "Turn Left"; break;
      case 147: name = "Slide Left"; break;
      };
      break;
    };
    fprintf(TraceFile," %s\n",name);
  };
  */
}


//  TAG00091c
void vblFlashButn(i16 x1,i16 x2,i16 y1,i16 y2) // called by VBL handler
{ // x1, x2, y1, y2 come directly from d.MoveButn
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;       
  dReg D0, D1, D2, D3, D4, D5, D6, D7;
  aReg A0, A1;
//00091c 4e56 0000                LINK     A6,#0   
//000920 48e7 0f00                MOVEM.L  D4567,-(A7)   
  traceFlash("vblFlashButn", x1, y1);
//000924 206c d132                MOVE.L   -11982(A4),A0   
  A0 = d.LogicalScreenBase;
//000928 3a2e 000c                MOVE.W   12(A6),D5   
  D5W = y1;
//00092c 302e 000e                MOVE.W   14(A6),D0   
  D0W = sw(y2-y1); // line counter
//000930 9045                     SUB.W    D5,D0   
//000932 cafc 00a0                MULU     #160,D5   
//000936 d0c5                     ADD.W    D5,A0   
  A0 += 160*y1;
//000938 3a2e 0008                MOVE.W   8(A6),D5   
  D5W = x1;
  D6W = x1;
//00093c 3c05                     MOVE.W   D5,D6   
//00093e e24d                     LSR.W    #1,D5   
//000940 0245 00f8                AND.W    #248,D5   
  D5W = (I16)((D5W >> 1) & 0x00f8);
  D7W = D5W;
//000944 3e05                     MOVE.W   D5,D7   
//000946 d0c5                     ADD.W    D5,A0   
  A0 += D5W+4;
//000948 5888                     ADDQ.L   #4,A0   
//00094a 0246 000f                AND.W    #15,D6   
  D6W &= 15;
//00094e 363c ffff                MOVE.W   #65535,D3   
//000952 3803                     MOVE.W   D3,D4   
  D3L = D4L = 0xffff;
//000954 ec6b                     LSR.W    D6,D3   
  D3H1 = 0; D3L >>= D6W;
//000956 3a2e 000a                MOVE.W   10(A6),D5   
  D5W = x2;
//00095a 3c05                     MOVE.W   D5,D6   
  D6W = (I16)((D5W>>1) & 0x00f8);
//00095c e24e                     LSR.W    #1,D6   
//00095e 0246 00f8                AND.W    #248,D6   
//000962 0245 000f                AND.W    #15,D5   
  D5W &= 15;
//000966 4445                     NEG.W    D5   
//000968 0645 000f                ADD.W    #15,D5   
  D5W = sw(15 - D5W);
//00096c eb6c                     LSL.W    D5,D4   
  D4W <<= D5W;
//00096e be46                     CMP.W    D6,D7   
//000970 6746                     BEQ      $+72 (=0x0009b8)   
  if (D7W != D6W)
  {
//000972 3206                     MOVE.W   D6,D1   
//000974 9247                     SUB.W    D7,D1   
//000976 5141                     SUBQ.W   #0,D1   
//000978 e649                     LSR.W    #3,D1   
    D1W = (I16)((((D6W - D7W) - 8) >> 3) & 0x1fff);
//00097a 43e8 00a0                LEA      160(A0),A1   
tag00097a:
    A1 = A0 + 160;
//00097e 3a10                     MOVE.W   (A0),D5   
//000980 3c05                     MOVE.W   D5,D6   
    D6W = LE16(wordGear(A0));
//000982 4645                     NOT.W    D5   
    D5W = (UI16)(D6W ^ 0xffff);
//000984 ca43                     AND.W    D3,D5   
    D5W &= D3W;
//000986 3e03                     MOVE.W   D3,D7   
//000988 4647                     NOT.W    D7   
    D7W = (UI16)(D3W ^ 0xffff);
//00098a cc47                     AND.W    D7,D6   
//00098c 8c45                     OR.W     D5,D6   
    D6W = (UI16)((D6W & D7W) | D5W);
//00098e 3086                     MOVE.W   D6,(A0)   
    wordGear(A0) = LE16(D6W);
//000990 5088                     ADDQ.L   #0,A0   
    A0 += 8;
//000992 3401                     MOVE.W   D1,D2   
    D2W = D1W;
//000994 6004                     BRA      $+6 (=0x00099a)   
    goto tag0099a;
tag000996:
//000996 4650                     NOT.W    (A0)   
    wordGear(A0) ^= 0xffff;
    A0 += 8;
//000998 5088                     ADDQ.L   #0,A0   
tag0099a:
//00099a 51ca fffa                DBF      D2,$-4 (=0x000996)   
    if (--D2W >= 0) goto tag000996;
//00099e 3a10                     MOVE.W   (A0),D5   
    D5W = LE16(wordGear(A0));
//0009a0 3c05                     MOVE.W   D5,D6   
//0009a2 4645                     NOT.W    D5   
    D6W = D5W;
    D5W ^= 0xffff;
//0009a4 ca44                     AND.W    D4,D5   
    D5W &= D4W;
//0009a6 3e04                     MOVE.W   D4,D7   
//0009a8 4647                     NOT.W    D7   
    D7W = (UI16)(D4W ^ 0xffff);
//0009aa cc47                     AND.W    D7,D6   
//0009ac 8c45                     OR.W     D5,D6   
    D6W = (UI16)((D6W & D7W) | D5W);
//0009ae 3086                     MOVE.W   D6,(A0)   
    wordGear(A0) = LE16(D6W);
//0009b0 2049                     MOVE.L   A1,A0   
    A0 = A1;
//0009b2 51c8 ffc6                DBF      D0,$-56 (=0x00097a)   
    if (--D0W >= 0) goto tag00097a;
//0009b6 601c                     BRA      $+30 (=0x0009d4)   
  }
  else
  {
//0009b8 c644                     AND.W    D4,D3   
    D3W &= D4W;
//0009ba 3a10                     MOVE.W   (A0),D5   
tag0009ba:
    D5W = LE16(wordGear(A0));
//0009bc 3c05                     MOVE.W   D5,D6   
    D6W = D5W;
//0009be 4645                     NOT.W    D5   
    D5W ^= 0xffff;
//0009c0 ca43                     AND.W    D3,D5   
    D5W &= D3W;
//0009c2 3e03                     MOVE.W   D3,D7   
    D7W = (UI16)(D3W ^ 0xffff);
//0009c4 4647                     NOT.W    D7   
//0009c6 cc47                     AND.W    D7,D6   
    D6W &= D7W;
//0009c8 8c45                     OR.W     D5,D6   
    D6W |= D5W;
//0009ca 3086                     MOVE.W   D6,(A0)   
    wordGear(A0) = LE16(D6W);
//0009cc 41e8 00a0                LEA      160(A0),A0
    A0 += 160;
//0009d0 51c8 ffe8                DBF      D0,$-22 (=0x0009ba)   
    if (--D0W >= 0) goto tag0009ba;
  };
//0009d4 4cdf 00f0                MOVEM.L  (A7)+,D4567   
//0009d8 4e5e                     UNLK     A6   
//0009da 4e75                     RTS         
}