#include "stdafx.h"

#include "UI.h"

#include <stdio.h>

#include "Objects.h"
#include "Dispatch.h"
#include "CSB.h"
#include "Data.h"


extern unsigned int numRandomCalls;
extern i32 VBLMultiplier;

//   TAG00133e
void ClearHeldObjectName(void)
{
  FillRectangle(d.LogicalScreenBase,
                &d.wRectPos624,
                0,
                160);
}

//   TAG004308
void FloorAndCeilingOnly(void)
{
  static i32 count=0;
  if ((VBLMultiplier!=1) && (((count++)%1) != 0)) return;
  Instrumentation(icntFloorAndCeiling);
  ClearMemory(d.Pointer2078,4144);//space between floor and ceiling
  MemMove(d.Pointer2074, d.pViewportBMP, 3248);//ceiling
  MemMove(d.Pointer2070, d.Pointer2082, 7840);//floor
  d.Word11684=0;
}


//   TAG00788c
void DrawCellF1R1(i32 facing,i32 mapX,i32 mapY)
{
  dReg D4;
  SUMMARIZEROOMDATA roomData;
  //D7W=P1;D6W=P2,D5W=P3;
  SummarizeRoomInfo(&roomData,facing,mapX,mapY);
  if (roomData.roomType == roomType19)     goto case19;
  if (roomData.roomType == roomSTONE)      goto case00;
  if (roomData.roomType == roomType18)     goto case18;
  if (roomData.roomType == roomDOOREDGE)   goto case16;
  if (roomData.roomType == roomDOORFACING) goto case17;
  if (roomData.roomType == roomPIT)        goto case02;
  if (roomData.roomType == roomTELEPORTER) goto case05;
  if (roomData.roomType == roomOPEN)       goto case01;
  goto finish;
case19:
  if (roomData.word4[0] != 0) TAG0044fe(d.Word1880,(RectPos *)d.Byte2618);
  else TAG0044fe(d.Word1894,(RectPos *)d.Byte2706);
  goto case01;

case00:
  //ClearViewport(); // xxxxxxxxtra
  TAG00437e(d.Pointer2102, (RectPos *)d.Byte3010);
  TAG0045ae(roomData.word4[2],11);
  goto exit;

case18:
  if (roomData.word4[0] != 0) TAG0044fe(d.Word1902, (RectPos *)d.Byte2754);
  else TAG0044fe(d.Word1904,(RectPos *)d.Byte2770);

case16:
  D4W = 65;
  goto tag0079e2;

case17:
  TAG004a1a(roomData.word4[2],8);
  DrawRoomObjects(roomData.rn2,facing,mapX,mapY,8,24);
  TAG00437e(d.Pointer2118, (RectPos *)d.Byte3194);
  DrawDoor(roomData.word4[1],roomData.word4[0],d.Word1918,0x1080,2,d.Byte3914);
  D4W = 73;
  goto tag007a08;

case02:
  TAG0044fe(roomData.word4[0]!=0?59:53,(RectPos *)d.Byte2858);
case01:
case05:
  D4W = 65;
tag0079e2:
  TAG004a1a(roomData.word4[2],8);
  CheckCeilingPit(65,(RectPos *)d.Byte2930,mapX,mapY,1);
tag007a08:
  DrawRoomObjects(roomData.rn2,facing,mapX,mapY,8,D4W);
finish:
  if (roomData.roomType != roomTELEPORTER) goto exit;
  if (roomData.word4[0] == 0) goto exit;
  TAG004f82(d.Byte3946,(RectPos *)d.Byte3010); /*,roomData);*/
exit:
  return;
}

//*********************************************************
//
//*********************************************************
//   TAG007a4a
void DrawCellF1(i32 facing,i32 mapX,i32 mapY,bool skipDrawing)
{
  dReg D0, D4;
  DB0 *pDB0;
  //i16 *pwA0;
  SUMMARIZEROOMDATA roomData;
  pnt LOCAL_14;
  //D7W = P1; D6W = P2; D5W = P3;
  SummarizeRoomInfo(&roomData,facing,mapX,mapY);//very quick
  d.CellTypeJustAhead = sw(roomData.roomType);
  if (roomData.roomType == roomType19)     goto case19;
  if (roomData.roomType == roomSTONE)      goto case00;
  if (roomData.roomType == roomDOORFACING) goto case17;
  if (roomData.roomType == roomPIT)        goto case02;
  if (roomData.roomType == roomTELEPORTER) goto case05;
  if (roomData.roomType == roomOPEN)       goto case01;
  goto finish;
case19:
  if (skipDrawing) goto case01;
  if (roomData.word4[0] != 0) TAG0044b0(d.Word1882, (RectPos *)d.Byte2610);
  else TAG0044b0(d.Word1896, (RectPos *)d.Byte2698);
  goto case01;
case00:
  d.Word10536 = d.Word10534 = d.Word10532 = 0;
  if (d.SeeThruWalls != 0)
  {
    TAG022c90(1);
    if (!skipDrawing)
    TAG0088b2(d.pViewportBMP,
              TAG022d38(1),
              (RectPos *)d.Word2538,
              d.uByte2534[0],
              d.uByte2534[2],
              112,
              48,
              -1);
    LOCAL_14 = GetGraphicAddress(41);
    if (!skipDrawing)
    TAG0088b2(LOCAL_14,
              TAG022d38(1),
              (RectPos *)d.Word2538,
              0,
              0,
              48,
              48,
              10);
  };
  //ClearViewport();
  if (!skipDrawing)
  TAG0043c4(d.Pointer2102, (RectPos *)d.uByte3026);//Draw blocks
  D0W = TAG0045ae(roomData.word4[1],12);//Draws wall decorations
  if (D0W != 0)
  {
    //if (!skipDrawing)
    DrawRoomObjects(roomData.rn2,facing,mapX,mapY,6,0);
  };
  if (d.SeeThruWalls != 0)
  {
    TAG0088b2(TAG022d38(1),
              d.pViewportBMP,
              (RectPos *)d.uByte2534, //0x40,0x9f,0x13,0x71
              0,
              0,
              48,
              112,
              9);
    TAG022d5e(1);
    DeleteGraphic((ui16)0x8001);
  };
  goto exit;
case17:
  TAG004a1a(roomData.word4[2], 7);
  DrawRoomObjects(roomData.rn2,facing,mapX,mapY,6,0x218);
  TAG00437e(d.Pointer2118, (RectPos *)d.Byte3186);
  TAG00437e(d.Pointer2134, (RectPos *)d.Byte3130);
  TAG00437e(d.Pointer2142, (RectPos *)d.Byte3138);
  //A0 = (pnt)d.misc1052eight[0] + roomData.word4[1]*4;
  //D0W = (wordGear(A0+2)>>6) & 1;
  //if (D0W != 0) DrawDoorSwitch(1,3);
  pDB0 = GetRecordAddressDB0(RN(0,0,roomData.word4[1]));
  if (pDB0->doorSwitch()) DrawDoorSwitch(1, 3);
  DrawDoor(roomData.word4[1],roomData.word4[0],d.Word1918,0x1080,2,d.Byte3834);
  D4W = 841;
  goto tag007cbe;
case02:
  if (!skipDrawing)
  TAG0044b0(roomData.word4[0]!=0?60:54, (RectPos *)d.Byte2850);

case01:
case05:
  D4W = 13345;
  TAG004a1a(roomData.word4[2],7);
  if (!skipDrawing)
  CheckCeilingPit(66,(RectPos *)d.Byte2922,mapX,mapY,0);
tag007cbe:
  //if (!skipDrawing)
  DrawRoomObjects(roomData.rn2,facing,mapX,mapY,6,D4W);
finish:
  if (roomData.roomType != roomTELEPORTER) goto exit;
  if (roomData.word4[0] == 0) goto exit;
  if (!skipDrawing)
  TAG004f82(d.Byte3962,(RectPos *)d.uByte3026 /*,roomData*/);
exit:
  return;
}

//   TAG006b20
void DrawCellF3L1(i32 facing,i32 mapX,i32 mapY)
{
  dReg D0, D4;
  ROOMTYPE rtD0;
  SUMMARIZEROOMDATA roomData; // array???
//  D7W = P1;
//  D6W = P2;
//  D5W = P3;
  SummarizeRoomInfo(&roomData, facing, mapX, mapY);
  rtD0 = roomData.roomType;
  if (rtD0 != roomType19) goto tag006b7a;
  D0W = roomData.word4[0];
  if (D0W == 0) goto tag006b68;
  TAG0044b0(d.Word1872, (RectPos *)d.Byte2554);
  goto tag006b76;
tag006b68:
  TAG0044b0(d.Word1886, (RectPos *)d.Byte2642);
tag006b76:
  goto tag006c56;
tag006b7a:
  if (rtD0 != roomSTONE) goto tag006bb6;
  TAG00437e(d.Pointer2094, (RectPos *)d.Byte3066);
  TAG0045ae(roomData.word4[0],0);
  D0W = TAG0045ae(roomData.word4[1], 2);
  if (D0W == 0) goto tag006bb2;
  D4W = 0;
  goto tag006c66;
tag006bb2:
  goto tag006c9a;
tag006bb6:
  if (rtD0 == roomDOOREDGE) goto tag006bc4;
  if (rtD0 != roomType18) goto tag006bcc;
tag006bc4:
  D4W = 801;
  goto tag006c5a;
tag006bcc:
  if (rtD0 != roomDOORFACING) goto tag006c2a;
  TAG004a1a(roomData.word4[2], 0);
  DrawRoomObjects(roomData.rn2, facing, mapX, mapY, 1, 0x218);
  TAG00437e(d.Pointer2122, (RectPos *)d.Byte3082);
  DrawDoor(roomData.word4[1], roomData.word4[0], d.Word1910, 984, 0,d.Byte3274);
  D4W = 841;
  goto tag006c66;
tag006c2a:
  if (rtD0 != roomPIT) goto tag006c48;
  D0W = roomData.word4[0];
  if (D0W != 0) goto tag006c46;
  TAG0044b0(49, (RectPos *)d.Byte2794);
tag006c46:
  goto tag006c56;
tag006c48:
  if (rtD0 == roomTELEPORTER) goto tag006c56;
  if (rtD0 != roomOPEN) goto tag006c7e;
tag006c56:
  D4W = 13345;
tag006c5a:
  TAG004a1a(roomData.word4[2], 0);
tag006c66:
  DrawRoomObjects(roomData.rn2, facing, mapX, mapY, 1, D4W);
tag006c7e:
  if (roomData.roomType == roomTELEPORTER)
  {
    if (roomData.word4[0] != 0)
    {
      TAG004f82(d.Byte4002, (RectPos *)d.Byte3066);
    };
  };
tag006c9a: return;
}

//   TAG006ca2
void DrawCellF3R1(i32 facing,i32 mapX,i32 mapY)
{
  dReg D0, D4;
  DB0 *pDB0;
  //i16 *pwA0;
  //i32 D4=0, D5, D6, D7;
  SUMMARIZEROOMDATA roomData;
  D4L = 0;
  //D7W = P1;
  //D6W = P2;
  //D5W = P3;
  SummarizeRoomInfo(&roomData, facing, mapX, mapY);
  if (roomData.roomType == roomType19)     goto case19;
  if (roomData.roomType == roomSTONE)      goto case00;
  if (roomData.roomType == roomDOOREDGE)   goto case16;
  if (roomData.roomType == roomType18)     goto case18;
  if (roomData.roomType == roomDOORFACING) goto case17;
  if (roomData.roomType == roomPIT)        goto case02;
  if (roomData.roomType == roomTELEPORTER) goto case05;
  if (roomData.roomType == roomOPEN)       goto case01;
  goto finish;
case19:
  if (roomData.word4[0] != 0) TAG0044fe(d.Word1872, (RectPos *)d.Byte2570);
  else TAG0044fe(d.Word1886, (RectPos *)d.Byte2658);
  goto case01;
case00:
  TAG00437e(d.Pointer2094, (RectPos *)d.Byte3058);
  TAG0045ae(roomData.word4[2], 1);
  D0W = TAG0045ae(roomData.word4[1], 4);
  if (D0W == 0) goto tag006e5e;
  goto tag006e2a;
case16:
case18:
  D4W = 1042;
  goto tag006e1c;
case17:
  TAG004a1a(roomData.word4[2], 2);
  DrawRoomObjects(roomData.rn2,facing, mapX, mapY,2,296);
  MemMove(d.Pointer2122, d.Pointer1848, 704);
  TAG004450(d.Pointer1848, d.Byte3090);
  //A0 = (pnt)d.misc1052eight[0] + roomData.word4[1]*4;
  //D0W = (wordGear(A0+2) >> 6) & 1;
  //if (D0W != 0) DrawDoorSwitch(1, 0);
  pDB0 = GetRecordAddressDB0(RN(0,0,roomData.word4[1]));
  if (pDB0->doorSwitch()) DrawDoorSwitch(1, 0);
  DrawDoor(roomData.word4[1],roomData.word4[0],d.Word1910,984,0,d.Byte3434);
  D4W = 1081;
  goto tag006e2a;
case02:
  if (roomData.word4[0] == 0) TAG0044fe(49, (RectPos *)d.Byte2810);
case01:
case05:
  D4W = 17170; // 0x4312
tag006e1c:
  TAG004a1a(roomData.word4[2], 2);
tag006e2a:
  DrawRoomObjects(roomData.rn2,facing, mapX, mapY,2,D4W);
finish:
  if (roomData.roomType == roomTELEPORTER)
  {
    if (roomData.word4[0] != 0)
             //TAG004f82(d.Byte3994, (RectPos *)d.Byte3058);
             // I replaced the 3994 with 4002 because 3994[3]
             // was zero and cause TAG004f82 to use NULL as a
             // source pointer.  This seems to cause no harm
             // on the ATARI.  In fact, it seems to make no
             // difference what data is used.
             TAG004f82(d.Byte4002, (RectPos *)d.Byte3058);
  };
tag006e5e:
  return;
}

//   TAG006e66
void DrawCellF3(i32 facing,i32 mapX,i32 mapY)
{
  dReg D0, D4;
  DB0 *pDB0;
  SUMMARIZEROOMDATA roomData;
  //void (*fn)(i32, i32, i32) = NULL;
  SummarizeRoomInfo(&roomData, facing, mapX, mapY);
  if (roomData.roomType == roomType19)     goto case19;
  if (roomData.roomType == roomSTONE)      goto case00;
  if (roomData.roomType == roomDOORFACING) goto case17;
  if (roomData.roomType == roomPIT)        goto case02;
  if (roomData.roomType == roomTELEPORTER) goto case05;
  if (roomData.roomType == roomOPEN)       goto case01;
  goto finish;
case19:
  if (roomData.word4[0] != 0) TAG0044b0(d.Word1874, (RectPos *)d.Byte2562);
  else TAG0044b0(d.Word1888, (RectPos *)d.Byte2650);
  goto case01;
case00:
  TAG0043c4(d.Pointer2094, (RectPos *)d.Byte3074);
  D0W = TAG0045ae(roomData.word4[1], 3);
  if (D0W == 0) goto exit;
  D4W = 0;
  goto tag00709e;
case17:
  TAG004a1a(roomData.word4[2], 1);
  DrawRoomObjects(roomData.rn2, facing, mapX, mapY, 0, 536);
  TAG00437e(d.Pointer2126, (RectPos *)d.Byte3098);
  MemMove(d.Pointer2126, d.Pointer1848, 704);
  TAG004450(d.Pointer1848, d.Byte3106);
  //A0 = (pnt)d.misc1052eight[0] + roomData.word4[1]*4;
  //D0W = (wordGear(A0+2)>>6)&1;
  //if (D0W != 0) DrawDoorSwitch(1, 1);
  pDB0 = GetRecordAddressDB0(RN(0,0,roomData.word4[1]));
  if (pDB0->doorSwitch()) DrawDoorSwitch(1, 1);
  DrawDoor(roomData.word4[1],roomData.word4[0],d.Word1910,984,0,d.Byte3354);
  D4W = 841;
  goto tag00709e;
case02:
  if (roomData.word4[0] == 0) TAG0044b0(50, (RectPos *)d.Byte2802);
case05:
  if ((ui16)d.Word1836 < 15) goto case01;
  if (d.Word23228 != 0) goto case01;
  if (d.Long11732 >= 65532) goto tag006fee;
  if (d.Time > 65530) goto tag007002; // 10000 seconds??
tag006fee:
  if ((ui32)(d.Long11732 + 8192) <= (ui32)d.Time) goto case01;
tag007002:
  //D0W = STRandom0_3();
  //if      (D0W == 0) fn = DrawCellF1R1;
  //else if (D0W == 1) fn = DrawCellF1;
  //else if (D0W == 2) fn = DrawCellF1L1;
  //else if (D0W == 3) fn = DrawCellF0R1;
  HopefullyNotNeeded();
  //TAG00907e(fn,
  //          GetGraphicAddress,
  //          538,
  //          d.ClusterCache,
  //          &d.Word23228,
  //          d.Pointer2526,3);
  d.CacheInvalid |= 1;
  d.Word11720 |= 1;
  d.Word1836 -= 10;
  d.Word1840 = 0;
case01:
  D4W = 13345;
  TAG004a1a(roomData.word4[2], 1);
tag00709e:
  DrawRoomObjects(roomData.rn2, facing, mapX, mapY, 0, D4W);
finish:
  if (roomData.roomType != roomTELEPORTER) goto exit;
  if (roomData.word4[0] != 0)
       TAG004f82(d.Byte4010,(RectPos *)d.Byte3074);
exit:
  return;
}

//   TAG0070d8
void DrawCellF2L1(i32 facing,i32 mapX,i32 mapY)
{
  dReg D0, D4;
  SUMMARIZEROOMDATA roomData;
  //D7W = P1;
  //D6W = P2;
  //D5W = P3;
  SummarizeRoomInfo(&roomData, facing, mapX, mapY);
  if (roomData.roomType == roomType19)     goto case19;
  if (roomData.roomType == roomSTONE)      goto case00;
  if (roomData.roomType == roomType18)     goto case18;
  if (roomData.roomType == roomDOOREDGE)   goto case16;
  if (roomData.roomType == roomDOORFACING) goto case17;
  if (roomData.roomType == roomPIT)        goto case02;
  if (roomData.roomType == roomTELEPORTER) goto case05;
  if (roomData.roomType == roomOPEN)       goto case01;
  goto finish;
case19:
  if (roomData.word4[0] != 0) TAG0044b0(d.Word1876, (RectPos *)d.Byte2578);
  else TAG0044b0(d.Word1890, (RectPos *)d.Byte2666);
  goto case01;
case00:
  TAG00437e(d.Pointer2098, (RectPos *)d.Byte3042);
  TAG0045ae(roomData.word4[0], 5); //wall decorations?
  D0W = TAG0045ae(roomData.word4[1], 7);//wall decorations
  if (D0W == 0) goto exit;
  D4W = 0;
  goto tag00723e;
case18:
  TAG0044b0(d.Word1900, (RectPos *)d.Byte2730);
case16:
  D4W = 0;
  goto tag007230;
case17:
  TAG004a1a(roomData.word4[2], 3);
  DrawRoomObjects(roomData.rn2,facing, mapX, mapY, 4, 536);
  TAG00437e(d.Pointer2114, (RectPos *)d.Byte3154);
  DrawDoor(roomData.word4[1], roomData.word4[0], d.Word1914, 1952, 1, d.Byte3514);
  D4L = 841;
  goto tag00723e;
case02:
  TAG0044b0(roomData.word4[0]==0?51:57,(RectPos *)d.Byte2818);
case01:
case05:
  D4W = 13345;
tag007230:
  TAG004a1a(roomData.word4[2], 3);
tag00723e:
  CheckCeilingPit(63,(RectPos *)d.Byte2890,mapX,mapY,0);
  DrawRoomObjects(roomData.rn2,facing,mapX,mapY,4,D4W);
finish:
  if (roomData.roomType != roomTELEPORTER) goto exit;
  if (roomData.word4[0] == 0) goto exit;
  TAG004f82(d.Byte3978, (RectPos *)d.Byte3042);
exit:
  return;
}

//   TAG007290
void DrawCellF2R1(i32 facing,i32 mapX,i32 mapY)
{
  dReg D0, D4;
  SUMMARIZEROOMDATA roomData;
  //D7W = P1;
  //D6W = P2;
  //D5W = P3;
  SummarizeRoomInfo(&roomData, facing, mapX, mapY);
  if (roomData.roomType == roomType19)     goto case19;
  if (roomData.roomType == roomSTONE)      goto case00;
  if (roomData.roomType == roomType18)     goto case18;
  if (roomData.roomType == roomDOOREDGE)   goto case16;
  if (roomData.roomType == roomDOORFACING) goto case17;
  if (roomData.roomType == roomPIT)        goto case02;
  if (roomData.roomType == roomOPEN)       goto case01;
  if (roomData.roomType == roomTELEPORTER) goto case05;
  goto finish;
case19:
  if (roomData.word4[0]!=0) TAG0044fe(d.Word1876,(RectPos *)d.Byte2594);
  else TAG0044fe(d.Word1890, (RectPos *)d.Byte2682);
  goto case01;
case00:
  TAG00437e(d.Pointer2098, (RectPos *)d.Byte3034);
  TAG0045ae(roomData.word4[2],6);
  D0W = TAG0045ae(roomData.word4[1], 9);
  if (D0W != 0)
  {
    D4W = 0;
    goto tag0074b4;
  };
  if ((ui16)d.Word1836 > 6) goto exit;
  if (d.Word1840 ==0) goto exit;
  if (d.Word23228 != 0) goto exit;
  if ((d.Word11722 & 1) != 0 ) goto tag007354;
  if ((d.CacheInvalid & 1) != 0) goto tag007384;
tag007354:
  if ((d.Word11724 & 1) == 0) goto tag00737a;
  if ((d.Word11722 & 1) == 0) goto tag007372;
  d.Word1842++;
  d.Word11722 &= 0xfffe;
tag007372:
  d.Word11724 &= 0xfffe;
  goto tag00737c;
  goto tag00737c;
tag00737a:
  goto exit;
tag00737c:
  d.Word1836 += 10;
  goto exit;
tag007384:
  d.Word1844 = 555;
  HopefullyNotNeeded();
  //TAG00907e(RandomBool() ? DrawCellF1 : DrawCellF0L1,
  //          GetGraphicAddress,
  //          21,
  //          d.ClusterCache,
  //          (i16 *)&d.Pointer2066, // don't know what to do here
  //          d.Pointer2526,
  //          3);
  d.Word1836 += 5;
  goto exit;
case18:
  TAG0044fe(d.Word1900, (RectPos *)d.Byte2738);
case16:
  D4W = 1073;
  goto tag00748e;
case17:
  TAG004a1a(roomData.word4[2], 5);
  DrawRoomObjects(roomData.rn2,facing, mapX, mapY, 5, 296);
  TAG00437e(d.Pointer2114, (RectPos *)d.Byte3170);
  DrawDoor(roomData.word4[1],roomData.word4[0],d.Word1914,1952,1,d.Byte3674);
  D4W = 1081;
  goto tag0074b4;
case02:
  TAG0044fe(roomData.word4[0]==0?51:57,(RectPos *)d.Byte2834);
case01:
case05:
  D4W = 17170;
tag00748e:
  TAG004a1a(roomData.word4[2],5);
  CheckCeilingPit(63,(RectPos *)d.Byte2906, mapX, mapY, 1);
tag0074b4:
  DrawRoomObjects(roomData.rn2,facing,mapX,mapY,5,D4W);
finish:
  if (roomData.roomType != roomTELEPORTER) goto exit;
  if (roomData.word4[0] == 0) goto exit;
  TAG004f82(d.Byte3970, (RectPos *)d.Byte3034);
exit:
  return;
}

//*********************************************************
//
//*********************************************************
//   TAG0074f0
void DrawCellF2(i32 facing,i32 mapX,i32 mapY)
{
  dReg D0, D4;
  DB0 *pDB0;
  //i16 *pwA0;
  SUMMARIZEROOMDATA roomData;
  //D7W = P1; D6W = P2; D5W = P3;
  SummarizeRoomInfo(&roomData,facing,mapX,mapY);
  if (roomData.roomType == roomType19)     goto case19;
  if (roomData.roomType == roomSTONE)      goto case00;
  if (roomData.roomType == roomDOORFACING) goto case17;
  if (roomData.roomType == roomPIT)        goto case02;
  if (roomData.roomType == roomTELEPORTER) goto case05;
  if (roomData.roomType == roomOPEN)       goto case01;
  goto finish;
case19:
  if (roomData.word4[0] != 0) TAG0044b0(d.Word1878, (RectPos *)d.Byte2586);
  else TAG0044b0(d.Word1892, (RectPos *)d.Byte2674);
  goto case01;
case00:
  TAG0043c4(d.Pointer2098, (RectPos *)d.Byte3050);
  D0W = TAG0045ae(roomData.word4[1], 8);
  if (D0W != 0)
  {
    D4W = 0;
    goto tag00768e;
  };
  goto exit;
case17:
  TAG004a1a(roomData.word4[2], 4);
  DrawRoomObjects(roomData.rn2,facing,mapX,mapY,3,536);
  TAG00437e(d.Pointer2114, (RectPos *)d.Byte3162);
  TAG00437e(d.Pointer2130, (RectPos *)d.Byte3114); // Door sides appear
  MemMove(d.Pointer2130, d.Pointer1848, 1560);
  TAG004450(d.Pointer1848, d.Byte3122); // Other side of door.
  pDB0 = GetRecordAddressDB0(RN(0,0,roomData.word4[1]));
  if (pDB0->doorSwitch()) DrawDoorSwitch(1, 2);
  DrawDoor(roomData.word4[1],roomData.word4[0],d.Word1914,1952,1,d.Byte3594);
  //  A door has appeared.
  D4W = 841;
  goto tag00768e;
case02:
  TAG0044b0(roomData.word4[0]==0?52:58,(RectPos *)d.Byte2826);
case01:
case05:
  D4W = 13345;
  TAG004a1a(roomData.word4[2], 4);
  CheckCeilingPit(64,(RectPos *)d.Byte2898,mapX,mapY,0);
tag00768e:
  DrawRoomObjects(roomData.rn2,facing,mapX,mapY,3,D4W);
finish:
  if (roomData.roomType != roomTELEPORTER) goto exit;
  if (roomData.word4[0] == 0) goto exit;
  TAG004f82(d.Byte3986, (RectPos *)d.Byte3050); /*, roomData);*/
exit:
  return;
}

//*********************************************************
//
//*********************************************************
//   TAG0076d0
void DrawCellF1L1(i32 facing,i32 mapX,i32 mapY)
{
  dReg D4;
  SUMMARIZEROOMDATA roomData;
  //D7W = P1; D6W = P2; D5W = P3;
  SummarizeRoomInfo(&roomData,facing, mapX, mapY);
  if (roomData.roomType == roomType19)     goto case19;
  if (roomData.roomType == roomSTONE)      goto case00;
  if (roomData.roomType == roomType18)     goto case18;
  if (roomData.roomType == roomDOOREDGE)   goto case16;
  if (roomData.roomType == roomDOORFACING) goto case17;
  if (roomData.roomType == roomPIT)        goto case02;
  if (roomData.roomType == roomTELEPORTER) goto case05;
  if (roomData.roomType == roomOPEN)       goto case01;
  goto finish;
case19:
  if (roomData.word4[0] != 0) TAG0044b0(d.Word1880, (RectPos *)d.Byte2602);
  else TAG0044b0(d.Word1894, (RectPos *)d.Byte2690);
  goto case01;
case00:
  TAG00437e(d.Pointer2102, (RectPos *)d.Byte3018);
  TAG0045ae(roomData.word4[0], 10);
  goto exit;
case18:
  if (roomData.word4[0] != 0) TAG0044b0(d.Word1902, (RectPos *)d.Byte2746);
  else TAG0044b0(d.Word1904,(RectPos *)d.Byte2762);
case16:
  D4W = 50;
  goto tag007826;
case17:
  TAG004a1a(roomData.word4[2],6);
  DrawRoomObjects(roomData.rn2,facing,mapX,mapY,7,40);
  TAG00437e(d.Pointer2118, (RectPos *)d.Byte3178);
  DrawDoor(roomData.word4[1],roomData.word4[0],d.Word1918,4224,2,d.Byte3754);
  D4W = 57;
  goto tag00784a;
case02:
TAG0044b0(roomData.word4[0]!=0?59:53,(RectPos *)d.Byte2842);
case01:
case05:
  D4W = 50;
tag007826:
  TAG004a1a(roomData.word4[2],6);
  CheckCeilingPit(65,(RectPos *)d.Byte2914,mapX,mapY,0);
tag00784a:
  DrawRoomObjects(roomData.rn2,facing,mapX,mapY,7,D4W);
finish:
  if (roomData.roomType != roomTELEPORTER) goto exit;
  if (roomData.word4[0] == 0) goto exit;
  TAG004f82(d.Byte3954,(RectPos *)d.Byte3018); /*,roomData);*/
exit:
  return;
}

//   TAG007d00
void DrawCellF0L1(i32 facing,i32 mapX,i32 mapY)
{
  //dReg D5,D6,D7;
  SUMMARIZEROOMDATA roomData;
  //D7W=facing; D6W=mapX; D5W=mapY;
#ifdef _VERIFYPPQ
      verifyppq();
#endif
  SummarizeRoomInfo(&roomData,facing,mapX,mapY);
  if (roomData.roomType == roomType18)     goto case18;
  if (roomData.roomType == roomPIT)        goto case02;
  if (roomData.roomType == roomOPEN)       goto case01;
  if (roomData.roomType == roomDOOREDGE)   goto case16;
  if (roomData.roomType == roomTELEPORTER) goto case05;
  if (roomData.roomType == roomSTONE)      goto case00;
  goto finish;
case18:
  TAG0044b0(d.Word1906, (RectPos *)d.Byte2778);
  goto exit;
case02:
  TAG0044b0(roomData.word4[0] != 0? 61:55,(RectPos *)d.Byte2866);
case01:
case05:
case16:
  DrawRoomObjects(roomData.rn2,facing,mapX,mapY,10,2);
  goto finish;
case00:
  TAG00437e(d.Pointer2106, (RectPos *)d.uByte2994);
  goto exit;
finish:
  CheckCeilingPit(67,(RectPos *)d.Byte2938,mapX,mapY,0);
  if (roomData.roomType != roomTELEPORTER) goto exit;
  if (roomData.word4[0] == 0) goto exit;
  TAG004f82(d.Byte3930, (RectPos *)d.uByte2994);
exit:
  return;
}

//   TAG007de8
void DrawCellF0R1(i32 facing,i32 mapX,i32 mapY)
{
    //dReg D5, D6, D7;
    SUMMARIZEROOMDATA roomData;
//007df0 3e2e 0008                MOVE.W   8(A6),D7
//007df4 3c2e 000a                MOVE.W   10(A6),D6
//007df8 3a2e 000c                MOVE.W   12(A6),D5
  //D7W = P1; D6W = P2; D5W = P3;
//007dfc 3f05                     MOVE.W   D5,-(A7)
//007dfe 3f06                     MOVE.W   D6,-(A7)
//007e00 3f07                     MOVE.W   D7,-(A7)
//007e02 486e fff6                PEA      -10(A6)
//007e06 4ead 02b8                JSR      696(A5)    (=0x00a59a)
//007e0a defc 000a                ADD.W    #10,A7
  SummarizeRoomInfo(&roomData,facing,mapX, mapY);
//007e0e 302e fff6                MOVE.W   -10(A6),D0
//007e12 b07c 0012                CMP.W    #18,D0
//007e16 6702                     BEQ      $+4 (=0x007e1a)
//007e18 6012                     BRA      $+20 (=0x007e2c)
  if (roomData.roomType == roomType18) goto case18;
//007e2c b07c 0002                CMP.W    #2,D0
//007e30 6702                     BEQ      $+4 (=0x007e34)
//007e32 601e                     BRA      $+32 (=0x007e52)
  if (roomData.roomType == roomPIT) goto case02;
//007e52 b07c 0001                CMP.W    #1,D0
//007e56 670e                     BEQ      $+16 (=0x007e66)
//007e58 b07c 0010                CMP.W    #16,D0
//007e5c 6708                     BEQ      $+10 (=0x007e66)
//007e5e b07c 0005                CMP.W    #5,D0
//007e62 6702                     BEQ      $+4 (=0x007e66)
//007e64 6032                     BRA      $+52 (=0x007e98)
  if (roomData.roomType ==  roomOPEN) goto case01;
  if (roomData.roomType == roomDOOREDGE) goto case16;
  if (roomData.roomType == roomTELEPORTER) goto case05;
//007e98 4a40                     TST.W    D0
//007e9a 6702                     BEQ      $+4 (=0x007e9e)
//007e9c 6010                     BRA      $+18 (=0x007eae)
  if (roomData.roomType == roomSTONE) goto case00;
  goto finish;
case18:
//007e1a 486c f51e                PEA      -2786(A4)
//007e1e 3f2c f88e                MOVE.W   -1906(A4),-(A7)
//007e22 4eba c6da                JSR      $-14628 (=0x0044fe)
//007e26 5c8f                     ADDQ.L   #6,A7
//007e28 6000 00a0                BRA      $+162 (=0x007eca)
  TAG0044fe(d.Word1906,(RectPos *)d.Byte2786);
goto exit;

case02:
//007e34 486c f4be                PEA      -2882(A4)
//007e38 302e fffa                MOVE.W   -6(A6),D0
//007e3c 6706                     BEQ      $+8 (=0x007e44)
//007e3e 303c 003d                MOVE.W   #61,D0
//007e42 6004                     BRA      $+6 (=0x007e48)
//007e44 303c 0037                MOVE.W   #55,D0
//007e48 3f00                     MOVE.W   D0,-(A7)
//007e4a 4eba c6b2                JSR      $-14668 (=0x0044fe)
//007e4e 5c8f                     ADDQ.L   #6,A7
//007e50 6014                     BRA      $+22 (=0x007e66)
  TAG0044fe(roomData.word4[0]!=0?61:55, (RectPos *)d.Byte2882);

case01:
case05:
case16:
//007e66 3f3c 0001                MOVE.W   #1,-(A7)
//007e6a 3f05                     MOVE.W   D5,-(A7)
//007e6c 3f06                     MOVE.W   D6,-(A7)
//007e6e 486c f476                PEA      -2954(A4)
//007e72 3f3c 0043                MOVE.W   #67,-(A7)
//007e76 4eba d08c                JSR      $-12146 (=0x004f04)
//007e7a defc 000c                ADD.W    #12,A7
  CheckCeilingPit(67, (RectPos *)d.Byte2954, mapX, mapY, 1);
//007e7e 2f3c 000b 0001           MOVE.L   #720897,-(A7)
//007e84 3f05                     MOVE.W   D5,-(A7)
//007e86 3f06                     MOVE.W   D6,-(A7)
//007e88 3f07                     MOVE.W   D7,-(A7)
//007e8a 3f2e fff8                MOVE.W   -8(A6),-(A7)
//007e8e 4eba d314                JSR      $-11498 (=0x0051a4)
//007e92 defc 000c                ADD.W    #12,A7
  DrawRoomObjects(roomData.rn2,facing, mapX, mapY,11,1);
//007e96 6016                     BRA      $+24 (=0x007eae)
  goto finish;

case00:
//007e9e 486c f456                PEA      -2986(A4)
//007ea2 2f2c f7c2                MOVE.L   -2110(A4),-(A7)
//007ea6 4eba c4d6                JSR      $-15144 (=0x00437e)
//007eaa 508f                     ADDQ.L   #0,A7
//007eac 601c                     BRA      $+30 (=0x007eca)
  TAG00437e(d.Pointer2110, (RectPos *)d.Byte2986);
  goto exit;
finish:
//007eae 0c6e 0005 fff6           CMP.W    #5,-10(A6)
//007eb4 6614                     BNE      $+22 (=0x007eca)
  if (roomData.roomType != roomTELEPORTER) goto exit;
  if (roomData.word4[0] == 0) goto exit;
//007eb6 302e fffa                MOVE.W   -6(A6),D0
//007eba 670e                     BEQ      $+16 (=0x007eca)
//007ebc 486c f456                PEA      -2986(A4)
//007ec0 486c f0ae                PEA      -3922(A4)
//007ec4 4eba d0bc                JSR      $-12098 (=0x004f82)
//007ec8 508f                     ADDQ.L   #0,A7
  TAG004f82(d.Byte3922, (RectPos *)d.Byte2986);
exit:
//007eca 4cdf 00e0                MOVEM.L  (A7)+,D567
//007ece 4e5e                     UNLK     A6
//007ed0 4e75                     RTS
  return;
}

//   TAG007ed2
void DrawLocalCell(i32 facing,i32 mapX,i32 mapY,bool skipDrawing)
{
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//007ed2 4e56 fff6                LINK     A6,#-10
//007ed6 48e7 0700                MOVEM.L  D567,-(A7)
  //dReg D5, D6, D7;
  SUMMARIZEROOMDATA roomData;
//007eda 3e2e 0008                MOVE.W   8(A6),D7
//007ede 3c2e 000a                MOVE.W   10(A6),D6
//007ee2 3a2e 000c                MOVE.W   12(A6),D5
  //D7W = P1; D6W = P2; D5W = P3;
//007ee6 3f05                     MOVE.W   D5,-(A7)
//007ee8 3f06                     MOVE.W   D6,-(A7)
//007eea 3f07                     MOVE.W   D7,-(A7)
//007eec 486e fff6                PEA      -10(A6)
//007ef0 4ead 02b8                JSR      696(A5)    (=0x00a59a)
//007ef4 defc 000a                ADD.W    #10,A7
  SummarizeRoomInfo(&roomData, facing, mapX, mapY);
//007ef8 302e fff6                MOVE.W   -10(A6),D0
//007efc b07c 0010                CMP.W    #16,D0
//007f00 6702                     BEQ      $+4 (=0x007f04)
//007f02 6076                     BRA      $+120 (=0x007f7a)
  if (roomData.roomType == roomDOOREDGE) goto case16;
//007f7a b07c 0013                CMP.W    #19,D0
//007f7e 6702                     BEQ      $+4 (=0x007f82)
//007f80 6042                     BRA      $+68 (=0x007fc4)
  if (roomData.roomType == roomType19) goto case19;
//007fc4 b07c 0002                CMP.W    #2,D0
//007fc8 6702                     BEQ      $+4 (=0x007fcc)
//007fca 601c                     BRA      $+30 (=0x007fe8)
  if (roomData.roomType == roomPIT) goto case02;
  goto finish;
case16:
//007f04 102c cc20                MOVE.B   -13280(A4),D0
//007f08 6760                     BEQ      $+98 (=0x007f6a)
  if (d.SeeThruWalls != 0)
  {
//007f0a 3f3c 07b0                MOVE.W   #1968,-(A7)
//007f0e 2f2c f8c8                MOVE.L   -1848(A4),-(A7)
//007f12 2f2c f7a6                MOVE.L   -2138(A4),-(A7)
//007f16 4ead 0006                JSR      6(A5)    (=0x0009dc)
//007f1a defc 000a                ADD.W    #10,A7
    MemMove(d.Pointer2138, d.Pointer1848, 1968);
    if (!skipDrawing)
//007f1e 2f3c 0010 0009           MOVE.L   #1048585,-(A7)
//007f24 3f3c 0030                MOVE.W   #48,-(A7)
//007f28 4267                     CLR.W    -(A7)
//007f2a 102c f3b6                MOVE.B   -3146(A4),D0
//007f2e c07c 00ff                AND.W    #255,D0
//007f32 162c f61a                MOVE.B   -2534(A4),D3
//007f36 c67c 00ff                AND.W    #255,D3
//007f3a 9043                     SUB.W    D3,D0
//007f3c 3f00                     MOVE.W   D0,-(A7)
//007f3e 486c f612                PEA      -2542(A4)
//007f42 2f2c f8c8                MOVE.L   -1848(A4),-(A7)
//007f46 3f3c 0029                MOVE.W   #41,-(A7)
//007f4a 4ead 061e                JSR      1566(A5)    (=0x022a92)
//007f4e 548f                     ADDQ.L   #2,A7
//007f50 2f00                     MOVE.L   D0,-(A7)
//007f52 4eba 095e                JSR      $+2400 (=0x0088b2)
//007f56 defc 0016                ADD.W    #22,A7
    TAG0088b2(GetGraphicAddress(41),
              d.Pointer1848,
              (RectPos *)d.uByte2542,
              ub(d.Byte3146[0])-d.uByte2534[0], // This isn't right
              0,
              48,
              16,
              9);
//007f5a 486c f3b6                PEA      -3146(A4)
//007f5e 2f2c f8c8                MOVE.L   -1848(A4),-(A7)
//007f62 4eba c41a                JSR      $-15332 (=0x00437e)
//007f66 508f                     ADDQ.L   #0,A7
    TAG00437e(d.Pointer1848, (RectPos *)d.Byte3146);
//007f68 600e                     BRA      $+16 (=0x007f78)
  }
  else
  {
//007f6a 486c f3b6                PEA      -3146(A4)
//007f6e 2f2c f7a6                MOVE.L   -2138(A4),-(A7)
//007f72 4eba c40a                JSR      $-15348 (=0x00437e)
//007f76 508f                     ADDQ.L   #0,A7
    TAG00437e(d.Pointer2138, (RectPos *)d.Byte3146);
  };
//007f78 606e                     BRA      $+112 (=0x007fe8)
  goto finish;

case19:
//007f82 302e fffa                MOVE.W   -6(A6),D0
//007f86 671e                     BEQ      $+32 (=0x007fa6)
  if (roomData.word4[0] != 0)
  {
//007f88 486c f5be                PEA      -2626(A4)
//007f8c 3f2c f8a4                MOVE.W   -1884(A4),-(A7)
//007f90 4eba c51e                JSR      $-15072 (=0x0044b0)
//007f94 5c8f                     ADDQ.L   #6,A7
    TAG0044b0(d.Word1884, (RectPos *)d.Byte2626);
//007f96 486c f5b6                PEA      -2634(A4)
//007f9a 3f2c f8a4                MOVE.W   -1884(A4),-(A7)
//007f9e 4eba c55e                JSR      $-15008 (=0x0044fe)
//007fa2 5c8f                     ADDQ.L   #6,A7
    TAG0044fe(d.Word1884, (RectPos *)d.Byte2634);
//007fa4 601c                     BRA      $+30 (=0x007fc2)
  }
  else
  {
//007fa6 486c f566                PEA      -2714(A4)
//007faa 3f2c f896                MOVE.W   -1898(A4),-(A7)
//007fae 4eba c500                JSR      $-15102 (=0x0044b0)
//007fb2 5c8f                     ADDQ.L   #6,A7
    TAG0044b0(d.Word1898, (RectPos *)d.Byte2714);
//007fb4 486c f55e                PEA      -2722(A4)
//007fb8 3f2c f896                MOVE.W   -1898(A4),-(A7)
//007fbc 4eba c540                JSR      $-15038 (=0x0044fe)
//007fc0 5c8f                     ADDQ.L   #6,A7
    TAG0044fe(d.Word1898, (RectPos *)d.Byte2722);
  };
//007fc2 6024                     BRA      $+38 (=0x007fe8)
  goto finish;

case02:
//007fcc 486c f4c6                PEA      -2874(A4)
//007fd0 302e fffa                MOVE.W   -6(A6),D0
//007fd4 6706                     BEQ      $+8 (=0x007fdc)
//007fd6 303c 003e                MOVE.W   #62,D0
//007fda 6004                     BRA      $+6 (=0x007fe0)
//007fdc 303c 0038                MOVE.W   #56,D0
//007fe0 3f00                     MOVE.W   D0,-(A7)
//007fe2 4eba c4cc                JSR      $-15154 (=0x0044b0)
//007fe6 5c8f                     ADDQ.L   #6,A7
  TAG0044b0(roomData.word4[0]!=0?62:56,(RectPos *)d.Byte2874);
finish:
  if (!skipDrawing)
//007fe8 4267                     CLR.W    -(A7)
//007fea 3f05                     MOVE.W   D5,-(A7)
//007fec 3f06                     MOVE.W   D6,-(A7)
//007fee 486c f47e                PEA      -2946(A4)
//007ff2 3f3c 0044                MOVE.W   #68,-(A7)
//007ff6 4eba cf0c                JSR      $-12530 (=0x004f04)
//007ffa defc 000c                ADD.W    #12,A7
  CheckCeilingPit(68,(RectPos *)d.Byte2946,mapX,mapY,0);
  //if (!skipDrawing)
//007ffe 2f3c 0009 0021           MOVE.L   #589857,-(A7)
//008004 3f05                     MOVE.W   D5,-(A7)
//008006 3f06                     MOVE.W   D6,-(A7)
//008008 3f07                     MOVE.W   D7,-(A7)
//00800a 3f2e fff8                MOVE.W   -8(A6),-(A7)
//00800e 4eba d194                JSR      $-11882 (=0x0051a4)
//008012 defc 000c                ADD.W    #12,A7
  DrawRoomObjects(roomData.rn2,facing,mapX,mapY,9,0x21);
//008016 0c6e 0005 fff6           CMP.W    #5,-10(A6)
//00801c 6614                     BNE      $+22 (=0x008032)
  if (roomData.roomType != roomTELEPORTER) goto exit;
  if (roomData.word4[0] == 0) goto exit;
//00801e 302e fffa                MOVE.W   -6(A6),D0
//008022 670e                     BEQ      $+16 (=0x008032)
//008024 486c f446                PEA      -3002(A4)
//008028 486c f09e                PEA      -3938(A4)
//00802c 4eba cf54                JSR      $-12458 (=0x004f82)
//008030 508f                     ADDQ.L   #0,A7
  if (!skipDrawing)
  TAG004f82(d.Byte3938, (RectPos *)d.Byte3002);
//008032 4cdf 00e0                MOVEM.L  (A7)+,D567
//008036 4e5e                     UNLK     A6
//008038 4e75                     RTS
exit:
  return;
}

extern i32 DrawViewportCount;

//   TAG00803a
void DrawViewport(i32 facing,i32 x,i32 y)
{
  unsigned int saveRandom;
  unsigned int saveNumRan;
  saveRandom = d.RandomNumber; // Don't upset the game
  saveNumRan = numRandomCalls;
  bool skipDrawing;
  skipDrawing = (VBLMultiplier != 1) && ((d.Time & 0xf) != 0);
#ifdef _VERIFYPPQ
  verifyppq();
#endif
  DrawViewportCount++;
  i32 cellY;
  i32 cellX;
  dReg D0, D4;
  D4W=0;
  if (d.Word11684 != 0)
  {
    FloorAndCeilingOnly();
  };
  d.UseByteCoordinates = 1;
  // Clear all the object buttons.
  memset(d.ViewportObjectButtons[0], 0, 24);
  fillWithByte((pnt)d.ViewportObjectButtons[0],6,ui8(0xff), 4);
  d.Pointer1848=allocateMemory(8880, 0);
  d.UseMirrorImages = (I16)((x + y + facing)&1);
  if (d.UseMirrorImages != 0)
  {
    if (!skipDrawing) Mirror(d.Pointer2082, 0x0070, 0x0046);
    D4W = d.Word23354;
    if (D4W != 0)
    {
      d.Pointer2094 = d.Pointer2214;
      d.Pointer2098 = d.Pointer2218;
      d.Pointer2102 = d.Pointer2222;
      d.Pointer2106 = d.Pointer2226;
      d.Pointer2110 = d.Pointer2230;
    };
  }
  else
  {
    if (!skipDrawing) Mirror(d.pViewportBMP, 0x0070, 0x001d);
  };
  D0W = TAG0097d6(facing, 0x0003, -2, x, y);
  if (D0W==0)
  {
    TAG00437e(d.Pointer2090, (RectPos *)d.Byte2970);
  };
  D0W=TAG0097d6(facing, 0x0003, 0x0002, x, y);
  if (D0W==0)
  {
    TAG00437e(d.Pointer2086, (RectPos *)d.Byte2978);
  };
  if (!skipDrawing)
  {
    cellX=x;
    cellY=y;
    UpdateXY(facing, 4, -1, &cellX, &cellY);
    DrawRoomObjects(FindFirstDrawableObject(cellX,cellY),facing,cellX,cellY,-2,1);
  };
  if (!skipDrawing)
  {
    cellX = x;
    cellY = y;
    UpdateXY(facing, 4, 1, &cellX, &cellY);
    DrawRoomObjects(FindFirstDrawableObject(cellX, cellY), facing,cellX, cellY,-1, 1);
  };
  if (!skipDrawing)
  {
    cellX = x;
    cellY = y;
    UpdateXY(facing,4,0,&cellX,&cellY);
    DrawRoomObjects(FindFirstDrawableObject(cellX,cellY), facing, cellX, cellY, -3, 1);
  };
  if (!skipDrawing)
  {
    cellX = x;
    cellY = y;
    UpdateXY(facing,3,-1,&cellX,&cellY);
    DrawCellF3L1(facing,cellX,cellY);
  };
  if (!skipDrawing)
  {
    cellY= y;
    cellX=x;
    UpdateXY(facing,3,1,&cellX,&cellY);
    DrawCellF3R1(facing,cellX,cellY);
  };
  if (!skipDrawing)
  {
    cellX=x;
    cellY=y;
    UpdateXY(facing,3,0,&cellX,&cellY);
    DrawCellF3(facing,cellX,cellY);
  };
  if (!skipDrawing)
  {
    cellX=x;
    cellY=y;
    UpdateXY(facing,2,-1,&cellX,&cellY);
    DrawCellF2L1(facing,cellX,cellY);
  };
  if (!skipDrawing)
  {
    cellX=x;
    cellY=y;
    UpdateXY(facing,2,1,&cellX,&cellY);
    DrawCellF2R1(facing,cellX,cellY);
  };
  if (!skipDrawing)
  {
    cellX=x;
    cellY=y;
    UpdateXY(facing,2,0,&cellX,&cellY);
    DrawCellF2(facing,cellX,cellY);
  };
  if (!skipDrawing)
  {
    cellX=x;
    cellY=y;
    UpdateXY(facing,1,-1,&cellX,&cellY);
    DrawCellF1L1(facing,cellX,cellY);
  };
  if (!skipDrawing)
  {
    cellX=x;
    cellY=y;
    UpdateXY(facing,1,1,&cellX,&cellY);
    DrawCellF1R1(facing,cellX,cellY);
  };
  cellX = x;
  cellY = y;
  UpdateXY(facing,1,0,&cellX,&cellY);
  DrawCellF1(facing,cellX,cellY,skipDrawing);
  if (!skipDrawing)
  {
    cellX = x;
    cellY = y;
    UpdateXY(facing,0,-1,&cellX,&cellY);
    DrawCellF0L1(facing,cellX,cellY);
  };
  if (!skipDrawing)
  {
    cellX = x;
    cellY = y;
    UpdateXY(facing,0,1,&cellX,&cellY);
    DrawCellF0R1(facing,cellX,cellY);
  };
  DrawLocalCell(facing,x,y,skipDrawing);
  if ((D0W=D4W)!=0)
  {
    d.Pointer2094 = d.Pointer2234;
    d.Pointer2098 = d.Pointer2238;
    d.Pointer2102 = d.Pointer2242;
    d.Pointer2106 = d.Pointer2246;
    d.Pointer2110 = d.Pointer2250;
  };
  // What was this for??? if (((D0W=d.Word1840)!=0) || true)
  {
  d.Word1840 = 1;
    FreeTempMemory(8880);
  };
  D0W = (I16)((d.partyLevel!=255)?1:0);
  if (!skipDrawing) MarkViewportUpdated(D0W);
  if (d.partyLevel!=255)
  {
    FloorAndCeilingOnly();
  };
  d.RandomNumber = saveRandom;
  numRandomCalls = saveNumRan;
}

//   TAG017c7a
void DrawSmallIcon(OBJECTTYPE icon,i16 x,i16 y)
{ // For example, the eye on the status viewport
  pnt BMP;
  RectPos rect;
  BMP = allocateMemory(128,0);
  rect.w.x1 = x;
  rect.w.x2 = sw(rect.w.x1 + 15);
  rect.w.y1 = y;
  rect.w.y2 = sw(rect.w.y1 + 15);
  GetIconGraphic(icon, BMP);
  BLT2Viewport(BMP, &rect, 8, -1);
  FreeTempMemory(128);
}

//   TAG018836
void DrawHorzBar(i32 x0, i32 y0, i32 width, i32 color)
{
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
  RectPos barPos;
  barPos.w.x1 = sw(x0);
  barPos.w.x2 = sw(barPos.w.x1 + width);
  barPos.w.y1 = sw(y0);
  barPos.w.y2 = sw(barPos.w.y1 + 6);
  d.UseByteCoordinates = 0;
  FillRectangle(d.pViewportBMP, &barPos, color, 112);
}

//   TAG018878
void DrawFoodWaterBar(i16 value,i16 y,i16 color)
{
  i32 barColor;
  barColor = color;
  if (value < 0) barColor = 11;   // Yellow
  if (value < -512) barColor = 8; //Red
  value += 1024;
  if (value >= 3072) value = 3071;
  value /= 32;
  DrawHorzBar(115, y+2, value, 0);//Black Background
  DrawHorzBar(113, y, value, barColor);//The bar itself
}

//*********************************************************
//
//*********************************************************
//   TAG0188e4
void DisplayFoodWater(void)
{
  CHARDESC *pcA3;
  pcA3 = &d.CH16482[d.SelectedCharacterOrdinal-1];
  TAG017da4();
  BLT2Viewport(GetGraphicAddress(20), &d.wRectPos926, 72, 8);//Food/water box
  BLT2Viewport(GetGraphicAddress(30), &d.wRectPos950, 24, 12);//"Food"
  BLT2Viewport(GetGraphicAddress(31), &d.wRectPos958, 24, 12);//"Water"
  if (pcA3->uByte42 != 0)
  {
    BLT2Viewport(GetGraphicAddress(32), &d.wRectPos966, 48, 12);
  };
  DrawFoodWaterBar(pcA3->food, 69, 5);
  DrawFoodWaterBar(pcA3->water, 92, 14);
}

//*********************************************************
//
//*********************************************************
RESTARTABLE _TAG0191e8(void)
{//(void)
  RESTARTMAP
    RESTART(1)
  END_RESTARTMAP
//;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;;
//0191e8 4e56 0000                LINK     A6,#0
//0191ec 48e7 0300                MOVEM.L  D67,-(A7)
//0191f0 397c 0001 a59c           MOVE.W   #1,-23140(A4)
//0191f6 397c 0001 d214           MOVE.W   #1,-11756(A4)
  d.Word23140 = 1;
  d.Word11756 = 1;
//0191fc 302c a5b0                MOVE.W   -23120(A4),D0
//019200 c07c 0002                AND.W    #2,D0
//019204 660e                     BNE      $+16 (=0x019214)
  if ((d.MouseSwitches & 2) == 0)
  {
//019206 426c a59c                CLR.W    -23140(A4)
    d.Word23140 = 0;
    d.Word11756 = 0;
    d.Word11758 = 0;
//01920a 426c d214                CLR.W    -11756(A4)
//01920e 426c d212                CLR.W    -11758(A4)
//019212 6048                     BRA      $+74 (=0x01925c)
    RETURN;
  };
//019214 4ead 052e                JSR      1326(A5)    (=0x01953a)
  TAG01953a();
//019218 4ead 0024                JSR      36(A5)    (=0x002fd2)
  STHideCursor();
//01921c 3f3c 0008                MOVE.W   #8,-(A7)
//019220 4ead 019e                JSR      414(A5)    (=0x000fb2)
  VBLDelay(_1_,8); // 8 vertical blanks
//019224 548f                     ADDQ.L   #2,A7
//019226 2f3c 000c 000d           MOVE.L   #786445,-(A7)
//01922c 3f3c 00cb                MOVE.W   #203,-(A7)
//019230 4eba ea48                JSR      $-5558 (=0x017c7a)
//019234 5c8f                     ADDQ.L   #6,A7
  DrawSmallIcon(obj_Special_e, 12, 13);//Eye looking towards skill scores
//019236 302c bf3e                MOVE.W   -16578(A4),D0
//01923a 6706                     BEQ      $+8 (=0x019242)
  if (d.EmptyHanded != 0)
  {
//01923c 4eba fdf8                JSR      $-518 (=0x019036)
    TAG019036();
//019240 6012                     BRA      $+20 (=0x019254)
  }
  else
  {
//019242 4ead 0150                JSR      336(A5)    (=0x00133e)
    ClearHeldObjectName();
//019246 3f3c 0001                MOVE.W   #1,-(A7)
//01924a 3f2c bf40                MOVE.W   -16576(A4),-(A7)
//01924e 4eba f19a                JSR      $-3684 (=0x0183ea)
//019252 588f                     ADDQ.L   #4,A7
    TAG0183ea(d.objectInHand, 1);
  };
//019254 4267                     CLR.W    -(A7)
//019256 4ead 01ec                JSR      492(A5)    (=0x0042da)
  MarkViewportUpdated(0);
//01925a 548f                     ADDQ.L   #2,A7
//01925c 4cdf 00c0                MOVEM.L  (A7)+,D67
//019260 4e5e                     UNLK     A6
//019262 4e75                     RTS
  RETURN;
}
