#include "stdafx.h"


#include "UI.h"
#include "Dispatch.h"

#include <stdio.h>

#include "Objects.h"

#include "CSB.h"

/*
typedef char i8;
typedef unsigned char ui8;
typedef _int16 i16;
typedef unsigned _int16 ui16;
typedef _int32 i32;  // signed 32-bit integer
typedef unsigned _int32 ui32;
typedef i8 * pnt;

  */

#pragma pack(1)  



typedef pnt aReg;

struct STRUCT148
{
  i8   *((*malloc)(i32 size));                 //0  //148
  void  (*free)(i8 *address);                  //4  //144
  void  (*seek)(i32 handle, i32 address);      //8  //140
  void  (*read)(i32 handle, i32 size, i8 *buf);//12 //138
  i32   handle;                                //16 //132      
  i32   i_20;                                  //20 //128
  i8   *p_24;                                  //24 //124
  i8   *pJumpTable;                            //28 //120
  i8   *p_32;                                  //32 //116
  i8   *p_36;                                  //36 //112
};


#define longGear(A) (*((i32 *)(A)))
//i32& longGear(pnt p);
pnt& pntGear(pnt p);
#define littleEndian(W)((ui16)((((ui16)(W))*0x10001)>>8))

#ifdef _MSVC_INTEL
i32 LE32(i32 lng);
#endif

struct ITEM20
{
  i32 Long0;
  i16 Word4;
  i32 Long6;
  i16 Word10;
  i16 Word12;
  i32 Long14;
  i16 Word18;
};


void  SetSupervisorMode(void);
void  ClearSupervisorMode(void);
void  CONOUT(i32) {NotImplemented(0xffff71);};
i8   *MALLOC(i32 size);
void  MFREE(i8 *address);
//i32   DIRECT_CONIN(void){NotImplemented(0xffff79); return 0;}; // Trap 1 #0x07
//i16   CONSTAT(void);     // Trap 1 #0x0b
i32   LSEEK(i32 offset, i32 file, i32 origin);
//i16   OPEN(char *name, i32 ref);
i32   READ(i32 file, i32 len, pnt buf);
i16   CLOSE(i16 handle);
i8   *MallocMemory(i32 size);//TAG0000b4
void  FreeMemory(i8 *address);//TAG0000ec
void  FileSeek(i32 handle, i32 offset);//TAG00010e
void  ReadFile(i32 handle, i32 size, i8 *buf);//  TAG000144
void  TAG00053a(i16, i32);
void  TAG0007a8(i32);
i32   TAG0007aa(void); // TRAP #1 save registers
void  SetCriticalErrorHandler(void);//TAG0007ce
i16   TAG0009ee(i32);
void  TAG000a60(i32);
i16   LoadProgram(STRUCT148 *s148);//TAG000ad2
i16   CheckSum(i8 *, i8 *);//TAG00127c
i16   TAG0012f6(i8 *, i32);
i16   TAG00132a(i8 *, i32);
i16   TAG00183c(i16);
void  TAG00187a(i32);
void  TAG001890(i32);
i16   TAG0018d6(ITEM20 *);
i16   TAG001928(ITEM20 *);
i32   TAG001a56(i16, i32, i16);
void  TAG001b6c(i32);
void  TAG001b82(i16 handle);
i16   TAG001cd4(i16, i32, i16);
void  TAG001e5e(void);


#define UTILFILL(a,b) i8 fill##a[a-b];

struct B
{
  i16  Word2132[76];
  UTILFILL(1980,1828)
  ui16 uWord1828;
  UTILFILL(1826,1752)
  ui16 uWord1752;
  ITEM20 Item20[73];//1750
  i8   Byte290[16]; // "0123456789ABCDEF"
  i8   Byte274[5];  // "A:\F"
  UTILFILL(269,160)
  ui16 uWord160;
  ui16 uWord158;
  UTILFILL(156,112)
  i32  Long112;
  i8   Byte108[13];
  UTILFILL(95,10)
  i32  Long10;
  i16  Word6;
  i32  IBank;  //4 // what we put in A5
};

char *MALLOC(i32 size)
{
  if (size == -1) return (char *)1000000;
  return (char *)malloc(size);
}

void MFREE(char *address)
{
  free (address);
}

B b;

void SETBLOCK(i8 * /*addr*/, i32 /*size*/, i32 /*zero*/)
{
}

//*********************************************************
//
//*********************************************************
//  TAG0000b4
i8 *MallocMemory(i32 size)
{
  i8 *p_4;
//0000b4 4e56 fffc                LINK     A6,#-4   
//0000b8 202e 0008                MOVE.L   8(A6),D0   
//0000bc 2f00                     MOVE.L   D0,-(A7)   
//0000be 3f3c 0048                MOVE.W   #72,-(A7)   
//0000c2 4eba 06e6                JSR      $+1768 (=0x0007aa)   
//0000c6 5c8f                     ADDQ.L   #6,A7   
//0000c8 2d40 fffc                MOVE.L   D0,-4(A6)   
  p_4 = MALLOC(size);
//0000cc 0c80 0000 0000           CMP.L    #0,D0   
//0000d2 6600 000c                BNE      $+14 (=0x0000e0)   
  if (p_4 == NULL)
  {
//0000d6 3f3c 0001                MOVE.W   #1,-(A7)   
//0000da 4eba 0984                JSR      $+2438 (=0x000a60)   
    TAG000a60(1);
//0000de 548f                     ADDQ.L   #2,A7   
  };
//0000e0 202e fffc                MOVE.L   -4(A6),D0   
//0000e4 6000 0002                BRA      $+4 (=0x0000e8)   
//0000e8 4e5e                     UNLK     A6   
//0000ea 4e75                     RTS         
  return p_4;
}

//*********************************************************
//
//*********************************************************
//  TAG0000ec
void FreeMemory(i8 *address)
{
//0000ec 4e56 0000                LINK     A6,#0   
//0000f0 0cae 0000 0000 0008      CMP.L    #0,8(A6)   
//0000f8 6700 0010                BEQ      $+18 (=0x00010a)   
  if (address != NULL)
  {
//0000fc 2f2e 0008                MOVE.L   8(A6),-(A7)   
//000100 3f3c 0049                MOVE.W   #73,-(A7)   
//000104 4eba 06a4                JSR      $+1702 (=0x0007aa)   
    MFREE(address);
//000108 5c8f                     ADDQ.L   #6,A7   
  };
//00010a 4e5e                     UNLK     A6   
//00010c 4e75                     RTS         
}

//*********************************************************
//
//*********************************************************
//   TAG00010e
void FileSeek(i32 handle, i32 offset)
{
  dReg D0;
//00010e 4e56 0000                LINK     A6,#0   
//000112 4267                     CLR.W    -(A7)   
//000114 202e 0008                MOVE.L   8(A6),D0   
//000118 3f00                     MOVE.W   D0,-(A7)   
//00011a 202e 000c                MOVE.L   12(A6),D0   
//00011e 2f00                     MOVE.L   D0,-(A7)   
//000120 3f3c 0042                MOVE.W   #66,-(A7)   
//000124 4eba 0684                JSR      $+1670 (=0x0007aa)   
//000128 defc 000a                ADD.W    #10,A7   
//00012c 222e 000c                MOVE.L   12(A6),D1   
  D0L = LSEEK(offset, handle, 0);
//000130 b081                     CMP.L    D1,D0   
//000132 6700 000c                BEQ      $+14 (=0x000140)   
  if (D0L != offset)
  {
//000136 3f3c 0003                MOVE.W   #3,-(A7)   
//00013a 4eba 0924                JSR      $+2342 (=0x000a60)   
//00013e 548f                     ADDQ.L   #2,A7   
    TAG000a60(3);
  };
//000140 4e5e                     UNLK     A6   
//000142 4e75                     RTS         
}

//*********************************************************
//
//*********************************************************
//  TAG000144
void ReadFile(i32 handle, i32 size, i8 * buffer)
{
  dReg D0;
//000144 4e56 0000                LINK     A6,#0   
//000148 2f2e 0010                MOVE.L   16(A6),-(A7)   
//00014c 202e 000c                MOVE.L   12(A6),D0   
//000150 2f00                     MOVE.L   D0,-(A7)   
//000152 202e 0008                MOVE.L   8(A6),D0   
//000156 3f00                     MOVE.W   D0,-(A7)   
//000158 3f3c 003f                MOVE.W   #63,-(A7)   
//00015c 4eba 064c                JSR      $+1614 (=0x0007aa)   
//000160 defc 000c                ADD.W    #12,A7   
  D0L = READ(handle, size, buffer);
//000164 222e 000c                MOVE.L   12(A6),D1   
//000168 b081                     CMP.L    D1,D0   
//00016a 6700 000c                BEQ      $+14 (=0x000178)   
  if (D0L != size)
  {
//00016e 3f3c 0004                MOVE.W   #4,-(A7)   
//000172 4eba 08ec                JSR      $+2286 (=0x000a60)   
//000176 548f                     ADDQ.L   #2,A7   
    TAG000a60(4);
  };
//000178 4e5e                     UNLK     A6   
//00017a 4e75                     RTS         
}

//*********************************************************
//
//*********************************************************
static i8 *TAG0004fe(char *dest, char *src)
{
  i8 *A2, *A3, *p_4;
//0004fe 4e56 fffc                LINK     A6,#-4   
//000502 48e7 0030                MOVEM.L  A23,-(A7)   
//000506 266e 0008                MOVE.L   8(A6),A3   
  A3 = dest;
//00050a 246e 000c                MOVE.L   12(A6),A2   
  A2 = src;
//00050e 2d4b fffc                MOVE.L   A3,-4(A6)   
  p_4 = A3;
//000512 6000 000e                BRA      $+16 (=0x000522)   
  while ((*p_4 = *A2) != 0)
  {
//000516 202e fffc                MOVE.L   -4(A6),D0   
//00051a 52ae fffc                ADDQ.L   #1,-4(A6)   
//00051e 200a                     MOVE.L   A2,D0   
    p_4++;
    A2++;
//000520 528a                     ADDQ.L   #1,A2   
//
//000522 206e fffc                MOVE.L   -4(A6),A0   
//000526 1092                     MOVE.B   (A2),(A0)   
//000528 6600 ffec                BNE      $-18 (=0x000516)   
  };
//00052c 200b                     MOVE.L   A3,D0   
//00052e 6000 0002                BRA      $+4 (=0x000532)   
//000532 4cdf 0c00                MOVEM.L  (A7)+,A23   
//000536 4e5e                     UNLK     A6   
//000538 4e75                     RTS         
  return A3;
}

//*********************************************************
//
//*********************************************************
void TAG00053a(i16, i32)
{
  i16 w_160;
  STRUCT148 s_148;
  i8   b_108[13];
  i8  *p_8;
  i16  w_4;
  i16  w_2;
  s_148.p_36 = NULL;
//00053a 4e56 ff60                LINK     A6,#-160   
//00053e 426e ff60                CLR.W    -160(A6)   
  w_160 = 0;
//000542 486c 0000                PEA      0(A4)   
//000546 486e ff94                PEA      -108(A6)   
//00054a 4eba ffb2                JSR      $-76 (=0x0004fe)   
//00054e 508f                     ADDQ.L   #0,A7   
  TAG0004fe(b_108, "FTLCODE");
  //TAG0004fe(b_108, "CHAOS.FTL");

//000550 6000 000c                BRA      $+14 (=0x00055e)   
  while (UI_CONSTAT() != 0)
  {
//000554 3f3c 0007                MOVE.W   #7,-(A7)   
//000558 4eba 0250                JSR      $+594 (=0x0007aa)   
//00055c 548f                     ADDQ.L   #2,A7   
    UI_DIRECT_CONIN();
//
//00055e 3f3c 000b                MOVE.W   #11,-(A7)   
//000562 4eba 0246                JSR      $+584 (=0x0007aa)   
//000566 548f                     ADDQ.L   #2,A7   
//000568 4a40                     TST.W    D0   
//00056a 6600 ffe8                BNE      $-22 (=0x000554)   
  };
//00056e 3d7c 5223 ff62           MOVE.W   #21027,-158(A6)   
  b.uWord158 = 0xff62;
//000574 426e ff60                CLR.W    -160(A6)   
  b.uWord160 = 0;
  for (;;)
  {
//000578 4eba 0254                JSR      $+598 (=0x0007ce)   
    SetCriticalErrorHandler();
//00057c 0c6e 5223 ff62           CMP.W    #21027,-158(A6)   
//000582 6700 0006                BEQ      $+8 (=0x00058a)   
//000586 6000 0218                BRA      $+538 (=0x0007a0)   
    if (b.uWord158 != 0xff62) break;
//00058a 426e ff62                CLR.W    -158(A6)   
    b.uWord158 = 0;
//00058e 42ae ff90                CLR.L    -112(A6)   
    b.Long112 = 0;
//000592 6000 0066                BRA      $+104 (=0x0005fa)   
//000596 4e71                     NOP         
//000598 4e71                     NOP         
//00059a 4e71                     NOP         
//00059c 4e71                     NOP         
//00059e 4e71                     NOP         
//0005a0 4e71                     NOP         
//0005a2 4e71                     NOP         
//0005a4 4e71                     NOP         
//0005a6 4e71                     NOP         
//0005a8 4e71                     NOP         
//0005aa 4e71                     NOP         
//0005ac 4e71                     NOP         
//0005ae 4e71                     NOP         
//0005b0 4e71                     NOP         
//0005b2 4e71                     NOP         
//0005b4 4e71                     NOP         
//0005b6 4e71                     NOP         
//0005b8 4e71                     NOP         
//0005ba 4e71                     NOP         
//0005bc 4e71                     NOP         
//0005be 4e71                     NOP         
//0005c0 4e71                     NOP         
//0005c2 4e71                     NOP         
//0005c4 4e71                     NOP         
//0005c6 4e71                     NOP         
//0005c8 3f3c 0007                MOVE.W   #7,-(A7)   
//0005cc 4eba 01dc                JSR      $+478 (=0x0007aa)   
//0005d0 548f                     ADDQ.L   #2,A7   
//0005d2 3f3c 000b                MOVE.W   #11,-(A7)   
//0005d6 4eba 01d2                JSR      $+468 (=0x0007aa)   
//0005da 548f                     ADDQ.L   #2,A7   
//0005dc 4a40                     TST.W    D0   
//0005de 6600 ffe8                BNE      $-22 (=0x0005c8)   
//0005e2 3f3c 0007                MOVE.W   #7,-(A7)   
//0005e6 4eba 01c2                JSR      $+452 (=0x0007aa)   
//0005ea 548f                     ADDQ.L   #2,A7   
//0005ec 3f3c 0001                MOVE.W   #1,-(A7)   
//0005f0 487a fb8a                PEA      $-1140 (=0x00017c)   
//0005f4 4eba 0dfa                JSR      $+3580 (=0x0013f0)   
//0005f8 5c8f                     ADDQ.L   #6,A7   

//0005fa 4e71                     NOP         
//0005fc 4e71                     NOP         
//0005fe 4e71                     NOP         
//000600 4e71                     NOP         
//000602 4e71                     NOP         
//000604 4e71                     NOP         
//000606 4e71                     NOP         
//000608 4e71                     NOP         
//00060a 4e71                     NOP         
//00060c 4e71                     NOP         
//00060e 4e71                     NOP         
//000610 4e71                     NOP         
//000612 4e71                     NOP         
//000614 4e71                     NOP         
//000616 4e71                     NOP         
//000618 4e71                     NOP         
//00061a 4e71                     NOP         
//00061c 4e71                     NOP         
//00061e 4e71                     NOP         
//000620 4e71                     NOP         
//000622 4267                     CLR.W    -(A7)   
//000624 486e ff94                PEA      -108(A6)   
//000628 3f3c 003d                MOVE.W   #61,-(A7)   
//00062c 4eba 017c                JSR      $+382 (=0x0007aa)   
//000630 508f                     ADDQ.L   #0,A7   
//000632 3d40 fffc                MOVE.W   D0,-4(A6)   
    w_4 = OPEN(b_108, 0);
    if (w_4 < 0)
    {
      die(0, "Cannot open file FTLCODE");
    };
//000636 0c40 0000                CMP.W    #0,D0   
//00063a 6c00 001c                BGE      $+30 (=0x000658)   
//00063e 3f3c 0500                MOVE.W   #1280,-(A7)   
//000642 4eba 03aa                JSR      $+940 (=0x0009ee)   
//000646 548f                     ADDQ.L   #2,A7   
//000648 3d40 fffe                MOVE.W   D0,-2(A6)   
//00064c 0c40 0000                CMP.W    #0,D0   
//000650 6700 0006                BEQ      $+8 (=0x000658)   
//000654 6000 0128                BRA      $+298 (=0x00077e)   
    if (   (w_4 >= 0)
        || ((w_2=TAG0009ee(0x500))==0)  )
    {
//000658 302e fffc                MOVE.W   -4(A6),D0   
//00065c c0bc 0000 ffff           AND.L    #65535,D0   
//000662 2d40 ff7c                MOVE.L   D0,-132(A6)   
      s_148.handle = w_4 & 0xffff;
//000666 41fa fa4c                LEA      $-1458 (=0x0000b4),A0   
//00066a 2d48 ff6c                MOVE.L   A0,-148(A6)   
      s_148.malloc = MallocMemory;
//00066e 41fa fa7c                LEA      $-1410 (=0x0000ec),A0   
//000672 2d48 ff70                MOVE.L   A0,-144(A6)   
      s_148.free = FreeMemory;
//000676 41fa fa96                LEA      $-1384 (=0x00010e),A0   
//00067a 2d48 ff74                MOVE.L   A0,-140(A6)   
      s_148.seek = FileSeek;
//00067e 41fa fac4                LEA      $-1338 (=0x000144),A0   
//000682 2d48 ff78                MOVE.L   A0,-136(A6)   
      s_148.read = ReadFile;
//000686 486e ff6c                PEA      -148(A6)   
//00068a 4eba 0446                JSR      $+1096 (=0x000ad2)   
//00068e 588f                     ADDQ.L   #4,A7   
//000690 3d40 fffe                MOVE.W   D0,-2(A6)   
      w_2 = LoadProgram(&s_148);
//000694 3f2e fffc                MOVE.W   -4(A6),-(A7)   
//000698 3f3c 003e                MOVE.W   #62,-(A7)   
//00069c 4eba 010c                JSR      $+270 (=0x0007aa)   
//0006a0 588f                     ADDQ.L   #4,A7   
      CLOSE(w_4);
//0006a2 0c6e 0000 fffe           CMP.W    #0,-2(A6)   
//0006a8 6700 0006                BEQ      $+8 (=0x0006b0)   
//0006ac 6000 00d0                BRA      $+210 (=0x00077e)   
      if (w_2 == 0)
      {
//0006b0 202e ff80                MOVE.L   -128(A6),D0   
//0006b4 5880                     ADDQ.L   #4,D0   
//0006b6 2f00                     MOVE.L   D0,-(A7)   
//0006b8 3f3c 0048                MOVE.W   #72,-(A7)   
//0006bc 4eba 00ec                JSR      $+238 (=0x0007aa)   
//0006c0 5c8f                     ADDQ.L   #6,A7   
//0006c2 2d40 fff8                MOVE.L   D0,-8(A6)   
        p_8 = MallocMemory(s_148.i_20+4);
//0006c6 0c80 0000 0000           CMP.L    #0,D0   
//0006cc 6600 001c                BNE      $+30 (=0x0006ea)   
//
//0006d0 3f3c 0501                MOVE.W   #1281,-(A7)   
//0006d4 4eba 0318                JSR      $+794 (=0x0009ee)   
//0006d8 548f                     ADDQ.L   #2,A7   
//0006da 3d40 fffe                MOVE.W   D0,-2(A6)   
//0006de 0c40 0000                CMP.W    #0,D0   
//0006e2 6700 0006                BEQ      $+8 (=0x0006ea)   
//0006e6 6000 0096                BRA      $+152 (=0x00077e)   
        if (   (p_8 != NULL) 
            || ((w_2=TAG0009ee(0x501))==0)  )
        {
//0006ea 202e fff8                MOVE.L   -8(A6),D0   
//0006ee d0ae ff80                ADD.L    -128(A6),D0   
//0006f2 5280                     ADDQ.L   #1,D0   
//0006f4 c0bc ffff fffe           AND.L    #-2,D0   
//0006fa 2d40 ff8c                MOVE.L   D0,-116(A6)   
          s_148.p_32 = p_8 + ((s_148.i_20+1) & 0xfffffffe);
          NotImplemented(0x6fe);
        /*
//0006fe 48e7 1f3e                MOVEM.L  D34567A23456,-(A7)   
//000702 2a6e ff84                MOVE.L   -124(A6),A5   
//000706 2b4f 0004                MOVE.L   A7,4(A5)   
//00070a 2e6e ff8c                MOVE.L   -116(A6),A7  //Stack 
//00070e 206e ff88                MOVE.L   -120(A6),A0   
//000712 486e ff6c                PEA      -148(A6)   
//000716 3f2e ff60                MOVE.W   -160(A6),-(A7)   
//00071a 4e90                     JSR      (A0)   
//00071c 2e6d 0004                MOVE.L   4(A5),A7   
//000720 4cdf 7cf8                MOVEM.L  (A7)+,D34567A23456   
*/
          NotImplemented(0x724);
  /*  
//000724 202e ff84                MOVE.L   -124(A6),D0   
//000728 2040                     MOVE.L   D0,A0   
          A0 = s_148.p_24;
//00072a 0c50 6160                CMP.W    #24928,(A0)   
//00072e 6600 003c                BNE      $+62 (=0x00076c)   
//000732 202e ff84                MOVE.L   -124(A6),D0   
//000736 5480                     ADDQ.L   #2,D0   
//000738 2040                     MOVE.L   D0,A0   
//00073a 0c50 5223                CMP.W    #21027,(A0)   
//00073e 6600 0024                BNE      $+38 (=0x000764)   
//000742 3d7c 5223 ff62           MOVE.W   #21027,-158(A6)   
//000748 202e ff84                MOVE.L   -124(A6),D0   
//00074c d0bc 0000 001c           ADD.L    #28,D0   
//000752 2040                     MOVE.L   D0,A0   
//000754 2f10                     MOVE.L   (A0),-(A7)   
//000756 486e ff94                PEA      -108(A6)   
//00075a 4eba fda2                JSR      $-604 (=0x0004fe)   
//00075e 508f                     ADDQ.L   #0,A7   
//000760 6000 0006                BRA      $+8 (=0x000768)   
//000764 426e ff62                CLR.W    -158(A6)   
//000768 6000 0006                BRA      $+8 (=0x000770)   
//00076c 426e ff62                CLR.W    -158(A6)   
//000770 2f2e fff8                MOVE.L   -8(A6),-(A7)   
//000774 3f3c 0049                MOVE.W   #73,-(A7)   
//000778 4eba 0030                JSR      $+50 (=0x0007aa)   
//00077c 5c8f                     ADDQ.L   #6,A7   
*/
        };
      };
    };
//00077e 0cae 0000 0000 ff90      CMP.L    #0,-112(A6)   
//000786 6700 0010                BEQ      $+18 (=0x000798)   
    if (s_148.p_36 != NULL)
    {
//00078a 2f2e ff90                MOVE.L   -112(A6),-(A7)   
//00078e 3f3c 0049                MOVE.W   #73,-(A7)   
//000792 4eba 0016                JSR      $+24 (=0x0007aa)   
//000796 5c8f                     ADDQ.L   #6,A7   
      FreeMemory(s_148.p_36);
    };
//000798 526e ff60                ADDQ.W   #1,-160(A6)   
//00079c 6000 fdda                BRA      $-548 (=0x000578)   
    w_160++;
  };
//0007a0 6000 fffe                BRA      $+0 (=0x0007a0)   
  for (;;) {};
//0007a4 4e5e                     UNLK     A6   
//0007a6 4e75                     RTS         
}


//*********************************************************
//
//*********************************************************
void TAG0007a8(i32)
{
//0007a8 4e75                     RTS         
}

//*********************************************************
//
//*********************************************************
//   TAG0007ce
void SetCriticalErrorHandler(void)
{
  SetSupervisorMode();
// Set critical error handler to:
//0007ec 70ff                     MOVEQ.L  #-1,D0 
//0007ee 4e75                     RTS         
  ClearSupervisorMode();
}

//*********************************************************
//
//*********************************************************
i16 TAG0009ee(i32)
{
  NotImplemented(0x9ee); return 0;
}

//*********************************************************
//
//*********************************************************
void TAG000a60(i32 errorCode)
{
  char msg[1000];
  sprintf(msg,"Loader Error\n0x%08x", errorCode);
  UI_MessageBox(msg,NULL,MESSAGE_OK);
  throw 0xbad;
//000a60 4e56 0000                LINK     A6,#0   
//000a64 3f07                     MOVE.W   D7,-(A7)   
//000a66 3e2e 0008                MOVE.W   8(A6),D7   
//000a6a 486c 0022                PEA      34(A4)   
//000a6e 3f3c 0009                MOVE.W   #9,-(A7)   
//000a72 4eba fd36                JSR      $-712 (=0x0007aa)   
//000a76 5c8f                     ADDQ.L   #6,A7   
  // Print "Loader Error"
//000a78 486c ff92                PEA      -110(A4)   
//000a7c 3007                     MOVE.W   D7,D0   
//000a7e c0bc 0000 ffff           AND.L    #65535,D0   
//000a84 2f00                     MOVE.L   D0,-(A7)   
//000a86 4eba 08dc                JSR      $+2270 (=0x001364)   
//000a8a 508f                     ADDQ.L   #0,A7   
//000a8c 486c ff92                PEA      -110(A4)   
//000a90 3f3c 0009                MOVE.W   #9,-(A7)   
//000a94 4eba fd14                JSR      $-746 (=0x0007aa)   
//000a98 5c8f                     ADDQ.L   #6,A7   
  // convert error number???
//000a9a 486c 003a                PEA      58(A4)   
//000a9e 3f3c 0009                MOVE.W   #9,-(A7)   
//000aa2 4eba fd06                JSR      $-760 (=0x0007aa)   
  // "0x"
//000aa6 5c8f                     ADDQ.L   #6,A7   
//000aa8 6000 0002                BRA      $+4 (=0x000aac)   
//000aac 3f3c 000b                MOVE.W   #11,-(A7)   
//000ab0 4eba fcf8                JSR      $-774 (=0x0007aa)   
//000ab4 548f                     ADDQ.L   #2,A7   
//000ab6 4a40                     TST.W    D0   
//000ab8 6700 fff2                BEQ      $-12 (=0x000aac)   
//000abc 3f3c 0007                MOVE.W   #7,-(A7)   
//000ac0 4eba fce8                JSR      $-790 (=0x0007aa)   
//000ac4 548f                     ADDQ.L   #2,A7   
//000ac6 3007                     MOVE.W   D7,D0   
//000ac8 6000 0002                BRA      $+4 (=0x000acc)   
//000acc 3e1f                     MOVE.W   (A7)+,D7   
  // Printing stack????
//000ace 4e5e                     UNLK     A6   
//000ad0 4e75                     RTS         
}
struct SEGMENTDESC
{
  i16 SegmentNumber; //0
  i16 One;           //2 //Always contains a one.
  i32 Offset;        //4 //File offset of segment
  i32 Length;        //8 //Length of segment
};
//*********************************************************
//
//*********************************************************
//  TAG000ad2
i16 LoadProgram(STRUCT148 *s148)
{
  dReg D0, D3, D7;
  aReg A0;
  bool exitFlag; //Escape from 'do-loop'.
  i8  *p_128;
  SEGMENTDESC  *pSegDesc;//p_118;
  i8   b_114[40];
  i8   b_74[20];
  i8  *p_54;
  i8  *p_50;
  i8  *p_46;
  i8  *p_42;
  i8  *p_38;
  i8  *p_34;
  i8  *p_30;
  i32  Segment18;//26
  i32  Segment17;//22
  i32  Segment16;//18
  i32  i_14;
  i32  i_10;
  i32  i_6;
  i16  w_2;
//000ad2 4e56 ff80                LINK     A6,#-128   
//000ad6 3f07                     MOVE.W   D7,-(A7)   
//000ad8 42ae ff8a                CLR.L    -118(A6)   
  pSegDesc = NULL;
//000adc 206e 0008                MOVE.L   8(A6),A0   
//000ae0 42a8 0024                CLR.L    36(A0)   
  s148->p_36 = NULL;
//000ae4 42ae ffce                CLR.L    -50(A6)   
  p_50 = NULL;
//000ae8 486e ffb6                PEA      -74(A6)   
//000aec 2f3c 0000 0014           MOVE.L   #20,-(A7)   
//000af2 206e 0008                MOVE.L   8(A6),A0   
//000af6 2f28 0010                MOVE.L   16(A0),-(A7)   
//000afa 206e 0008                MOVE.L   8(A6),A0   
//000afe 2068 000c                MOVE.L   12(A0),A0   
//000b02 4e90                     JSR      (A0)   
//000b04 defc 000c                ADD.W    #12,A7   
  s148->read(s148->handle, 20, b_74);
  exitFlag=false;
  for (;;)
  { // This is a fake loop.  There are a lot of jumps
    // to the instruction just beyond the end of this
    // loop and I wanted to avoid complicated if-statements
    // and/or goto-statements.  A break-statement fit
    // the need.
    // We also need a way to 'break out' of nested 
    // case-structures and for-loops.  The boolean
    // variable 'exitFlag' provides an escape.
//000b08 0c6e 6160 ffb6           CMP.W    #24928,-74(A6)   
//000b0e 6600 002c                BNE      $+46 (=0x000b3c)   

//000b12 0c6e 0002 ffba           CMP.W    #2,-70(A6)   
//000b18 6600 0022                BNE      $+36 (=0x000b3c)   

//000b1c 102e ffbc                MOVE.B   -68(A6),D0   
//000b20 c07c 00ff                AND.W    #255,D0   
//000b24 b07c 0001                CMP.W    #1,D0   
//000b28 6600 0012                BNE      $+20 (=0x000b3c)   
//000b2c 102e ffbd                MOVE.B   -67(A6),D0   
//000b30 c07c 00ff                AND.W    #255,D0   
//000b34 b07c 0000                CMP.W    #0,D0   
//000b38 6700 001a                BEQ      $+28 (=0x000b54)   
    if (    (b_74[0]!=0x61)
         || (b_74[1]!=0x60)
         || (b_74[4]!=0)
         || (b_74[5]!=2)
         || (b_74[6]!=1)    
         || (b_74[7]!=0) )
    {
//000b3c 3f3c 0001                MOVE.W   #1,-(A7)   
//000b40 4eba feac                JSR      $-338 (=0x0009ee)   
//000b44 548f                     ADDQ.L   #2,A7   
//000b46 3e00                     MOVE.W   D0,D7   
    D7W = TAG0009ee(1);
//000b48 0c40 0000                CMP.W    #0,D0   
//000b4c 6700 0006                BEQ      $+8 (=0x000b54)   
//000b50 6000 06ac                BRA      $+1710 (=0x0011fe)   
      if (D7W != 0) break;
    };
//000b54 0c6e 0064 ffc8           CMP.W    #100,-56(A6)   
//000b5a 6300 001a                BLS      $+28 (=0x000b76)   
    if (littleEndian(wordGear(b_74+18)) > 100) 
    {
//
//000b5e 3f3c 001a                MOVE.W   #26,-(A7)   
//000b62 4eba fe8a                JSR      $-372 (=0x0009ee)   
//000b66 548f                     ADDQ.L   #2,A7   
//000b68 3e00                     MOVE.W   D0,D7   
      D7W = TAG0009ee(26);
//000b6a 0c40 0000                CMP.W    #0,D0   
//000b6e 6700 0006                BEQ      $+8 (=0x000b76)   
//000b72 6000 068a                BRA      $+1676 (=0x0011fe)   
      if (D7W !=0) break;
    };
//000b76 302e ffc8                MOVE.W   -56(A6),D0   
//000b7a c0fc 000c                MULU     #12,D0   
//000b7e c0bc 0000 ffff           AND.L    #65535,D0   
//000b84 2d40 fff2                MOVE.L   D0,-14(A6)   
    i_14 = (12 * littleEndian(wordGear(b_74+18))) & 0xffff;
//000b88 202e fff2                MOVE.L   -14(A6),D0   
//000b8c 2f00                     MOVE.L   D0,-(A7)   
//000b8e 206e 0008                MOVE.L   8(A6),A0   
//000b92 2050                     MOVE.L   (A0),A0   
//000b94 4e90                     JSR      (A0)   
//000b96 588f                     ADDQ.L   #4,A7   
//000b98 2d40 ff8a                MOVE.L   D0,-118(A6)   
    pSegDesc = (SEGMENTDESC *)s148->malloc(i_14);
//000b9c 2f2e ff8a                MOVE.L   -118(A6),-(A7)   
//000ba0 2f2e fff2                MOVE.L   -14(A6),-(A7)   
//000ba4 206e 0008                MOVE.L   8(A6),A0   
//000ba8 2f28 0010                MOVE.L   16(A0),-(A7)   
//000bac 206e 0008                MOVE.L   8(A6),A0   
//000bb0 2068 000c                MOVE.L   12(A0),A0   
//000bb4 4e90                     JSR      (A0)   
//000bb6 defc 000c                ADD.W    #12,A7   
    s148->read(s148->handle, i_14, (i8 *)pSegDesc);
//000bba 2f2e ff8a                MOVE.L   -118(A6),-(A7)   
//000bbe 486e ffb6                PEA      -74(A6)   
//000bc2 4eba 06b8                JSR      $+1722 (=0x00127c)   
//000bc6 508f                     ADDQ.L   #0,A7   
    D0W = CheckSum(b_74, (i8 *)pSegDesc);
//000bc8 b06e ffb8                CMP.W    -72(A6),D0   
//000bcc 6700 001a                BEQ      $+28 (=0x000be8)   
    if (D0W != littleEndian(wordGear(b_74+2)))
    {
//000bd0 3f3c 000e                MOVE.W   #14,-(A7)   
//000bd4 4eba fe18                JSR      $-486 (=0x0009ee)   
//000bd8 548f                     ADDQ.L   #2,A7   
//000bda 3e00                     MOVE.W   D0,D7   
      D7W = TAG0009ee(14);
//000bdc 0c40 0000                CMP.W    #0,D0   
//000be0 6700 0006                BEQ      $+8 (=0x000be8)   
//000be4 6000 0618                BRA      $+1562 (=0x0011fe)   
      if (D7W != 0) break;
    };
//000be8 2d7c ffff ffff ffee      MOVE.L   #-1,-18(A6)   
//000bf0 2d7c ffff ffff ffea      MOVE.L   #-1,-22(A6)   
//000bf8 2d7c ffff ffff ffe6      MOVE.L   #-1,-26(A6)   
    Segment18 = -1;
    Segment17 = -1;
    Segment16 = -1;
//000c00 4247                     CLR.W    D7   
//000c02 6000 0184                BRA      $+390 (=0x000d88)   
    for (D7W=0; D7W<littleEndian(wordGear(b_74+18)); D7W++)
    {
//000c06 3007                     MOVE.W   D7,D0   
//000c08 c1fc 000c                MULS     #12,D0   
//000c0c 206e ff8a                MOVE.L   -118(A6),A0   
//000c10 d0c0                     ADD.W    D0,A0   
//000c12 3010                     MOVE.W   (A0),D0   
      D0W = littleEndian(pSegDesc[D7W].SegmentNumber);
//000c14 6000 0002                BRA      $+4 (=0x000c18)   
      switch (D0W)
      {
//000c18 b07c 0010                CMP.W    #16,D0   
//000c1c 6700 0006                BEQ      $+8 (=0x000c24)   
//000c20 6000 006c                BRA      $+110 (=0x000c8e)   
      case 16:
//000c24 3007                     MOVE.W   D7,D0   
//000c26 c1fc 000c                MULS     #12,D0   
//000c2a 206e ff8a                MOVE.L   -118(A6),A0   
//000c2e d0c0                     ADD.W    D0,A0   
//000c30 0c68 0001 0002           CMP.W    #1,2(A0)   
//000c36 6700 001a                BEQ      $+28 (=0x000c52)   
        if (littleEndian(pSegDesc[D7W].One) != 1)
        {
//000c3a 3f3c 0014                MOVE.W   #20,-(A7)   
//000c3e 4eba fdae                JSR      $-592 (=0x0009ee)   
//000c42 548f                     ADDQ.L   #2,A7   
//000c44 3e00                     MOVE.W   D0,D7   
          D7W = TAG0009ee(20);
//000c46 0c40 0000                CMP.W    #0,D0   
//000c4a 6700 0006                BEQ      $+8 (=0x000c52)   
//000c4e 6000 05ae                BRA      $+1456 (=0x0011fe)   
          if (D7W != 0)
          {
            exitFlag=true;
            break;
          };
        };
//000c52 0cae ffff ffff ffee      CMP.L    #-1,-18(A6)   
//000c5a 6600 0012                BNE      $+20 (=0x000c6e)   
        if (Segment16 == -1)
        {
//000c5e 3007                     MOVE.W   D7,D0   
//000c60 c0bc 0000 ffff           AND.L    #65535,D0   
//000c66 2d40 ffee                MOVE.L   D0,-18(A6)   
          Segment16 = D7W & 0xffff;
//000c6a 6000 001a                BRA      $+28 (=0x000c86)   
        }
        else
        {
//000c6e 3f3c 0017                MOVE.W   #23,-(A7)   
//000c72 4eba fd7a                JSR      $-644 (=0x0009ee)   
//000c76 548f                     ADDQ.L   #2,A7   
//000c78 3e00                     MOVE.W   D0,D7   
          D7W = TAG0009ee(23);
//000c7a 0c40 0000                CMP.W    #0,D0   
//000c7e 6700 0006                BEQ      $+8 (=0x000c86)   
//000c82 6000 057a                BRA      $+1404 (=0x0011fe)   
          if (D7W != 0)
          {
            exitFlag=true;
            break;
          };
        };
//000c86 6000 00fe                BRA      $+256 (=0x000d86)   
        break;
//000c8a 6000 000e                BRA      $+16 (=0x000c9a)   

//000c8e b07c 0011                CMP.W    #17,D0   
//000c92 6700 0006                BEQ      $+8 (=0x000c9a)   
//000c96 6000 006c                BRA      $+110 (=0x000d04)   
      case 17:
//000c9a 3007                     MOVE.W   D7,D0   
//000c9c c1fc 000c                MULS     #12,D0   
//000ca0 206e ff8a                MOVE.L   -118(A6),A0   
//000ca4 d0c0                     ADD.W    D0,A0   
//000ca6 0c68 0001 0002           CMP.W    #1,2(A0)   
//000cac 6700 001a                BEQ      $+28 (=0x000cc8)   
        if (littleEndian(pSegDesc[D7W].One) != 1)
        {
//000cb0 3f3c 0015                MOVE.W   #21,-(A7)   
//000cb4 4eba fd38                JSR      $-710 (=0x0009ee)   
//000cb8 548f                     ADDQ.L   #2,A7   
//000cba 3e00                     MOVE.W   D0,D7   
          D7W = TAG0009ee(21);
//000cbc 0c40 0000                CMP.W    #0,D0   
//000cc0 6700 0006                BEQ      $+8 (=0x000cc8)   
//000cc4 6000 0538                BRA      $+1338 (=0x0011fe)   
          if (D7W != 0)
          {
            exitFlag=true;
            break;
          };
        };
//000cc8 0cae ffff ffff ffea      CMP.L    #-1,-22(A6)   
//000cd0 6600 0012                BNE      $+20 (=0x000ce4)   
        if (Segment17 == -1)
        {
//000cd4 3007                     MOVE.W   D7,D0   
//000cd6 c0bc 0000 ffff           AND.L    #65535,D0   
//000cdc 2d40 ffea                MOVE.L   D0,-22(A6)   
          Segment17 = D7W & 0xffff;
//000ce0 6000 001a                BRA      $+28 (=0x000cfc)   
        }
        else
        {
//000ce4 3f3c 0018                MOVE.W   #24,-(A7)   
//000ce8 4eba fd04                JSR      $-762 (=0x0009ee)   
//000cec 548f                     ADDQ.L   #2,A7   
//000cee 3e00                     MOVE.W   D0,D7   
          D7W = TAG0009ee(24);
//000cf0 0c40 0000                CMP.W    #0,D0   
//000cf4 6700 0006                BEQ      $+8 (=0x000cfc)   
//000cf8 6000 0504                BRA      $+1286 (=0x0011fe)   
          if (D7W != 0)
          {
            exitFlag=true;
            break;
          };
        };
//000cfc 6000 0088                BRA      $+138 (=0x000d86)   
        break;
//000d00 6000 000e                BRA      $+16 (=0x000d10)   

//000d04 b07c 0012                CMP.W    #18,D0   
//000d08 6700 0006                BEQ      $+8 (=0x000d10)   
//000d0c 6000 0074                BRA      $+118 (=0x000d82)   
      case 18:
//000d10 3007                     MOVE.W   D7,D0   
//000d12 c1fc 000c                MULS     #12,D0   
//000d16 206e ff8a                MOVE.L   -118(A6),A0   
//000d1a d0c0                     ADD.W    D0,A0   
//000d1c 0c68 0001 0002           CMP.W    #1,2(A0)   
//000d22 6700 001a                BEQ      $+28 (=0x000d3e)   
        if (littleEndian(pSegDesc[D7W].One) != 1)
        {
//000d26 3f3c 0016                MOVE.W   #22,-(A7)   
//000d2a 4eba fcc2                JSR      $-828 (=0x0009ee)   
//000d2e 548f                     ADDQ.L   #2,A7   
//000d30 3e00                     MOVE.W   D0,D7   
          D7W = TAG0009ee(22);
//000d32 0c40 0000                CMP.W    #0,D0   
//000d36 6700 0006                BEQ      $+8 (=0x000d3e)   
//000d3a 6000 04c2                BRA      $+1220 (=0x0011fe)   
          if (D7W != 0)
          {
            exitFlag=true;
            break;
          };
        };
//000d3e 0cae ffff ffff ffe6      CMP.L    #-1,-26(A6)   
//000d46 6600 0012                BNE      $+20 (=0x000d5a)   
        if (Segment18 == -1)
        {
//000d4a 3007                     MOVE.W   D7,D0   
//000d4c c0bc 0000 ffff           AND.L    #65535,D0   
//000d52 2d40 ffe6                MOVE.L   D0,-26(A6)   
          Segment18 = D7W & 0xffff;
//000d56 6000 001a                BRA      $+28 (=0x000d72)   
        }
        else
        {
//000d5a 3f3c 0019                MOVE.W   #25,-(A7)   
//000d5e 4eba fc8e                JSR      $-880 (=0x0009ee)   
//000d62 548f                     ADDQ.L   #2,A7   
//000d64 3e00                     MOVE.W   D0,D7   
          D7W = TAG0009ee(25);
//000d66 0c40 0000                CMP.W    #0,D0   
//000d6a 6700 0006                BEQ      $+8 (=0x000d72)   
//000d6e 6000 048e                BRA      $+1168 (=0x0011fe)   
          if (D7W != 0)
          {
            exitFlag=true;
            break;
          };
        };
//000d72 6000 0012                BRA      $+20 (=0x000d86)   
        break;
//000d76 6000 0002                BRA      $+4 (=0x000d7a)   
//000d7a 6000 000a                BRA      $+12 (=0x000d86)   
//000d7e 6000 0006                BRA      $+8 (=0x000d86)   
      default: break;
//000d82 6000 fff6                BRA      $-8 (=0x000d7a)   
      };
      if (exitFlag) break;
//000d86 5247                     ADDQ.W   #1,D7   
//
//000d88 3007                     MOVE.W   D7,D0   
//000d8a b06e ffc8                CMP.W    -56(A6),D0   
//000d8e 6500 fe76                BCS      $-392 (=0x000c06)   
    }; //for (D7W)
    if (exitFlag) break;
//000d92 0cae ffff ffff ffee      CMP.L    #-1,-18(A6)   
//000d9a 6700 001a                BEQ      $+28 (=0x000db6)   
//000d9e 0cae ffff ffff ffea      CMP.L    #-1,-22(A6)   
//000da6 6700 000e                BEQ      $+16 (=0x000db6)   
//000daa 0cae ffff ffff ffe6      CMP.L    #-1,-26(A6)   
//000db2 6600 001a                BNE      $+28 (=0x000dce)   
    if ( (Segment16==-1)||(Segment17==-1)||(Segment18==-1) )
    {
//000db6 3f3c 0002                MOVE.W   #2,-(A7)   
//000dba 4eba fc32                JSR      $-972 (=0x0009ee)   
//000dbe 548f                     ADDQ.L   #2,A7   
//000dc0 3e00                     MOVE.W   D0,D7   
      D7W = TAG0009ee(2);
//000dc2 0c40 0000                CMP.W    #0,D0   
//000dc6 6700 0006                BEQ      $+8 (=0x000dce)   
//000dca 6000 0432                BRA      $+1076 (=0x0011fe)   
      if (D7W != 0) break;
    };
//000dce 202e ffee                MOVE.L   -18(A6),D0   
//000dd2 c0fc 000c                MULU     #12,D0   
//000dd6 206e ff8a                MOVE.L   -118(A6),A0   
//000dda d1c0                     ADD.L    D0,A0   
//000ddc 2028 0004                MOVE.L   4(A0),D0   
    D0L = LE32(pSegDesc[Segment16].Offset);
//000de0 2f00                     MOVE.L   D0,-(A7)   
//000de2 206e 0008                MOVE.L   8(A6),A0   
//000de6 2f28 0010                MOVE.L   16(A0),-(A7)   
//000dea 206e 0008                MOVE.L   8(A6),A0   
//000dee 2068 0008                MOVE.L   8(A0),A0   
//000df2 4e90                     JSR      (A0)   
//000df4 508f                     ADDQ.L   #0,A7   
    s148->seek(s148->handle, D0L); //To Segment 16..jump table??
//000df6 486e ff8e                PEA      -114(A6)   
//000dfa 2f3c 0000 0028           MOVE.L   #40,-(A7)   
//000e00 206e 0008                MOVE.L   8(A6),A0   
//000e04 2f28 0010                MOVE.L   16(A0),-(A7)   
//000e08 206e 0008                MOVE.L   8(A6),A0   
//000e0c 2068 000c                MOVE.L   12(A0),A0   
//000e10 4e90                     JSR      (A0)   
//000e12 defc 000c                ADD.W    #12,A7   
    s148->read(s148->handle, 40, b_114);
//000e16 203c 0000 0000           MOVE.L   #0,D0   
//000e1c d0ae ff92                ADD.L    -110(A6),D0   
//000e20 d0ae ff8e                ADD.L    -114(A6),D0   
//000e24 d0ae ffa2                ADD.L    -94(A6),D0   
//000e28 d0bc 0000 000c           ADD.L    #12,D0   
//000e2e 2d40 fff2                MOVE.L   D0,-14(A6)   
    i_14 =  LE32(longGear(b_114+4))
          + LE32(longGear(b_114))
          + LE32(longGear(b_114+20))
          + 12;
//000e32 2f2e fff2                MOVE.L   -14(A6),-(A7)   
//000e36 206e 0008                MOVE.L   8(A6),A0   
//000e3a 2050                     MOVE.L   (A0),A0   
//000e3c 4e90                     JSR      (A0)   
//000e3e 588f                     ADDQ.L   #4,A7   
//000e40 2d40 ffd6                MOVE.L   D0,-42(A6)   
    p_42 = s148->malloc(i_14);
//000e44 206e 0008                MOVE.L   8(A6),A0   
//000e48 2140 0024                MOVE.L   D0,36(A0)   
    s148->p_36 = p_42;
//000e4c 202e ffd6                MOVE.L   -42(A6),D0   
//000e50 d0bc 0000 0000           ADD.L    #0,D0   
//000e56 5280                     ADDQ.L   #1,D0   
//000e58 c0bc ffff fffe           AND.L    #-2,D0   
//000e5e 2d40 ffe2                MOVE.L   D0,-30(A6)   
    p_30 = p_42;
//000e62 202e ffe2                MOVE.L   -30(A6),D0   
//000e66 d0ae ff92                ADD.L    -110(A6),D0   
//000e6a 5280                     ADDQ.L   #1,D0   
//000e6c c0bc ffff fffe           AND.L    #-2,D0   
//000e72 2d40 ffde                MOVE.L   D0,-34(A6)   
    D0L = LE32(longGear(b_114+4));
    p_34 = p_30 + ((D0L+1) & 0xfffffffe);
//000e76 202e ffde                MOVE.L   -34(A6),D0   
//000e7a d0ae ff8e                ADD.L    -114(A6),D0   
//000e7e 5280                     ADDQ.L   #1,D0   
//000e80 c0bc ffff fffe           AND.L    #-2,D0   
//000e86 2d40 ffda                MOVE.L   D0,-38(A6)   
    D0L = LE32(longGear(b_114));
    p_38 = p_34 + ((D0L+1) & 0xfffffffe);
//000e8a 202e ffee                MOVE.L   -18(A6),D0   
//000e8e c0fc 000c                MULU     #12,D0   
//000e92 206e ff8a                MOVE.L   -118(A6),A0   
//000e96 d1c0                     ADD.L    D0,A0   
//000e98 2d68 0008 fff2           MOVE.L   8(A0),-14(A6)   
    i_14 = LE32(pSegDesc[Segment16].Length);
//000e9e 202e ffea                MOVE.L   -22(A6),D0   
//000ea2 c0fc 000c                MULU     #12,D0   
//000ea6 206e ff8a                MOVE.L   -118(A6),A0   
//000eaa d1c0                     ADD.L    D0,A0   
//000eac 2028 0008                MOVE.L   8(A0),D0   
    D0L = LE32(pSegDesc[Segment17].Length);
//000eb0 b0ae fff2                CMP.L    -14(A6),D0   
//000eb4 6300 0016                BLS      $+24 (=0x000ecc)   
    if (D0L > i_14) i_14 = D0L;
//000eb8 202e ffea                MOVE.L   -22(A6),D0   
//000ebc c0fc 000c                MULU     #12,D0   
//000ec0 206e ff8a                MOVE.L   -118(A6),A0   
//000ec4 d1c0                     ADD.L    D0,A0   
//000ec6 2d68 0008 fff2           MOVE.L   8(A0),-14(A6)   
//000ecc 202e fff2                MOVE.L   -14(A6),D0   
//000ed0 b0ae ffa2                CMP.L    -94(A6),D0   
//000ed4 6300 0028                BLS      $+42 (=0x000efe)   
    if (i_14 > LE32(longGear(b_114+20)))
    {
//000ed8 2f2e fff2                MOVE.L   -14(A6),-(A7)   
//000edc 206e 0008                MOVE.L   8(A6),A0   
//000ee0 2050                     MOVE.L   (A0),A0   
//000ee2 4e90                     JSR      (A0)   
//000ee4 588f                     ADDQ.L   #4,A7   
//000ee6 2d40 ffce                MOVE.L   D0,-50(A6)   
      p_50 = s148->malloc(i_14);
//000eea 202e ffce                MOVE.L   -50(A6),D0   
//000eee 5280                     ADDQ.L   #1,D0   
//000ef0 c0bc ffff fffe           AND.L    #-2,D0   
//000ef6 2d40 ffca                MOVE.L   D0,-54(A6)   
      p_54 = p_50;
//000efa 6000 0008                BRA      $+10 (=0x000f04)   
    }
    else
    {
//000efe 2d6e ffda ffca           MOVE.L   -38(A6),-54(A6)   
      p_54 = p_38;
    };
//000f04 2d6e ffca ffd6           MOVE.L   -54(A6),-42(A6)   
    p_42 = p_54;
//000f0a 202e ffde                MOVE.L   -34(A6),D0   
//000f0e d0ae ff9a                ADD.L    -102(A6),D0   
//000f12 2d40 ffd2                MOVE.L   D0,-46(A6)   
    p_46 = p_34 + LE32(longGear(b_114+12));
//000f16 202e ffee                MOVE.L   -18(A6),D0   
//000f1a c0fc 000c                MULU     #12,D0   
//000f1e 206e ff8a                MOVE.L   -118(A6),A0   
//000f22 d1c0                     ADD.L    D0,A0   
//000f24 2028 0008                MOVE.L   8(A0),D0   
    D0L = LE32(pSegDesc[Segment16].Length);
//000f28 90bc 0000 0028           SUB.L    #40,D0   
//000f2e 2d40 fff2                MOVE.L   D0,-14(A6)   
    i_14 = D0L - 40;
//000f32 2f2e ffd6                MOVE.L   -42(A6),-(A7)   
//000f36 2f2e fff2                MOVE.L   -14(A6),-(A7)   
//000f3a 206e 0008                MOVE.L   8(A6),A0   
//000f3e 2f28 0010                MOVE.L   16(A0),-(A7)   
//000f42 206e 0008                MOVE.L   8(A6),A0   
//000f46 2068 000c                MOVE.L   12(A0),A0   
//000f4a 4e90                     JSR      (A0)   
//000f4c defc 000c                ADD.W    #12,A7   
    s148->read(s148->handle, i_14, p_42);
//000f50 202e fff2                MOVE.L   -14(A6),D0   
//000f54 2f00                     MOVE.L   D0,-(A7)   
//000f56 2f2e ffd6                MOVE.L   -42(A6),-(A7)   
//000f5a 4eba 039a                JSR      $+924 (=0x0012f6)   
//000f5e 508f                     ADDQ.L   #0,A7   
//000f60 3d40 fffe                MOVE.W   D0,-2(A6)   
    w_2 = TAG0012f6(p_42, i_14);
//000f64 2f3c 0000 0028           MOVE.L   #40,-(A7)   
//000f6a 486e ff8e                PEA      -114(A6)   
//000f6e 4eba 0386                JSR      $+904 (=0x0012f6)   
//000f72 508f                     ADDQ.L   #0,A7   
//000f74 d16e fffe                ADD.W    D0,-2(A6)   
    w_2 = sw(w_2 + TAG0012f6(b_114, 40));
//000f78 302e fffe                MOVE.W   -2(A6),D0   
//000f7c 906e ffb0                SUB.W    -80(A6),D0   
//000f80 b06e ffb0                CMP.W    -80(A6),D0   
//000f84 6700 001a                BEQ      $+28 (=0x000fa0)   
    D0W = littleEndian(wordGear(b_114+34));
    if (w_2 - D0W != D0W)
    {
//000f88 3f3c 000f                MOVE.W   #15,-(A7)   
//000f8c 4eba fa60                JSR      $-1438 (=0x0009ee)   
//000f90 548f                     ADDQ.L   #2,A7   
//000f92 3e00                     MOVE.W   D0,D7   
      D7W = TAG0009ee(15);
//000f94 0c40 0000                CMP.W    #0,D0   
//000f98 6700 0006                BEQ      $+8 (=0x000fa0)   
//000f9c 6000 0260                BRA      $+610 (=0x0011fe)   
      if (D7W != 0) break;
    };
//000fa0 6000 002e                BRA      $+48 (=0x000fd0)   
    while (p_42  < (p_128 = p_38 + i_14))
    { // Construct jump table
//000fa4 202e ffd2                MOVE.L   -46(A6),D0   
//000fa8 2040                     MOVE.L   D0,A0   
//000faa 317c 4ef9 0002           MOVE.W   #20217,2(A0)   
#ifdef _MSVC_INTEL
#pragma warning(disable:4310)
#endif
      wordGear(p_46+2) = littleEndian(0x4ef9); //Jump Absolute
#ifdef _MSVC_INTEL
#pragma warning(default:4310)
#endif
//000fb0 202e ffd6                MOVE.L   -42(A6),D0   
//000fb4 2040                     MOVE.L   D0,A0   
//000fb6 2010                     MOVE.L   (A0),D0   
      D0L = LE32(longGear(p_42));
//000fb8 222e ffda                MOVE.L   -38(A6),D1   
//000fbc d081                     ADD.L    D1,D0   
//000fbe 222e ffd2                MOVE.L   -46(A6),D1   
//000fc2 2041                     MOVE.L   D1,A0   
//000fc4 2140 0004                MOVE.L   D0,4(A0)   
      pntGear(p_46+4) = D0L + p_38;
//000fc8 50ae ffd2                ADDQ.L   #0,-46(A6)   
      p_46 += 8;
//000fcc 58ae ffd6                ADDQ.L   #4,-42(A6)   
      p_42 += 4;

//000fd0 202e fff2                MOVE.L   -14(A6),D0   
//000fd4 222e ffda                MOVE.L   -38(A6),D1   
//000fd8 d081                     ADD.L    D1,D0   
//000fda 2d40 ff80                MOVE.L   D0,-128(A6)   
//000fde 202e ffd6                MOVE.L   -42(A6),D0   
//000fe2 b0ae ff80                CMP.L    -128(A6),D0   
//000fe6 6d00 ffbc                BLT      $-66 (=0x000fa4)   
    };
//000fea 2d6e ffca ffd6           MOVE.L   -54(A6),-42(A6)   
    p_42 = p_54;
//000ff0 2d6e ffe2 ffd2           MOVE.L   -30(A6),-46(A6)   
    p_46 = p_30;
//000ff6 202e ffea                MOVE.L   -22(A6),D0   
//000ffa c0fc 000c                MULU     #12,D0   
//000ffe 206e ff8a                MOVE.L   -118(A6),A0   
//001002 d1c0                     ADD.L    D0,A0   
//001004 2028 0008                MOVE.L   8(A0),D0   
//001008 2d40 fff2                MOVE.L   D0,-14(A6)   
    i_14 = LE32(pSegDesc[Segment17].Length);
//00100c 202e ffea                MOVE.L   -22(A6),D0   
//001010 c0fc 000c                MULU     #12,D0   
//001014 206e ff8a                MOVE.L   -118(A6),A0   
//001018 d1c0                     ADD.L    D0,A0   
//00101a 2028 0004                MOVE.L   4(A0),D0   
    D0L = LE32(pSegDesc[Segment17].Offset);
//00101e 2f00                     MOVE.L   D0,-(A7)   
//001020 206e 0008                MOVE.L   8(A6),A0   
//001024 2f28 0010                MOVE.L   16(A0),-(A7)   
//001028 206e 0008                MOVE.L   8(A6),A0   
//00102c 2068 0008                MOVE.L   8(A0),A0   
//001030 4e90                     JSR      (A0)   
//001032 508f                     ADDQ.L   #0,A7   
    s148->seek(s148->handle, D0L); //Go to segment 17
//001034 2f2e ffd6                MOVE.L   -42(A6),-(A7)   
//001038 2f2e fff2                MOVE.L   -14(A6),-(A7)   
//00103c 206e 0008                MOVE.L   8(A6),A0   
//001040 2f28 0010                MOVE.L   16(A0),-(A7)   
//001044 206e 0008                MOVE.L   8(A6),A0   
//001048 2068 000c                MOVE.L   12(A0),A0   
//00104c 4e90                     JSR      (A0)   
//00104e defc 000c                ADD.W    #12,A7   
    s148->read(s148->handle, i_14, p_42);
//001052 202e fff2                MOVE.L   -14(A6),D0   
//001056 2f00                     MOVE.L   D0,-(A7)   
//001058 2f2e ffd6                MOVE.L   -42(A6),-(A7)   
//00105c 4eba 02cc                JSR      $+718 (=0x00132a)   
//001060 508f                     ADDQ.L   #0,A7   
//001062 3d40 fffe                MOVE.W   D0,-2(A6)   
    w_2 = TAG00132a(p_42, i_14);
//001066 302e fffe                MOVE.W   -2(A6),D0   
//00106a b06e ffb4                CMP.W    -76(A6),D0   
//00106e 6700 001a                BEQ      $+28 (=0x00108a)   
    if (w_2 != littleEndian(wordGear(b_114+38)))
    {
//001072 3f3c 0010                MOVE.W   #16,-(A7)   
//001076 4eba f976                JSR      $-1672 (=0x0009ee)   
//00107a 548f                     ADDQ.L   #2,A7   
//00107c 3e00                     MOVE.W   D0,D7   
      D7W = TAG0009ee(16);
//00107e 0c40 0000                CMP.W    #0,D0   
//001082 6700 0006                BEQ      $+8 (=0x00108a)   
//001086 6000 0176                BRA      $+376 (=0x0011fe)   
      if (D7W != 0) break;
    };
//00108a 202e ffd6                MOVE.L   -42(A6),D0   
//00108e 2040                     MOVE.L   D0,A0   
//001090 2d68 0002 fffa           MOVE.L   2(A0),-6(A6)   
    i_6 = LE32(longGear(p_42 + 2));
//001096 202e ffd6                MOVE.L   -42(A6),D0   
//00109a 2040                     MOVE.L   D0,A0   
//00109c 2d68 0006 fff6           MOVE.L   6(A0),-10(A6)   
    i_10 = LE32(longGear(p_42 + 6));
//0010a2 06ae 0000 000a ffd6      ADD.L    #10,-42(A6)   
    p_42 += 10;
//0010aa 6000 0050                BRA      $+82 (=0x0010fc)   
    while (i_6 > 0)
    {
//0010ae 2e2e ffd6                MOVE.L   -42(A6),D7   
//0010b2 2047                     MOVE.L   D7,A0   
//0010b4 3e10                     MOVE.W   (A0),D7   
      D7W = littleEndian(wordGear(p_42));
//0010b6 202e ffd2                MOVE.L   -46(A6),D0   
//0010ba 2040                     MOVE.L   D0,A0   
//0010bc 3087                     MOVE.W   D7,(A0)   
      wordGear(p_46) = littleEndian(D7W);
//0010be 54ae ffd6                ADDQ.L   #2,-42(A6)   
      p_42 += 2;
//0010c2 55ae fffa                SUBQ.L   #2,-6(A6)   
      i_6 -= 2;
//0010c6 54ae ffd2                ADDQ.L   #2,-46(A6)   
      p_46 += 2;
//0010ca 0c47 0000                CMP.W    #0,D7   
//0010ce 6600 002c                BNE      $+46 (=0x0010fc)   
      if (D7W == 0)
      {
//0010d2 2e2e ffd6                MOVE.L   -42(A6),D7   
//0010d6 2047                     MOVE.L   D7,A0   
//0010d8 3e10                     MOVE.W   (A0),D7   
        D7W = littleEndian(wordGear(p_42));
//0010da 54ae ffd6                ADDQ.L   #2,-42(A6)   
        p_42 += 2;
//0010de 55ae fffa                SUBQ.L   #2,-6(A6)   
        i_6 -= 2;
//0010e2 6000 0010                BRA      $+18 (=0x0010f4)   
        while (D7W > 0)
        {
//0010e6 202e ffd2                MOVE.L   -46(A6),D0   
//0010ea 2040                     MOVE.L   D0,A0   
//0010ec 4210                     CLR.B    (A0)   
          *p_46 = 0;
//0010ee 52ae ffd2                ADDQ.L   #1,-46(A6)   
          p_46 += 1;
//0010f2 5347                     SUBQ.W   #1,D7   
          D7W--;
//
//0010f4 0c47 0000                CMP.W    #0,D7   
//0010f8 6200 ffec                BHI      $-18 (=0x0010e6)   
        };
      };
//
//0010fc 0cae 0000 0000 fffa      CMP.L    #0,-6(A6)   
//001104 6200 ffa8                BHI      $-86 (=0x0010ae)   
    };
//001108 6000 0026                BRA      $+40 (=0x001130)   
    while (i_10 > 0)
    {
//00110c 222e ffde                MOVE.L   -34(A6),D1   
//001110 202e ffde                MOVE.L   -34(A6),D0   
//001114 242e ffd6                MOVE.L   -42(A6),D2   
//001118 2042                     MOVE.L   D2,A0   
//00111a 3610                     MOVE.W   (A0),D3   
      D3W = littleEndian(wordGear(p_42));
//00111c 48c3                     EXT.L    D3   
      D3L = D3W;
//00111e d083                     ADD.L    D3,D0   
//001120 2040                     MOVE.L   D0,A0   
      A0 = p_34 + D3L;
//001122 2010                     MOVE.L   (A0),D0   
      D0L = LE32(longGear(A0));
//001124 d081                     ADD.L    D1,D0   
//001126 2080                     MOVE.L   D0,(A0)   
      longGear(A0) = LE32((i32)p_34 + D0L);
//001128 54ae ffd6                ADDQ.L   #2,-42(A6)   
      p_42 += 2;
//00112c 55ae fff6                SUBQ.L   #2,-10(A6)   
      i_10 -= 2;
//
//001130 0cae 0000 0000 fff6      CMP.L    #0,-10(A6)   
//001138 6200 ffd2                BHI      $-44 (=0x00110c)   
    };
//00113c 2d6e ffda ffd6           MOVE.L   -38(A6),-42(A6)   
    p_42 = p_38;
//001142 202e ffe6                MOVE.L   -26(A6),D0   
//001146 c0fc 000c                MULU     #12,D0   
//00114a 206e ff8a                MOVE.L   -118(A6),A0   
//00114e d1c0                     ADD.L    D0,A0   
//001150 2028 0008                MOVE.L   8(A0),D0   
//001154 2d40 fff2                MOVE.L   D0,-14(A6)   
    i_14 = LE32(pSegDesc[Segment18].Length);
//001158 202e ffe6                MOVE.L   -26(A6),D0   
//00115c c0fc 000c                MULU     #12,D0   
//001160 206e ff8a                MOVE.L   -118(A6),A0   
//001164 d1c0                     ADD.L    D0,A0   
//001166 2028 0004                MOVE.L   4(A0),D0   
    D0L = LE32(pSegDesc[Segment18].Offset);
//00116a 2f00                     MOVE.L   D0,-(A7)   
//00116c 206e 0008                MOVE.L   8(A6),A0   
//001170 2f28 0010                MOVE.L   16(A0),-(A7)   
//001174 206e 0008                MOVE.L   8(A6),A0   
//001178 2068 0008                MOVE.L   8(A0),A0   
//00117c 4e90                     JSR      (A0)   
//00117e 508f                     ADDQ.L   #0,A7   
    s148->seek(s148->handle, D0L);
//001180 2f2e ffd6                MOVE.L   -42(A6),-(A7)   
//001184 2f2e fff2                MOVE.L   -14(A6),-(A7)   
//001188 206e 0008                MOVE.L   8(A6),A0   
//00118c 2f28 0010                MOVE.L   16(A0),-(A7)   
//001190 206e 0008                MOVE.L   8(A6),A0   
//001194 2068 000c                MOVE.L   12(A0),A0   
//001198 4e90                     JSR      (A0)   
//00119a defc 000c                ADD.W    #12,A7   
    s148->read(s148->handle, i_14, p_42);
//00119e 202e fff2                MOVE.L   -14(A6),D0   
//0011a2 2f00                     MOVE.L   D0,-(A7)   
//0011a4 2f2e ffd6                MOVE.L   -42(A6),-(A7)   
//0011a8 4eba 0180                JSR      $+386 (=0x00132a)   
//0011ac 508f                     ADDQ.L   #0,A7   
//0011ae 3d40 fffe                MOVE.W   D0,-2(A6)   
    w_2 = TAG00132a(p_42, i_14);
//0011b2 302e fffe                MOVE.W   -2(A6),D0   
//0011b6 b06e ffb2                CMP.W    -78(A6),D0   
//0011ba 6000 001a                BRA      $+28 (=0x0011d6)   
//
//0011be 3f3c 0011                MOVE.W   #17,-(A7)   
//0011c2 4eba f82a                JSR      $-2004 (=0x0009ee)   
//0011c6 548f                     ADDQ.L   #2,A7   
//0011c8 3e00                     MOVE.W   D0,D7   
//0011ca 0c40 0000                CMP.W    #0,D0   
//0011ce 6700 0006                BEQ      $+8 (=0x0011d6)   
//0011d2 6000 002a                BRA      $+44 (=0x0011fe)   
//0011d6 206e 0008                MOVE.L   8(A6),A0   
//0011da 216e ffde 0018           MOVE.L   -34(A6),24(A0)   
    s148->p_24 = p_34;
//0011e0 202e ffde                MOVE.L   -34(A6),D0   
//0011e4 d0ae ff9a                ADD.L    -102(A6),D0   
//0011e8 5480                     ADDQ.L   #2,D0   
//0011ea 206e 0008                MOVE.L   8(A6),A0   
//0011ee 2140 001c                MOVE.L   D0,28(A0)   
    s148->pJumpTable = p_34 + LE32(longGear(b_114+12)) + 2;
//0011f2 206e 0008                MOVE.L   8(A6),A0   
//0011f6 216e ff9e 0014           MOVE.L   -98(A6),20(A0)   
    s148->i_20 = LE32(longGear(b_114+16));
//0011fc 4247                     CLR.W    D7   
    D7W = 0;
    break;
  } //for (;;);//See comment at top of loop
//0011fe 0cae 0000 0000 ff8a      CMP.L    #0,-118(A6)   
//001206 6700 0014                BEQ      $+22 (=0x00121c)   
//00120a 202e ff8a                MOVE.L   -118(A6),D0   
//00120e 2f00                     MOVE.L   D0,-(A7)   
//001210 206e 0008                MOVE.L   8(A6),A0   
//001214 2068 0004                MOVE.L   4(A0),A0   
//001218 4e90                     JSR      (A0)   
//00121a 588f                     ADDQ.L   #4,A7   
  if (pSegDesc != NULL) s148->free((i8 *)pSegDesc);
 
//00121c 0cae 0000 0000 ffce      CMP.L    #0,-50(A6)   
//001224 6700 0014                BEQ      $+22 (=0x00123a)   
//001228 202e ffce                MOVE.L   -50(A6),D0   
//00122c 2f00                     MOVE.L   D0,-(A7)   
//00122e 206e 0008                MOVE.L   8(A6),A0   
//001232 2068 0004                MOVE.L   4(A0),A0   
//001236 4e90                     JSR      (A0)   
//001238 588f                     ADDQ.L   #4,A7   
  if (p_50 != NULL) s148->free(p_50);
//00123a 0c47 0000                CMP.W    #0,D7   
//00123e 6700 0030                BEQ      $+50 (=0x001270)   
//001242 206e 0008                MOVE.L   8(A6),A0   
//001246 0ca8 0000 0000 0024      CMP.L    #0,36(A0)   
//00124e 6700 0020                BEQ      $+34 (=0x001270)   
  if ( (D7W != 0) && (s148->p_36 != NULL) )
  {
//001252 206e 0008                MOVE.L   8(A6),A0   
//001256 2028 0024                MOVE.L   36(A0),D0   
//00125a 2f00                     MOVE.L   D0,-(A7)   
//00125c 206e 0008                MOVE.L   8(A6),A0   
//001260 2068 0004                MOVE.L   4(A0),A0   
//001264 4e90                     JSR      (A0)   
//001266 588f                     ADDQ.L   #4,A7   
    s148->free(s148->p_36);
//001268 206e 0008                MOVE.L   8(A6),A0   
//00126c 42a8 0024                CLR.L    36(A0)   
    s148->p_36 = NULL;
  };
//001270 3007                     MOVE.W   D7,D0   
//001272 6000 0002                BRA      $+4 (=0x001276)   
//001276 3e1f                     MOVE.W   (A7)+,D7   
//001278 4e5e                     UNLK     A6   
//00127a 4e75                     RTS         
  return D7W;
}

//*********************************************************
//
//*********************************************************
//  TAG00127c
i16 CheckSum(i8 *P1, i8 *P2)
{
  ui8 *ubA3;
  dReg D0, D5, D6, D7;
//00127c 4e56 0000                LINK     A6,#0   
//001280 48e7 0710                MOVEM.L  D567A3,-(A7)   
//001284 4246                     CLR.W    D6   
  D6W = 0;
//001286 202e 0008                MOVE.L   8(A6),D0   
//00128a 2640                     MOVE.L   D0,A3   
  ubA3 = (ui8 *)P1;
//00128c 3e3c 0004                MOVE.W   #4,D7   
//001290 6000 0014                BRA      $+22 (=0x0012a6)   
  for (D7W=4; D7W<20; D7W++)  
  {
//001294 3007                     MOVE.W   D7,D0   
//001296 204b                     MOVE.L   A3,A0   
//001298 d0c0                     ADD.W    D0,A0   
//00129a 1010                     MOVE.B   (A0),D0   
    D6W = sw(D6W + D7W * ubA3[D7W]);
//00129c c07c 00ff                AND.W    #255,D0   
//0012a0 c0c7                     MULU     D7,D0   
//0012a2 dc40                     ADD.W    D0,D6   
//
//0012a4 5247                     ADDQ.W   #1,D7   
//
//0012a6 0c47 0014                CMP.W    #20,D7   
//0012aa 6500 ffe8                BCS      $-22 (=0x001294)   
  };
//0012ae 202e 000c                MOVE.L   12(A6),D0   
//0012b2 2640                     MOVE.L   D0,A3   
  ubA3 = (ui8 *)P2;
//0012b4 206e 0008                MOVE.L   8(A6),A0   
//0012b8 3a28 0012                MOVE.W   18(A0),D5   
//0012bc cafc 000c                MULU     #12,D5   
  D5L = 12 * (UI16)(littleEndian(wordGear(P1+18)));
//0012c0 4247                     CLR.W    D7   
//0012c2 6000 001c                BRA      $+30 (=0x0012e0)   
  for (D7W = 0; D7W<D5W; D7W++)
  {
//0012c6 3007                     MOVE.W   D7,D0   
//0012c8 204b                     MOVE.L   A3,A0   
//0012ca d0c0                     ADD.W    D0,A0   
//0012cc 1010                     MOVE.B   (A0),D0   
    D0W = ubA3[D7W];
//0012ce 3207                     MOVE.W   D7,D1   
//0012d0 c27c 00ff                AND.W    #255,D1   
//0012d4 5241                     ADDQ.W   #1,D1   
//0012d6 c07c 00ff                AND.W    #255,D0   
//0012da c0c1                     MULU     D1,D0   
//0012dc dc40                     ADD.W    D0,D6   
    D6W = sw(D6W + D0W * ((D7W&255)+1));
//
//0012de 5247                     ADDQ.W   #1,D7   
//
//0012e0 3007                     MOVE.W   D7,D0   
//0012e2 b045                     CMP.W    D5,D0   
//0012e4 6500 ffe0                BCS      $-30 (=0x0012c6)   
  };
//0012e8 3006                     MOVE.W   D6,D0   
//0012ea 6000 0002                BRA      $+4 (=0x0012ee)   
//0012ee 4cdf 08e0                MOVEM.L  (A7)+,D567A3   
//0012f2 4e5e                     UNLK     A6   
//0012f4 4e75                     RTS         
  return D6W;
}

//*********************************************************
//
//*********************************************************
i16 TAG0012f6(i8 *P1, i32 size)
{
  dReg D6, D7;
  ui16 *uwA3;
//0012f6 4e56 0000                LINK     A6,#0   
//0012fa 48e7 0310                MOVEM.L  D67A3,-(A7)   
//0012fe 266e 0008                MOVE.L   8(A6),A3   
  uwA3 = (ui16 *)P1;
//001302 2e2e 000c                MOVE.L   12(A6),D7   
//001306 4246                     CLR.W    D6   
//001308 6000 0008                BRA      $+10 (=0x001312)   
  for (D7W=sw(size), D6W=0; D7W>0; D7W-=2)
  {
//00130c dc53                     ADD.W    (A3),D6   
    D6W = (UI16)(D6W + littleEndian(*(uwA3++)));
//00130e 548b                     ADDQ.L   #2,A3   
//001310 5587                     SUBQ.L   #2,D7   
//
//001312 0c87 0000 0000           CMP.L    #0,D7   
//001318 6e00 fff2                BGT      $-12 (=0x00130c)   
  };
//00131c 3006                     MOVE.W   D6,D0   
  return D6W;
//00131e 6000 0002                BRA      $+4 (=0x001322)   
//001322 4cdf 08c0                MOVEM.L  (A7)+,D67A3   
//001326 4e5e                     UNLK     A6   
//001328 4e75                     RTS         
}

//*********************************************************
//
//*********************************************************
i16 TAG00132a(i8 *P1,i32 size)
{
  dReg D6, D7;
  ui8 *ubA3;
//00132a 4e56 0000                LINK     A6,#0   
//00132e 48e7 0310                MOVEM.L  D67A3,-(A7)   
//001332 266e 0008                MOVE.L   8(A6),A3   
  ubA3 = (ui8 *)P1;
//001336 2e2e 000c                MOVE.L   12(A6),D7   
//00133a 4246                     CLR.W    D6   
//00133c 6000 000e                BRA      $+16 (=0x00134c)   
  for (D6W=0, D7L=size; D7L>0; D7L--)
  {
//001340 1013                     MOVE.B   (A3),D0   
//001342 c07c 00ff                AND.W    #255,D0   
//001346 dc40                     ADD.W    D0,D6   
    D6W = (UI16)(D6W + *(ubA3++));
//001348 528b                     ADDQ.L   #1,A3   
//
//00134a 5387                     SUBQ.L   #1,D7   
//
//00134c 0c87 0000 0000           CMP.L    #0,D7   
//001352 6e00 ffec                BGT      $-18 (=0x001340)   
  };
//001356 3006                     MOVE.W   D6,D0   
//001358 6000 0002                BRA      $+4 (=0x00135c)   
  return D6W;
//00135c 4cdf 08c0                MOVEM.L  (A7)+,D67A3   
//001360 4e5e                     UNLK     A6   
//001362 4e75                     RTS         
}

//*********************************************************
//
//*********************************************************
i16 TAG00183c(i16 handle)
{
//00183c 4e56 0000                LINK     A6,#0   
//001840 3f2e 0008                MOVE.W   8(A6),-(A7)   
//001844 4eba 033c                JSR      $+830 (=0x001b82)   
//001848 548f                     ADDQ.L   #2,A7   
  TAG001b82(handle);
//00184a 0c6e 8300 0008           CMP.W    #33536,8(A6)   
//001850 6e06                     BGT      $+8 (=0x001858)   
  if (handle <= 0x8300)
  {
//001852 303c 0000                MOVE.W   #0,D0   
//001856 601e                     BRA      $+32 (=0x001876)   
    return 0;
  };
//001858 3f2e 0008                MOVE.W   8(A6),-(A7)   
//00185c 3f3c 003e                MOVE.W   #62,-(A7)   
//001860 4eba ef48                JSR      $-4278 (=0x0007aa)   
//001864 588f                     ADDQ.L   #4,A7   
//001866 3940 f8dc                MOVE.W   D0,-1828(A4)   
  b.uWord1828 = CLOSE(handle);
//00186a 6706                     BEQ      $+8 (=0x001872)   
  if (b.uWord1828 != 0)
  {
//00186c 303c ffff                MOVE.W   #65535,D0   
    return -1;
//001870 6004                     BRA      $+6 (=0x001876)   
  }
  else
  {
//001872 303c 0000                MOVE.W   #0,D0   
    return 0;
  };
//001876 4e5e                     UNLK     A6   
//001878 4e75                     RTS         
}

//*********************************************************
//
//*********************************************************
void TAG00187a(i32)
{
//00187a 4e56 0000                LINK     A6,#0   
//00187e 3f2e 0008                MOVE.W   8(A6),-(A7)   
//001882 3f3c 004c                MOVE.W   #76,-(A7)   
//001886 4eba ef22                JSR      $-4316 (=0x0007aa)   
//00188a 588f                     ADDQ.L   #4,A7   
  // TRAP 1  -  TERM
  NotImplemented(0x188c);
  throw 0xbad;
//00188c 4e5e                     UNLK     A6   
//00188e 4e75                     RTS         
}

//*********************************************************
//
//*********************************************************
void TAG001890(i32 P1)
{
  ITEM20 *pi20A3;
//001890 4e56 fffe                LINK     A6,#-2   
//001894 2f0b                     MOVE.L   A3,-(A7)   
//001896 41ec f92a                LEA      -1750(A4),A0   
//00189a 2648                     MOVE.L   A0,A3   
//00189c 6016                     BRA      $+24 (=0x0018b4)   
  for (pi20A3 = b.Item20;
       pi20A3 < b.Item20 + 1460/20;
       pi20A3++)
  {
//00189e 302b 000a                MOVE.W   10(A3),D0   
//0018a2 c07c 0003                AND.W    #3,D0   
//0018a6 6708                     BEQ      $+10 (=0x0018b0)   
    if ((pi20A3->Word10 & 3) != 0)
    {
//0018a8 2f0b                     MOVE.L   A3,-(A7)   
//0018aa 4eba 002a                JSR      $+44 (=0x0018d6)   
//0018ae 588f                     ADDQ.L   #4,A7   
      TAG0018d6(pi20A3);
    };
//0018b0 d6fc 0014                ADD.W    #20,A3   
//
//0018b4 200b                     MOVE.L   A3,D0   
//0018b6 41ec f92a                LEA      -1750(A4),A0   
//0018ba 2208                     MOVE.L   A0,D1   
//0018bc d2bc 0000 05b4           ADD.L    #1460,D1   
//0018c2 b081                     CMP.L    D1,D0   
//0018c4 6dd8                     BLT      $-38 (=0x00189e)   
  };
//0018c6 3f2e 0008                MOVE.W   8(A6),-(A7)   
//0018ca 4eba ffae                JSR      $-80 (=0x00187a)   
//0018ce 548f                     ADDQ.L   #2,A7   
  TAG00187a(P1);
//0018d0 265f                     MOVE.L   (A7)+,A3   
//0018d2 4e5e                     UNLK     A6   
//0018d4 4e75                     RTS         
}

//*********************************************************
//
//*********************************************************
i16 TAG0018d6(ITEM20 *P1)
{
  dReg D0;
  ITEM20 *i20A3;
//0018d6 4e56 0000                LINK     A6,#0   
//0018da 2f0b                     MOVE.L   A3,-(A7)   
//0018dc 266e 0008                MOVE.L   8(A6),A3   
  i20A3 = P1;
//0018e0 2f0b                     MOVE.L   A3,-(A7)   
//0018e2 4eba 0044                JSR      $+70 (=0x001928)   
//0018e6 588f                     ADDQ.L   #4,A7   
  D0W = TAG001928(i20A3);
//0018e8 4a40                     TST.W    D0   
//0018ea 6706                     BEQ      $+8 (=0x0018f2)   
  if (D0W != 0)
  {
//0018ec 303c ffff                MOVE.W   #65535,D0   
    D0W = -1;
//0018f0 6030                     BRA      $+50 (=0x001922)   
  }
  else
  {
//0018f2 302b 000a                MOVE.W   10(A3),D0   
//0018f6 c07c 0010                AND.W    #16,D0   
//0018fa 670a                     BEQ      $+12 (=0x001906)   
    if (i20A3->Word10 & 16)
    {
//0018fc 2f2b 0006                MOVE.L   6(A3),-(A7)   
//001900 4eba 026a                JSR      $+620 (=0x001b6c)   
//001904 588f                     ADDQ.L   #4,A7   
      TAG001b6c(i20A3->Long6);
    };
//001906 426b 000a                CLR.W    10(A3)   
    i20A3->Word10 = 0;
//00190a 3f2b 000c                MOVE.W   12(A3),-(A7)   
//00190e 4eba ff2c                JSR      $-210 (=0x00183c)   
//001912 548f                     ADDQ.L   #2,A7   
    D0W = TAG00183c(i20A3->Word12);
//001914 4a40                     TST.W    D0   
//001916 6706                     BEQ      $+8 (=0x00191e)   
    if (D0W != 0)
    {
//001918 303c ffff                MOVE.W   #65535,D0   
      D0W = -1;
//00191c 6004                     BRA      $+6 (=0x001922)   
    }
    else
    {
//00191e 303c 0000                MOVE.W   #0,D0   
      D0W = 0;
    };
  };
//001922 265f                     MOVE.L   (A7)+,A3   
//001924 4e5e                     UNLK     A6   
//001926 4e75                     RTS         
  return D0W;
}

//*********************************************************
//
//*********************************************************
i16 TAG001928(ITEM20 *P1)
{
  dReg D0, D7;
  ITEM20 *i20A3;
//001928 4e56 0000                LINK     A6,#0   
//00192c 48e7 0110                MOVEM.L  D7A3,-(A7)   
//001930 266e 0008                MOVE.L   8(A6),A3   
  i20A3 = P1;
//001934 302b 000a                MOVE.W   10(A3),D0   
//001938 c07c 0003                AND.W    #3,D0   
//00193c 6608                     BNE      $+10 (=0x001946)   
  if ((i20A3->Word10 & 3) == 0)
  {
//00193e 303c ffff                MOVE.W   #65535,D0   
    return -1;
//001942 6000 0098                BRA      $+154 (=0x0019dc)   
  }
  else
  {
//001946 2e13                     MOVE.L   (A3),D7   
//001948 9eab 0006                SUB.L    6(A3),D7   
    D7L = i20A3->Long0 - i20A3->Long6;
//00194c 302b 000a                MOVE.W   10(A3),D0   
//001950 c07c 0080                AND.W    #128,D0   
//001954 6756                     BEQ      $+88 (=0x0019ac)   
    if (i20A3->Word10 & 0x80)
    {
//001956 302b 000a                MOVE.W   10(A3),D0   
//00195a c07c 0002                AND.W    #2,D0   
//00195e 6606                     BNE      $+8 (=0x001966)   
      if ((i20A3->Word10 & 2) == 0)
      {
//001960 303c ffff                MOVE.W   #65535,D0   
//001964 6076                     BRA      $+120 (=0x0019dc)   
        return -1;
      };
//001966 302b 000a                MOVE.W   10(A3),D0   
//00196a c07c 0004                AND.W    #4,D0   
//00196e 6710                     BEQ      $+18 (=0x001980)   
      if (i20A3->Word10 & 4)
      {
//001970 3f3c 0002                MOVE.W   #2,-(A7)   
//001974 42a7                     CLR.L    -(A7)   
//001976 3f2b 000c                MOVE.W   12(A3),-(A7)   
//00197a 4eba 00da                JSR      $+220 (=0x001a56)   
//00197e 508f                     ADDQ.L   #0,A7   
        TAG001a56(i20A3->Word12, 0, 2);
      };
//001980 3f07                     MOVE.W   D7,-(A7)   
//001982 2f2b 0006                MOVE.L   6(A3),-(A7)   
//001986 3f2b 000c                MOVE.W   12(A3),-(A7)   
//00198a 4eba 0348                JSR      $+842 (=0x001cd4)   
//00198e 508f                     ADDQ.L   #0,A7 
      NotImplemented(0x1990); // Need longword  
      D0W = TAG001cd4(i20A3->Word12, i20A3->Long6, D7W);
//001990 0c40 ffff                CMP.W    #65535,D0   
//001994 6606                     BNE      $+8 (=0x00199c)   
      if (D0W == -1)
      {
//001996 303c ffff                MOVE.W   #65535,D0   
//00199a 6040                     BRA      $+66 (=0x0019dc)   
        return -1;
      };
//00199c 026b ff7f 000a           AND.W    #65407,10(A3)   
      i20A3->Word10 &= 0xff7f;
//0019a2 3007                     MOVE.W   D7,D0   
//0019a4 48c0                     EXT.L    D0   
//0019a6 d1ab 000e                ADD.L    D0,14(A3)   
      i20A3->Long14 += D7W;
//0019aa 6024                     BRA      $+38 (=0x0019d0)   
    }
    else
    {
//0019ac 0c6b 0000 000c           CMP.W    #0,12(A3)   
//0019b2 6f1c                     BLE      $+30 (=0x0019d0)   
      if (i20A3->Word12 > 0)
      {
//0019b4 3f3c 0001                MOVE.W   #1,-(A7)   
//0019b8 302b 0004                MOVE.W   4(A3),D0   
//0019bc 4440                     NEG.W    D0   
//0019be 48c0                     EXT.L    D0   
//0019c0 2f00                     MOVE.L   D0,-(A7)   
//0019c2 3f2b 000c                MOVE.W   12(A3),-(A7)   
//0019c6 4eba 008e                JSR      $+144 (=0x001a56)   
//0019ca 508f                     ADDQ.L   #0,A7   
//0019cc 2740 000e                MOVE.L   D0,14(A3)   
        i20A3->Long14 = TAG001a56(i20A3->Word12, -i20A3->Word4, 1);
      };
    };
//0019d0 26ab 0006                MOVE.L   6(A3),(A3)   
    i20A3->Long0 = i20A3->Long6;
//0019d4 426b 0004                CLR.W    4(A3)   
    i20A3->Word4 = 0;
//0019d8 303c 0000                MOVE.W   #0,D0   
    return 0;
  };
//0019dc 4cdf 0880                MOVEM.L  (A7)+,D7A3   
//0019e0 4e5e                     UNLK     A6   
//0019e2 4e75                     RTS         
}

//*********************************************************
//
//*********************************************************
i32 TAG001a56(i16,i32,i16)
{
  NotImplemented(0x1a56); return 0;
}

//*********************************************************
//
//*********************************************************
void TAG001b6c(i32)
{
  NotImplemented(0x1b6c);
}

//*********************************************************
//
//*********************************************************
void TAG001b82(i16 P1)
{
  dReg D0;
  i32 i;
//001b82 4e56 fffe                LINK     A6,#-2   
//001b86 426e fffe                CLR.W    -2(A6)   
//001b8a 6026                     BRA      $+40 (=0x001bb2)   
  for (i=0; i<76; i++)
  {
//001b8c 302e fffe                MOVE.W   -2(A6),D0   
//001b90 e580                     ASL.L    #2,D0   
//001b92 41ec f7ac                LEA      -2132(A4),A0   
//001b96 d0c0                     ADD.W    D0,A0   
//001b98 3010                     MOVE.W   (A0),D0   
    D0W = b.Word2132[2*i];
//001b9a b06e 0008                CMP.W    8(A6),D0   
//001b9e 660e                     BNE      $+16 (=0x001bae)   
    if (D0W == P1)
    {
//001ba0 302e fffe                MOVE.W   -2(A6),D0   
//001ba4 e580                     ASL.L    #2,D0   
//001ba6 41ec f7ac                LEA      -2132(A4),A0   
//001baa d0c0                     ADD.W    D0,A0   
//001bac 4250                     CLR.W    (A0)   
      b.Word2132[2*i] = 0;
    };
//001bae 526e fffe                ADDQ.W   #1,-2(A6)   
//
//001bb2 0c6e 004c fffe           CMP.W    #76,-2(A6)   
//001bb8 6dd2                     BLT      $-44 (=0x001b8c)   
  };
//001bba 4e5e                     UNLK     A6   
//001bbc 4e75                     RTS         
}

//*********************************************************
//
//*********************************************************
i16 TAG001cd4(i16,i32,i16)
{
  NotImplemented(0x1cd4); return 0;
}

//*********************************************************
//
//*********************************************************
void TAG001e5e(void)
{
//001e5e 43ec feee                LEA      -274(A4),A1   
//001e62 12fc 0041                MOVE.B   #65,(A1)+   A
//001e66 12fc 003a                MOVE.B   #58,(A1)+   :
//001e6a 12fc 005c                MOVE.B   #92,(A1)+   \
//001e6e 12fc 0046                MOVE.B   #70,(A1)+   F
//001e72 12fc 0000                MOVE.B   #0,(A1)+   
  strcpy(b.Byte274, "A:\\F");
//001e76 43ec fede                LEA      -290(A4),A1   
//001e7a 12fc 0030                MOVE.B   #48,(A1)+   0
//001e7e 12fc 0031                MOVE.B   #49,(A1)+   1
//001e82 12fc 0032                MOVE.B   #50,(A1)+   2
//001e86 12fc 0033                MOVE.B   #51,(A1)+   3
//001e8a 12fc 0034                MOVE.B   #52,(A1)+   4
//001e8e 12fc 0035                MOVE.B   #53,(A1)+   5
//001e92 12fc 0036                MOVE.B   #54,(A1)+   6
//001e96 12fc 0037                MOVE.B   #55,(A1)+   7
//001e9a 12fc 0038                MOVE.B   #56,(A1)+   8
//001e9e 12fc 0039                MOVE.B   #57,(A1)+   9
//001ea2 12fc 0041                MOVE.B   #65,(A1)+   A
//001ea6 12fc 0042                MOVE.B   #66,(A1)+   B
//001eaa 12fc 0043                MOVE.B   #67,(A1)+   C
//001eae 12fc 0044                MOVE.B   #68,(A1)+   D
//001eb2 12fc 0045                MOVE.B   #69,(A1)+   E
//001eb6 12fc 0046                MOVE.B   #70,(A1)+   F
  memcpy(b.Byte290, "0123456789ABCDEF", 16);
//001eba 43ec f92a                LEA      -1750(A4),A1   
//001ebe 22fc 0000 0000           MOVE.L   #0,(A1)+   ;0=Long
  b.Item20[0].Long0 = 0;
//001ec4 32fc 0000                MOVE.W   #0,(A1)+   ;2=word
  b.Item20[0].Word4 = 0;
//001ec8 22fc 0000 0000           MOVE.L   #0,(A1)+   ;3=Long
  b.Item20[0].Long6 = 0;
//001ece 32fc 0009                MOVE.W   #9,(A1)+   ;5=word
  b.Item20[0].Word10 = 9;
//001ed2 32fc 8300                MOVE.W   #33536,(A1)+  ;6=word
  b.Item20[0].Word12 = (ui16)0x8300;
//001ed6 22fc 0000 0000           MOVE.L   #0,(A1)+   ;7=Long
  b.Item20[0].Long14 = 0;
//001edc 32fc 0000                MOVE.W   #0,(A1)+   ;9=word
  b.Item20[0].Word18 = 0;
//001ee0 22fc 0000 0000           MOVE.L   #0,(A1)+   ;0=Long
  b.Item20[1].Long0 = 0;
//001ee6 32fc 0000                MOVE.W   #0,(A1)+   ;2=word
  b.Item20[1].Word4 = 0;
//001eea 22fc 0000 0000           MOVE.L   #0,(A1)+   ;3=Long
  b.Item20[1].Long6 = 0;
//001ef0 32fc 0102                MOVE.W   #258,(A1)+  ;5=word 
  b.Item20[1].Word10 = 258;
//001ef4 32fc 8300                MOVE.W   #33536,(A1)+   ;6=word
  b.Item20[1].Word12 = (ui16)0x8300;
//001ef8 22fc 0000 0000           MOVE.L   #0,(A1)+   ;7=Long
  b.Item20[1].Long14 = 0;
//001efe 32fc 0200                MOVE.W   #512,(A1)+   9=word
  b.Item20[1].Word18 = 0x200;
//001f02 22fc 0000 0000           MOVE.L   #0,(A1)+   
  b.Item20[2].Long0 = 0;
//001f08 32fc 0000                MOVE.W   #0,(A1)+   
  b.Item20[2].Word4 = 0;
//001f0c 22fc 0000 0000           MOVE.L   #0,(A1)+   
  b.Item20[2].Long6 = 0;
//001f12 32fc 0102                MOVE.W   #258,(A1)+   
  b.Item20[2].Word10 = 0x102;
//001f16 32fc 8300                MOVE.W   #33536,(A1)+   
  b.Item20[2].Word12 = (ui16)0x8300;
//001f1a 22fc 0000 0000           MOVE.L   #0,(A1)+   
  b.Item20[2].Long14 = 0;
//001f20 32fc 0200                MOVE.W   #512,(A1)+   
  b.Item20[2].Word18 = 0x200;
//001f24 d2fc 0578                ADD.W    #1400,A1   
//001f28 397c 0200 f928           MOVE.W   #512,-1752(A4)   
  b.uWord1752 = 0x200;
//001f2e 4e75                     RTS         
}